"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = require("../Button");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var AccordionSection = function AccordionSection(props) {
  var children = props.children,
      className = props.className,
      id = props.id,
      isOpen = props.isOpen,
      summary = props.summary,
      summaryOnClick = props.summaryOnClick,
      rest = _objectWithoutProperties(props, ["children", "className", "id", "isOpen", "summary", "summaryOnClick"]);

  var liClasses = ['slds-accordion__list-item', className];
  var sectionClasses = ['slds-accordion__section', {
    'slds-is-open': isOpen
  }];
  return _react.default.createElement("li", _extends({}, rest, {
    className: (0, _classnames.default)(liClasses),
    key: id
  }), _react.default.createElement("section", {
    className: (0, _classnames.default)(sectionClasses),
    id: id
  }, _react.default.createElement("div", {
    className: "slds-accordion__summary"
  }, _react.default.createElement("h3", {
    className: "slds-accordion__summary-heading"
  }, _react.default.createElement(_Button.Button, {
    sprite: "utility",
    icon: isOpen ? 'chevrondown' : 'chevronright',
    className: "slds-button_reset slds-accordion__summary-action",
    flavor: null,
    "aria-controls": "accordion-details-".concat(id),
    "aria-expanded": isOpen ? 'true' : 'false'
  }, _react.default.createElement("span", {
    className: "slds-truncate",
    title: summary
  }, summary))), _react.default.createElement(_Button.IconButton, {
    sprite: "utility",
    icon: "down",
    "aria-haspopup": "true",
    border: "filled",
    className: "slds-shrink-none",
    onClick: summaryOnClick,
    size: "x-small",
    title: "More Options"
  })), _react.default.createElement("div", {
    hidden: !isOpen ? 'hidden' : null,
    className: "slds-accordion__content",
    id: id
  }, children)));
};

AccordionSection.defaultProps = {
  className: null,
  isOpen: false,
  summaryOnClick: function summaryOnClick() {}
};
AccordionSection.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * section content
   */
  children: _propTypes.default.node.isRequired,

  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * section id
   */
  id: _propTypes.default.string.isRequired,

  /**
   * section is open
   */
  isOpen: _propTypes.default.bool,

  /**
   * section summary
   */
  summary: _propTypes.default.string.isRequired,

  /**
   * function for the button on the right of summary
   */
  summaryOnClick: _propTypes.default.func
} : {};
var _default = AccordionSection;
exports.default = _default;