"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("../../utils");

var _Modal = require("../Modal");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Prompt = function Prompt(props) {
  var children = props.children,
      className = props.className,
      closeButtonLabel = props.closeButtonLabel,
      id = props.id,
      onClose = props.onClose,
      open = props.open,
      theme = props.theme,
      title = props.title,
      rest = _objectWithoutProperties(props, ["children", "className", "closeButtonLabel", "id", "onClose", "open", "theme", "title"]);

  return _react.default.createElement("div", null, _react.default.createElement(_Modal.Modal, _extends({}, rest, {
    className: className,
    id: id,
    open: open,
    onClose: onClose,
    prompt: theme,
    title: title
  }), _react.default.createElement(_Modal.ModalContent, null, children), _react.default.createElement(_Modal.ModalFooter, {
    className: "slds-theme_default",
    closeButtonLabel: closeButtonLabel
  })));
};

Prompt.defaultProps = {
  className: null,
  closeButtonLabel: 'Okay',
  open: false,
  theme: 'error'
};
Prompt.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * prompt content
   */
  children: _propTypes.default.node.isRequired,

  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * Prompt Id
   */
  id: _propTypes.default.string.isRequired,

  /**
   * Close button label
   */
  closeButtonLabel: _propTypes.default.string,

  /**
   * fires when close is clicked or when esc is pressed when the prompt is visible
   */
  onClose: _propTypes.default.func.isRequired,

  /**
   * opens the prompt
   */
  open: _propTypes.default.bool,

  /**
   * slds theme
   */
  theme: _propTypes.default.oneOf(_utils.THEMES),

  /**
   * prompt title
   */
  title: _propTypes.default.string.isRequired
} : {};
var _default = Prompt;
exports.default = _default;