"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Box = function Box(props) {
  var children = props.children,
      className = props.className,
      size = props.size,
      theme = props.theme,
      rest = _objectWithoutProperties(props, ["children", "className", "size", "theme"]);

  var sldsClasses = ['slds-box', _defineProperty({}, "slds-box_".concat(size), !!size)].concat(_toConsumableArray((0, _utils.getThemeClass)(theme)), [className]);
  return _react.default.createElement("div", _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses)
  }), children);
};

Box.defaultProps = {
  className: null,
  size: null,
  theme: null
};
Box.propTypes = process.env.NODE_ENV !== "production" ? {
  /** box content */
  children: _propTypes.default.node.isRequired,

  /** (optional) className */
  className: _propTypes.default.string,

  /** (optional) box size */
  size: _propTypes.default.oneOf(['xx-small', 'x-small', 'small']),

  /*
   * theme
   */
  theme: _propTypes.default.oneOf(_utils.THEMES)
} : {};
var _default = Box;
exports.default = _default;