"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var BrandBand = function BrandBand(props) {
  var className = props.className,
      cover = props.cover,
      noBackground = props.noBackground,
      size = props.size,
      rest = _objectWithoutProperties(props, ["className", "cover", "noBackground", "size"]);

  var baseClass = 'slds-brand-band';
  var sldsClasses = [baseClass, _defineProperty({}, "".concat(baseClass, "_none"), noBackground), _defineProperty({}, "".concat(baseClass, "_cover"), cover), _defineProperty({}, "".concat(baseClass, "_").concat(size), !!size), className];
  return _react.default.createElement("div", _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses)
  }));
};

BrandBand.defaultProps = {
  className: null,
  cover: false,
  noBackground: false,
  size: 'medium'
};
BrandBand.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Optional additional classes
   */
  className: _propTypes.default.string,

  /**
   * Changes background image to be set to cover rather than contain
  */
  cover: _propTypes.default.bool,

  /**
   * Removes image but keeps page background
   */
  noBackground: _propTypes.default.bool,

  /**
   * Sets height of brand band to {size}. Can either be: small, medium, large
   */
  size: _propTypes.default.oneOf(['small', 'medium', 'large'])
} : {};
var _default = BrandBand;
exports.default = _default;