"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = _interopRequireDefault(require("./Button"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var StatefulButton = function StatefulButton(props) {
  var children = props.children,
      className = props.className,
      selected = props.selected,
      rest = _objectWithoutProperties(props, ["children", "className", "selected"]);

  var sldsClasses = (0, _classnames.default)('slds-button_stateful', selected ? 'slds-is-selected' : 'slds-not-selected', className);
  return _react.default.createElement(_Button.default, _extends({}, rest, {
    "aria-live": "assertive",
    className: sldsClasses
  }), children);
};

StatefulButton.defaultProps = {
  className: null,
  selected: false
};
StatefulButton.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Determines which state to render
   */
  selected: _propTypes.default.bool,

  /**
   * `StatefulButtonState` components for: selected, not-selected & focus
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Optional additional className
   */
  className: _propTypes.default.string
} : {};
var _default = StatefulButton;
exports.default = _default;