"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ButtonIcon = _interopRequireDefault(require("./ButtonIcon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var renderStatefulButtonIcon = function renderStatefulButtonIcon(icon, sprite) {
  return _react.default.createElement(_ButtonIcon.default, {
    position: "left",
    icon: icon,
    size: "small",
    sprite: sprite
  });
};

var StatefulButtonState = function StatefulButtonState(props) {
  var className = props.className,
      icon = props.icon,
      sprite = props.sprite,
      state = props.state,
      title = props.title,
      rest = _objectWithoutProperties(props, ["className", "icon", "sprite", "state", "title"]);

  var selectedClass = null;

  switch (state) {
    case 'selected':
      selectedClass = 'slds-text-selected';
      break;

    case 'focus':
      selectedClass = 'slds-text-selected-focus';
      break;

    default:
      selectedClass = 'slds-text-not-selected';
  }

  return _react.default.createElement("span", _extends({}, rest, {
    className: (0, _classnames.default)(selectedClass, className)
  }), renderStatefulButtonIcon(icon, sprite), title);
};

StatefulButtonState.defaultProps = {
  className: null
};
StatefulButtonState.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Button state described by this component. A `StatefulButton` needs all states present
   */
  state: _propTypes.default.oneOf(['selected', 'not-selected', 'focus']).isRequired,

  /**
   * Icon rendered in this state
   */
  icon: _propTypes.default.string.isRequired,

  /**
   * Sprite containing `icon`
   */
  sprite: _propTypes.default.string.isRequired,

  /**
   * Button content for `state`
   */
  title: _propTypes.default.string.isRequired,

  /**
   * Optional additional className
   */
  className: _propTypes.default.string
} : {};
var _default = StatefulButtonState;
exports.default = _default;