"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var ReactIs = _interopRequireWildcard(require("react-is"));

var _classnames = _interopRequireDefault(require("classnames"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ButtonGroup = function ButtonGroup(props) {
  var children = props.children,
      className = props.className,
      list = props.list,
      row = props.row,
      rest = _objectWithoutProperties(props, ["children", "className", "list", "row"]);

  var wrapLi = function wrapLi(parentEl, i) {
    var isFragment = ReactIs.typeOf(parentEl) === ReactIs.Fragment;

    var toLi = function toLi(childEl, index) {
      return _react.default.createElement("li", {
        className: row ? 'slds-button-group-item' : null,
        key: index
      }, childEl);
    };

    return isFragment ? _react.default.Children.map(parentEl.props.children, function (child, j) {
      return toLi(child, "".concat(i, "-").concat(j));
    }) : toLi(parentEl, i);
  };

  var isDivGroup = !list && !row;
  var sldsClasses = (0, _classnames.default)({
    'slds-button-group': isDivGroup
  }, {
    'slds-button-group-list': list
  }, {
    'slds-button-group-row': row
  }, className);
  var ButtonGroupEl = isDivGroup ? 'div' : 'ul';
  var childEls = !isDivGroup ? _react.default.Children.map(children, wrapLi) : children;
  return _react.default.createElement(ButtonGroupEl, _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses),
    role: isDivGroup ? 'group' : null
  }), childEls);
};

ButtonGroup.defaultProps = {
  className: null,
  list: false,
  row: false
};
ButtonGroup.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Any number and combination of button elements
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Optional additional classNames
   */
  className: _propTypes.default.string,

  /**
   * Renders the button group as a list
   */
  list: _propTypes.default.bool,

  /**
   * Renders the button group as a row of separate buttons
   */
  row: _propTypes.default.bool
} : {};
var _default = ButtonGroup;
exports.default = _default;