"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var CheckboxButton = function CheckboxButton(props) {
  var checked = props.checked,
      className = props.className,
      id = props.id,
      label = props.label,
      rest = _objectWithoutProperties(props, ["checked", "className", "id", "label"]);

  var sldsClasses = (0, _classnames.default)('slds-assistive-text', className);
  return _react.default.createElement("div", {
    className: "slds-checkbox_add-button"
  }, _react.default.createElement("input", _extends({}, rest, {
    checked: checked,
    className: (0, _classnames.default)(sldsClasses),
    id: id,
    type: "checkbox",
    value: checked ? 'on' : 'off'
  })), _react.default.createElement("label", {
    className: "slds-checkbox_faux",
    htmlFor: id
  }, _react.default.createElement("span", {
    className: "slds-assistive-text"
  }, label)));
};

CheckboxButton.defaultProps = {
  className: null
};
CheckboxButton.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Checkbox state
   */
  checked: _propTypes.default.bool.isRequired,

  /**
   * `id` of input. Links input and label
   */
  id: _propTypes.default.string.isRequired,

  /**
   * Input label, will be present for screen readers
   */
  label: _propTypes.default.string.isRequired,

  /**
   * Optional additional className
   */
  className: _propTypes.default.string
} : {};
var _default = CheckboxButton;
exports.default = _default;