"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = _interopRequireDefault(require("../Base/Button"));

var _ButtonIcon = _interopRequireDefault(require("../Base/ButtonIcon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var prefix = 'slds-button_icon';

var IconButton = function IconButton(props) {
  var border = props.border,
      children = props.children,
      className = props.className,
      container = props.container,
      flavor = props.flavor,
      icon = props.icon,
      more = props.more,
      size = props.size,
      sprite = props.sprite,
      title = props.title,
      rest = _objectWithoutProperties(props, ["border", "children", "className", "container", "flavor", "icon", "more", "size", "sprite", "title"]);

  var isInverse = flavor === 'inverse';
  /* eslint-disable no-nested-ternary */

  var borderSuffix = isInverse && border ? 'border-inverse' : border === 'filled' ? 'border-filled' : 'border';
  /* eslint-enable */

  var sldsClasses = (0, _classnames.default)(prefix, _defineProperty({}, "".concat(prefix, "-").concat(size), !!size), _defineProperty({}, "".concat(prefix, "-").concat(borderSuffix), !!border), _defineProperty({}, "".concat(prefix, "-container"), container), _defineProperty({}, "".concat(prefix, "-inverse"), isInverse && !border), _defineProperty({}, "".concat(prefix, "-more"), more), _defineProperty({}, "".concat(prefix, "-").concat(flavor), flavor && !isInverse), className);
  var isShortcut = !!icon && !!sprite;
  return _react.default.createElement(_Button.default, _extends({}, rest, {
    className: sldsClasses,
    flavor: null,
    title: title
  }), !isShortcut ? children : _react.default.createElement(_ButtonIcon.default, {
    icon: icon,
    sprite: sprite
  }), more && _react.default.createElement(_ButtonIcon.default, {
    icon: "down",
    size: "x-small",
    sprite: "utility"
  }), title && _react.default.createElement("span", {
    className: "slds-assistive-text"
  }, title));
};

IconButton.defaultProps = {
  border: null,
  children: null,
  className: null,
  container: false,
  icon: null,
  sprite: null,
  more: false,
  flavor: null,
  title: null,
  size: null
};
IconButton.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Shortcut to render a ButtonIcon. Used in combination with `sprite`
   */
  icon: _propTypes.default.string,

  /**
   * Shortcut to render a ButtonIcon. Used in combination with `icon`
   */
  sprite: _propTypes.default.string,

  /**
   * If shortcut does not suffice (e.g. you need more control over ButtonIcon), you can add a ButtonIcon as child
   */
  children: _propTypes.default.node,

  /**
   * Renders a border. Can be `true` to render a transparent border or filled to render a visible border
   */
  border: _propTypes.default.oneOf([true, 'filled']),

  /**
   * Adjust icon sizes. Used to render transparent icons with padding
   */
  container: _propTypes.default.bool,

  /**
   * Optional additional classNames
   */
  className: _propTypes.default.string,

  /**
   * Renders a small down chevron besides the main icon. Used for example in IconButton groups
   */
  more: _propTypes.default.bool,

  /**
   * Can be either `brand`, `error` or `inverse`
   */
  flavor: _propTypes.default.oneOf(['brand', 'error', 'inverse']),

  /**
   * Adjusts icon size. Can be `xx-small`, `x-small` or `small`
   */
  size: _propTypes.default.oneOf(['xx-small', 'x-small', 'small']),

  /**
   * Title for hover and screenreaders
   */
  title: _propTypes.default.string
} : {};
var _default = IconButton;
exports.default = _default;