"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CardHeader = _interopRequireDefault(require("./CardHeader"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Card = function Card(_ref) {
  var Tag = _ref.as,
      boundary = _ref.boundary,
      children = _ref.children,
      className = _ref.className,
      isBoundary = _ref.isBoundary,
      isPadded = _ref.isPadded,
      renderFooter = _ref.renderFooter,
      renderHeader = _ref.renderHeader,
      body = _ref.body,
      footer = _ref.footer,
      headerRight = _ref.headerRight,
      title = _ref.title,
      icon = _ref.icon,
      rest = _objectWithoutProperties(_ref, ["as", "boundary", "children", "className", "isBoundary", "isPadded", "renderFooter", "renderHeader", "body", "footer", "headerRight", "title", "icon"]);

  return _react.default.createElement(Tag, _extends({}, rest, {
    className: (0, _classnames.default)(['slds-card', {
      'slds-card_boundary': isBoundary || boundary
    }, className])
  }), renderHeader ? renderHeader() : title && _react.default.createElement(_CardHeader.default, {
    icon: icon,
    title: title
  }, headerRight), _react.default.createElement("div", {
    className: (0, _classnames.default)(['slds-card__body', {
      'slds-card__body_inner': isPadded
    }])
  }, children || body), renderFooter ? renderFooter() : footer && _react.default.createElement("footer", {
    className: "slds-card__footer"
  }, footer));
};

Card.defaultProps = {
  as: 'article',
  children: null,
  className: null,
  isBoundary: false,
  isPadded: true,
  renderFooter: null,
  renderHeader: null,
  body: null,
  boundary: false,
  footer: null,
  headerRight: null,
  icon: null,
  title: null
};
Card.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Determines the HTML element type that the Card renders as
   */
  as: _propTypes.default.string,

  /**
   * Content
   */
  children: _propTypes.default.node,

  /**
   * Optional classname, applied to top-level tag
   */
  className: _propTypes.default.string,

  /**
   * Should be set to true for the outermost `Card`
   */
  isBoundary: _propTypes.default.bool,

  /**
   * By default, the content receives `medium` padding. Set to `false` to remove this
   */
  isPadded: _propTypes.default.bool,

  /**
   * Render function for the Card footer. Can use `<CardFooter />`
   */
  renderFooter: _propTypes.default.func,

  /**
   * Render function for the Card header. Can use `<CardHeader />`
   */
  renderHeader: _propTypes.default.func,

  /**
   * DEPRECATED: Use `children` instead
   */
  body: _propTypes.default.node,

  /**
   * DEPRECATED: Use `isHeader`  instead
   */
  boundary: _propTypes.default.bool,

  /**
   * DEPRECATED: Use `renderFooter()` instead
   */
  footer: _propTypes.default.node,

  /**
   * DEPRECATED: Set this in `renderHeader()` => `<CardHeader />` instead
   */
  title: _propTypes.default.string,

  /**
   * DEPRECATED: Use `renderHeader()` instead (see example)
   */
  headerRight: _propTypes.default.node,

  /**
   * DEPRECATED: Set this in `renderHeader()` => `<CardHeader />` instead
   */
  icon: _propTypes.default.element
} : {};
var _default = Card;
exports.default = _default;