"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var CardFooter = function CardFooter(_ref) {
  var assistiveText = _ref.assistiveText,
      className = _ref.className,
      linkText = _ref.linkText,
      linkProps = _ref.linkProps,
      rest = _objectWithoutProperties(_ref, ["assistiveText", "className", "linkText", "linkProps"]);

  return _react.default.createElement("footer", _extends({}, rest, {
    className: (0, _classnames.default)(['slds-card__footer', className])
  }), linkText && _react.default.createElement("a", linkProps, linkText, assistiveText && _react.default.createElement("span", {
    className: "slds-assistive-text"
  }, assistiveText)));
};

CardFooter.defaultProps = {
  assistiveText: null,
  className: null,
  linkProps: {},
  linkText: null
};
CardFooter.propTypes = process.env.NODE_ENV !== "production" ? {
  assistiveText: _propTypes.default.string,

  /**
   * Applied to top-level element `slds-card__footer`
   */
  className: _propTypes.default.string,

  /**
   * Props passed to the link `a` tag
   */
  linkProps: _propTypes.default.object,

  /**
   * Link text
   */
  linkText: _propTypes.default.string
} : {};
var _default = CardFooter;
exports.default = _default;