"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Grid = require("../Grid");

var _MediaObject = require("../MediaObject");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var CardHeader = function CardHeader(_ref) {
  var children = _ref.children,
      className = _ref.className,
      icon = _ref.icon,
      titleClassName = _ref.titleClassName,
      titleProps = _ref.titleProps,
      title = _ref.title,
      rest = _objectWithoutProperties(_ref, ["children", "className", "icon", "titleClassName", "titleProps", "title"]);

  var LinkTag = titleProps.href ? 'a' : 'span'; // The LDS sets `.slds-truncate` on the span, that does not work in praxis though

  return _react.default.createElement(_Grid.Grid, _extends({}, rest, {
    className: (0, _classnames.default)(['slds-card__header', className])
  }), _react.default.createElement(_MediaObject.MediaObject, {
    className: "slds-has-flexi-truncate",
    figureLeft: icon
  }, title && _react.default.createElement("h2", {
    className: "slds-card__header-title slds-truncate"
  }, _react.default.createElement(LinkTag, _extends({}, titleProps, {
    className: (0, _classnames.default)(['slds-card__header-link', titleClassName])
  }), _react.default.createElement("span", null, title)))), children && _react.default.createElement("div", {
    className: "slds-no-flex"
  }, children));
};

CardHeader.defaultProps = {
  children: null,
  className: null,
  icon: null,
  titleClassName: null,
  titleProps: {},
  title: null
};
CardHeader.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Renders in the right column
   */
  children: _propTypes.default.node,

  /**
   * Applied to top-level element `slds-card__header`
   */
  className: _propTypes.default.string,

  /**
   * Optional icon, should be `<Icon />`
   */
  icon: _propTypes.default.element,

  /**
   * Applied to `slds-card__header-link`
   */
  titleClassName: _propTypes.default.string,

  /**
   * Props passed to `slds-card__header-link`. If `href` is set, title will render as `a`, else `span`
   */
  titleProps: _propTypes.default.object,

  /**
   * Title text or element
   */
  title: _propTypes.default.node
} : {};
var _default = CardHeader;
exports.default = _default;