"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodashEs = require("lodash-es");

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = require("./utils");

var _ChatListItem = _interopRequireDefault(require("./ChatListItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DEFAULT_TRANSLATIONS = {
  at: 'at',
  resend: 'Resend',
  said: 'said'
};

var Chat = function Chat(_ref) {
  var className = _ref.className,
      isPastChat = _ref.isPastChat,
      items = _ref.items,
      translations = _ref.translations;
  var sectionClassNames = (0, _classnames.default)(['slds-chat', {
    'slds-chat_past': isPastChat
  }, className]);

  var mergedTranslation = _objectSpread({}, DEFAULT_TRANSLATIONS, {}, translations);

  return _react.default.createElement("section", {
    role: "log",
    className: sectionClassNames
  }, _react.default.createElement("ul", {
    className: "slds-chat-list"
  }, items.map(function (item, i) {
    var messageAuthor = item.author,
        id = item.id,
        type = item.type;
    var isConsecutive = false;
    var isFirstMessage = false;

    var _get = (0, _lodashEs.get)(items, [i - 1], {}),
        prevAuthor = _get.author,
        prevIsStart = _get.isStart;

    var _get2 = (0, _lodashEs.get)(items, [i + 1], {}),
        nextAuthor = _get2.author,
        nextType = _get2.type;

    if (!isPastChat && type === nextType && messageAuthor === nextAuthor) {
      isConsecutive = true;
    }

    isFirstMessage = prevIsStart || prevAuthor !== messageAuthor;
    return _react.default.createElement(_ChatListItem.default, _extends({
      isConsecutive: isConsecutive,
      isFirstMessage: isFirstMessage,
      isPastChat: isPastChat,
      key: "chat-list-item-".concat(id),
      translations: mergedTranslation
    }, item));
  })));
};

Chat.defaultProps = {
  className: null,
  isPastChat: false,
  translations: DEFAULT_TRANSLATIONS
};
Chat.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes.default.string,
  isPastChat: _propTypes.default.bool,
  items: _propTypes.default.arrayOf(_propTypes.default.shape({
    author: _propTypes.default.string,
    attachment: _propTypes.default.shape({
      fileType: _propTypes.default.string.isRequired,
      isLink: _propTypes.default.bool,
      src: _propTypes.default.string,
      title: _propTypes.default.string.isRequired
    }),
    avatar: _propTypes.default.string,
    error: _propTypes.default.node,
    id: _propTypes.default.string.isRequired,
    message: _propTypes.default.node,
    meta: _propTypes.default.node,
    onResend: _propTypes.default.func,
    timestamp: _propTypes.default.string,
    type: _propTypes.default.oneOf(Object.values(_utils.CHAT_ITEM_TYPES))
  })).isRequired,
  translations: _propTypes.default.shape({
    at: _propTypes.default.string,
    resend: _propTypes.default.string,
    said: _propTypes.default.string
  })
} : {};
var _default = Chat;
exports.default = _default;