"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ChatListItemMessage = _interopRequireDefault(require("./ChatListItemMessage"));

var _ChatListItemEvent = _interopRequireDefault(require("./ChatListItemEvent"));

var _ChatListItemBookend = _interopRequireDefault(require("./ChatListItemBookend"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ChatListItem = function ChatListItem(props) {
  var isPastChat = props.isPastChat,
      type = props.type;
  var isEnd = type === _utils.CHAT_ITEM_TYPES.EVENT_STOP;
  var isStart = type === _utils.CHAT_ITEM_TYPES.EVENT_START;
  var isBookend = isStart || isEnd;
  var isError = type === _utils.CHAT_ITEM_TYPES.EVENT_ERROR;
  var isEvent = type === _utils.CHAT_ITEM_TYPES.EVENT || isError;

  function getListItemCssClass() {
    if (isBookend) return 'bookend';
    if (isEvent) return 'event';
    if (type === _utils.CHAT_ITEM_TYPES.MESSAGE_OUTBOUND || type === _utils.CHAT_ITEM_TYPES.MESSAGE_DELIVERY_FAILURE || type === _utils.CHAT_ITEM_TYPES.MESSAGE_OUTBOUND_AGENT) return 'outbound';
    return 'inbound';
  }

  var classNamesItem = (0, _classnames.default)(['slds-chat-listitem', _defineProperty({}, "slds-chat-listitem_".concat(getListItemCssClass()), isBookend || !isPastChat)]);
  return _react.default.createElement("li", {
    className: classNamesItem
  }, function () {
    if (isEvent) return _react.default.createElement(_ChatListItemEvent.default, _extends({}, props, {
      isError: isError
    }));
    if (isBookend) return _react.default.createElement(_ChatListItemBookend.default, _extends({}, props, {
      isEnd: isEnd
    }));
    return _react.default.createElement(_ChatListItemMessage.default, props);
  }());
};

ChatListItem.propTypes = process.env.NODE_ENV !== "production" ? {
  isPastChat: _propTypes.default.bool.isRequired,
  type: _propTypes.default.oneOf(Object.values(_utils.CHAT_ITEM_TYPES)).isRequired
} : {};
var _default = ChatListItem;
exports.default = _default;