"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Content = require("./Content");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ChatListItemEvent = function ChatListItemEvent(_ref) {
  var icon = _ref.icon,
      isError = _ref.isError,
      message = _ref.message,
      meta = _ref.meta,
      timestamp = _ref.timestamp;
  var eventClassName = (0, _classnames.default)(['slds-chat-event', {
    'slds-has-error': isError
  }]);
  return _react.default.createElement("div", {
    className: eventClassName
  }, _react.default.createElement("div", {
    className: "slds-chat-event__body"
  }, _react.default.createElement(_Content.EventContent, {
    icon: icon,
    message: message,
    timestamp: timestamp
  })), !isError && meta && _react.default.createElement("div", {
    className: "slds-chat-event__agent-message"
  }, meta));
};

ChatListItemEvent.defaultProps = {
  icon: null,
  meta: null,
  timestamp: null
};
ChatListItemEvent.propTypes = process.env.NODE_ENV !== "production" ? {
  icon: _propTypes.default.string,
  isError: _propTypes.default.bool.isRequired,
  message: _propTypes.default.node.isRequired,
  meta: _propTypes.default.node,
  timestamp: _propTypes.default.string
} : {};
var _default = ChatListItemEvent;
exports.default = _default;