"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Content = require("./Content");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ChatListItemMessage = function ChatListItemMessage(_ref) {
  var author = _ref.author,
      avatar = _ref.avatar,
      isFirstMessage = _ref.isFirstMessage,
      isPastChat = _ref.isPastChat,
      rest = _objectWithoutProperties(_ref, ["author", "avatar", "isFirstMessage", "isPastChat"]);

  var hasAvatar = !!avatar;
  var classNamesMessage = (0, _classnames.default)(['slds-chat-message', {
    'slds-chat-message_faux-avatar': hasAvatar && !isFirstMessage
  }]);
  return _react.default.createElement("div", {
    className: classNamesMessage
  }, !isPastChat && hasAvatar && isFirstMessage && _react.default.createElement("span", {
    "aria-hidden": "true",
    className: "slds-avatar slds-avatar_circle slds-chat-avatar"
  }, _react.default.createElement("abbr", {
    className: "slds-avatar__initials slds-avatar__initials_inverse",
    title: author
  }, avatar)), _react.default.createElement("div", {
    className: "slds-chat-message__body"
  }, _react.default.createElement(_Content.MessageContent, _extends({
    author: author,
    avatar: avatar,
    isPastChat: isPastChat
  }, rest))));
};

ChatListItemMessage.defaultProps = {
  avatar: null
};
ChatListItemMessage.propTypes = process.env.NODE_ENV !== "production" ? {
  author: _propTypes.default.string.isRequired,
  avatar: _propTypes.default.string,
  isFirstMessage: _propTypes.default.bool.isRequired,
  isPastChat: _propTypes.default.bool.isRequired
} : {};
var _default = ChatListItemMessage;
exports.default = _default;