"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EventContent = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = require("prop-types");

var _Icon = require("../../Icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable react/jsx-one-expression-per-line */
var EventContent = function EventContent(_ref) {
  var icon = _ref.icon,
      message = _ref.message,
      timestamp = _ref.timestamp;
  return _react.default.createElement(_react.default.Fragment, null, icon && _react.default.createElement(_Icon.Icon, {
    className: "slds-chat-icon",
    icon: icon,
    size: "x-small",
    sprite: "utility",
    svgClassName: "slds-icon-text-default"
  }), _react.default.createElement("p", null, timestamp ? _react.default.createElement(_react.default.Fragment, null, message, " \u2022 ", timestamp) : message));
};
/* eslint-enable react/jsx-one-expression-per-line */


exports.EventContent = EventContent;
EventContent.defaultProps = {
  icon: null,
  message: null,
  timestamp: null
};
EventContent.propTypes = process.env.NODE_ENV !== "production" ? {
  icon: _propTypes.PropTypes.string,
  message: _propTypes.PropTypes.node,
  timestamp: _propTypes.PropTypes.string
} : {};