"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessageFile = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _File = require("../../File");

var _Icon = require("../../Icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var MessageFile = function MessageFile(_ref) {
  var alt = _ref.alt,
      fileType = _ref.fileType,
      isLink = _ref.isLink,
      src = _ref.src,
      title = _ref.title,
      rest = _objectWithoutProperties(_ref, ["alt", "fileType", "isLink", "src", "title"]);

  return isLink ? _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Icon.Icon, {
    className: "slds-chat-icon",
    icon: "attachment",
    size: "small",
    sprite: "doctype"
  }), _react.default.createElement("a", {
    href: src,
    title: title
  }, title)) : _react.default.createElement("div", {
    style: {
      width: '15rem'
    }
  }, _react.default.createElement(_File.File, _extends({
    fileType: fileType,
    image: src && {
      alt: alt || title,
      src: src
    },
    title: title
  }, rest)));
};

exports.MessageFile = MessageFile;
MessageFile.defaultProps = {
  alt: '',
  isLink: false,
  src: null
};
MessageFile.propTypes = process.env.NODE_ENV !== "production" ? {
  alt: _propTypes.default.string,
  fileType: _propTypes.default.string.isRequired,
  isLink: _propTypes.default.bool,
  src: _propTypes.default.string,
  title: _propTypes.default.string.isRequired
} : {};