"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessageMeta = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = require("../../Button");

var _Grid = require("../../Grid");

var _Icon = require("../../Icon");

var _Meta = require("./Meta");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MessageMeta = function MessageMeta(_ref) {
  var author = _ref.author,
      id = _ref.id,
      isConsecutive = _ref.isConsecutive,
      isDeliveryFailure = _ref.isDeliveryFailure,
      isPastChat = _ref.isPastChat,
      meta = _ref.meta,
      onResend = _ref.onResend,
      timestamp = _ref.timestamp,
      translations = _ref.translations;

  var metaCmp = _react.default.createElement(_Meta.Meta, {
    author: author,
    isPastChat: isPastChat,
    meta: meta,
    timestamp: timestamp,
    translations: translations
  });

  if (isDeliveryFailure) {
    var labelResend = translations.resend;

    var onClick = function onClick() {
      return onResend(id);
    };

    return _react.default.createElement(_Grid.Grid, {
      align: "spread"
    }, metaCmp, _react.default.createElement(_Button.Button, {
      disabled: !onResend,
      className: "slds-chat-message__action slds-m-top_xxx-small",
      flavor: "none",
      onClick: onClick,
      title: labelResend
    }, _react.default.createElement(_Icon.Icon, {
      className: "slds-chat-icon",
      icon: "redo",
      size: "xx-small",
      sprite: "utility"
    }), labelResend));
  }

  return !isConsecutive && metaCmp;
};

exports.MessageMeta = MessageMeta;
MessageMeta.defaultProps = {
  timestamp: null,
  onResend: null
};
MessageMeta.propTypes = process.env.NODE_ENV !== "production" ? {
  author: _propTypes.default.string.isRequired,
  id: _propTypes.default.string.isRequired,
  isConsecutive: _propTypes.default.bool.isRequired,
  isDeliveryFailure: _propTypes.default.bool.isRequired,
  isPastChat: _propTypes.default.bool.isRequired,
  onResend: _propTypes.default.func,
  timestamp: _propTypes.default.string,
  translations: _propTypes.default.shape({
    at: _propTypes.default.string,
    resend: _propTypes.default.string,
    said: _propTypes.default.string
  }).isRequired
} : {};