"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessageStatus = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = require("../../Icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MessageStatus = function MessageStatus(_ref) {
  var isDeliveryFailure = _ref.isDeliveryFailure,
      isUnsupportedType = _ref.isUnsupportedType,
      message = _ref.message;
  var classNamesStatusIcon = (0, _classnames.default)([{
    'slds-icon-text-warning': isUnsupportedType
  }, {
    'slds-icon-text-error': isDeliveryFailure
  }]);
  return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_Icon.Icon, {
    className: "slds-chat-icon",
    icon: isUnsupportedType ? 'warning' : 'error',
    svgClassName: classNamesStatusIcon,
    size: "x-small",
    sprite: "utility"
  }), _react.default.createElement("span", null, message));
};

exports.MessageStatus = MessageStatus;
MessageStatus.propTypes = process.env.NODE_ENV !== "production" ? {
  isDeliveryFailure: _propTypes.default.bool.isRequired,
  isUnsupportedType: _propTypes.default.bool.isRequired,
  message: _propTypes.default.node.isRequired
} : {};