"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Meta = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable react/jsx-one-expression-per-line */
var Meta = function Meta(_ref) {
  var author = _ref.author,
      isPastChat = _ref.isPastChat,
      meta = _ref.meta,
      timestamp = _ref.timestamp,
      _ref$translations = _ref.translations,
      at = _ref$translations.at,
      said = _ref$translations.said;
  return _react.default.createElement("div", {
    className: "slds-chat-message__meta",
    "aria-label": "".concat(said, " ").concat(author, " ").concat(at, " ").concat(timestamp)
  }, meta || _react.default.createElement(_react.default.Fragment, null, isPastChat ? _react.default.createElement("b", null, author) : author, "\u2022 ", timestamp));
};

exports.Meta = Meta;
Meta.defaultProps = {
  author: null,
  meta: null,
  timestamp: null
};
Meta.propTypes = process.env.NODE_ENV !== "production" ? {
  author: _propTypes.default.string,
  isPastChat: _propTypes.default.bool.isRequired,
  meta: _propTypes.default.node,
  timestamp: _propTypes.default.string,
  translations: _propTypes.default.shape({
    at: _propTypes.default.string,
    said: _propTypes.default.string
  }).isRequired
} : {};