"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Form = require("../Form");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var hiddenWhen = function hiddenWhen(hidden) {
  return {
    'slds-assistive-text': hidden
  };
};

var CheckboxToggle = function CheckboxToggle(props) {
  var checked = props.checked,
      disabled = props.disabled,
      hideStatusLabels = props.hideStatusLabels,
      hideLabel = props.hideLabel,
      id = props.id,
      label = props.label,
      _props$statusLabels = props.statusLabels,
      labelUnchecked = _props$statusLabels.unchecked,
      labelChecked = _props$statusLabels.checked,
      rest = _objectWithoutProperties(props, ["checked", "disabled", "hideStatusLabels", "hideLabel", "id", "label", "statusLabels"]);

  var descId = "".concat(id, "-description");
  var statusHidden = hiddenWhen(hideStatusLabels);
  return _react.default.createElement(_Form.FormElement, null, _react.default.createElement("label", {
    className: "slds-checkbox_toggle slds-grid"
  }, _react.default.createElement("span", {
    className: (0, _classnames.default)('slds-form-element__label', 'slds-m-bottom_none', hiddenWhen(hideLabel))
  }, label), _react.default.createElement("input", _extends({
    type: "checkbox",
    checked: checked,
    disabled: disabled,
    id: id,
    "aria-describedby": descId
  }, rest, {
    name: "checkbox",
    value: checked ? 'on' : 'off'
  })), _react.default.createElement("span", {
    id: descId,
    className: "slds-checkbox_faux_container",
    "aria-live": "assertive"
  }, _react.default.createElement("span", {
    className: "slds-checkbox_faux"
  }), _react.default.createElement("span", {
    className: (0, _classnames.default)('slds-checkbox_on', statusHidden)
  }, labelChecked), _react.default.createElement("span", {
    className: (0, _classnames.default)('slds-checkbox_off', statusHidden)
  }, labelUnchecked))));
};

CheckboxToggle.defaultProps = {
  checked: false,
  disabled: false,
  hideLabel: false,
  hideStatusLabels: false,
  statusLabels: {
    unchecked: 'Disabled',
    checked: 'Enabled'
  }
};
CheckboxToggle.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Unique Id
   */
  id: _propTypes.default.string.isRequired,

  /**
   * Checkbox label
   */
  label: _propTypes.default.node.isRequired,

  /**
   * :checked state. Pass `null` for an uncontrolled checkbox
   */
  checked: _propTypes.default.bool,

  /**
   * Disable the checkbox
   */
  disabled: _propTypes.default.bool,

  /**
   * Hides the checkbox label (still visible for screen readers)
   */
  hideLabel: _propTypes.default.bool,

  /**
   * Hide the status labels beneath the checkbox (still visible for screen readers)
   */
  hideStatusLabels: _propTypes.default.bool,

  /**
   * Status labels beneath the checkbox
   */
  statusLabels: _propTypes.default.shape({
    unchecked: _propTypes.default.node.isRequired,
    checked: _propTypes.default.node.isRequired
  })
} : {};
var _default = CheckboxToggle;
exports.default = _default;