"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AutoCompleteCombobox = exports.defaultAutoCompleteComboboxItemRenderer = exports.defaultAutoCompleteComboboxInputRenderer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isEmpty = _interopRequireDefault(require("lodash-es/isEmpty"));

var _isObject = _interopRequireDefault(require("lodash-es/isObject"));

var _ComboboxCore = _interopRequireDefault(require("./components/ComboboxCore"));

var _ComboboxListbox = _interopRequireDefault(require("./components/ComboboxListbox"));

var _DropdownItems = require("./components/DropdownItems");

var _Form = require("../Form");

var _helpers = require("./utils/helpers");

var _constants = require("./utils/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var defaultAutoCompleteComboboxInputRenderer = function defaultAutoCompleteComboboxInputRenderer(inputProps, opts) {
  var onKeyDown = inputProps.onKeyDown,
      value = inputProps.value,
      rest = _objectWithoutProperties(inputProps, ["onKeyDown", "value"]);

  var keyboardSelection = opts.keyboardSelection,
      items = opts.items,
      isMultiSelect = opts.isMultiSelect,
      makeSelectHandler = opts.makeSelectHandler,
      selectedItems = opts.selectedItems;
  var len = selectedItems.length;
  var hasSingleSelection = !isMultiSelect && len === 1;
  var inputValue = value;
  var activeId = null;

  if (hasSingleSelection) {
    var selectedItem = selectedItems[0];
    var id = selectedItem.id,
        label = selectedItem.label;
    inputValue = label;
    activeId = id;
  } else if (!isMultiSelect && len === 0 && !!keyboardSelection) {
    var activeItem = items.find(function (item) {
      return item.id === keyboardSelection;
    });

    if (activeItem) {
      var _id = activeItem.id,
          _label = activeItem.label;
      inputValue = _label;
      activeId = _id;
    }
  }

  return _react.default.createElement(_Form.InputRaw, _extends({}, rest, {
    "aria-activedescendant": !hasSingleSelection && activeId ? activeId : null,
    "aria-autocomplete": "list",
    iconRight: hasSingleSelection ? 'clear' : 'search',
    iconRightOnClick: hasSingleSelection ? makeSelectHandler(activeId) : null,
    onKeyDown: (0, _helpers.makeInputAddHandler)(onKeyDown, opts),
    readOnly: hasSingleSelection,
    value: inputValue
  }));
};

exports.defaultAutoCompleteComboboxInputRenderer = defaultAutoCompleteComboboxInputRenderer;

var defaultAutoCompleteComboboxItemRenderer = function defaultAutoCompleteComboboxItemRenderer(_itemProps, opts) {
  var makeSelectHandler = opts.makeSelectHandler,
      search = opts.search,
      selectedItems = opts.selectedItems;

  var id = _itemProps.id,
      itemProps = _objectWithoutProperties(_itemProps, ["id"]);

  var autocompleteResultProps = _objectSpread({}, itemProps, {
    isMultiSelect: !(0, _isEmpty.default)(selectedItems),
    key: id,
    id: id,
    onSelect: makeSelectHandler(id),
    highlight: search
  });

  return _react.default.createElement(_DropdownItems.BaseDropdownItem, autocompleteResultProps);
};

exports.defaultAutoCompleteComboboxItemRenderer = defaultAutoCompleteComboboxItemRenderer;

var AutoCompleteCombobox =
/*#__PURE__*/
function (_Component) {
  _inherits(AutoCompleteCombobox, _Component);

  function AutoCompleteCombobox() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, AutoCompleteCombobox);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(AutoCompleteCombobox)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "onSearch", function (input) {
      var onSearch = _this.props.onSearch;
      var val = (0, _isObject.default)(input) ? input.target.value : input;
      onSearch(val, {
        isClear: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onSelect", function (id, opts) {
      var _this$props = _this.props,
          onSearch = _this$props.onSearch,
          onSelect = _this$props.onSelect;
      onSelect(id, opts);
      onSearch('', {
        isClear: true
      });
    });

    return _this;
  }

  _createClass(AutoCompleteCombobox, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_ComboboxCore.default, _extends({}, this.props, {
        onSearch: this.onSearch,
        onSelect: this.onSelect
      }));
    }
  }]);

  return AutoCompleteCombobox;
}(_react.Component);

exports.AutoCompleteCombobox = AutoCompleteCombobox;

_defineProperty(AutoCompleteCombobox, "defaultProps", {
  closeOnSelect: true,
  comboboxClassName: null,
  dropdownClassName: null,
  error: null,
  height: 5,
  hideErrorMessage: false,
  hideLabel: false,
  isLoading: false,
  isMultiSelect: false,
  isRequired: false,
  items: [],
  labelListbox: null,
  renderInput: defaultAutoCompleteComboboxInputRenderer,
  renderItem: defaultAutoCompleteComboboxItemRenderer,
  renderItemsAppended: null,
  renderItemsPrepended: null,
  renderListbox: function renderListbox(listboxProps) {
    return _react.default.createElement(_ComboboxListbox.default, listboxProps);
  },
  search: '',
  selectedItems: []
});

AutoCompleteCombobox.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * See `ComboboxCore` or the Storybook stories for more information
   */
  closeOnSelect: _propTypes.default.bool,
  comboboxClassName: _propTypes.default.string,
  dropdownClassName: _propTypes.default.string,
  error: _propTypes.default.string,
  height: _propTypes.default.oneOf([5, 7, 10]),
  hideLabel: _propTypes.default.bool,
  id: _propTypes.default.string.isRequired,
  hideErrorMessage: _propTypes.default.bool,
  isLoading: _propTypes.default.bool,
  isMultiSelect: _propTypes.default.bool,
  isOpen: _propTypes.default.bool.isRequired,
  isRequired: _propTypes.default.bool,
  items: _propTypes.default.arrayOf(_constants.itemType),
  label: _propTypes.default.node.isRequired,
  labelListbox: _propTypes.default.string,
  placeholder: _propTypes.default.string.isRequired,
  onSearch: _propTypes.default.func.isRequired,
  onSelect: _propTypes.default.func.isRequired,
  onToggle: _propTypes.default.func.isRequired,
  renderInput: _propTypes.default.func,
  renderItem: _propTypes.default.func,
  renderItemsAppended: _propTypes.default.func,
  renderItemsPrepended: _propTypes.default.func,
  renderListbox: _propTypes.default.func,
  search: _propTypes.default.string,
  selectedItems: _propTypes.default.arrayOf(_constants.itemType)
} : {};