"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _memoize = _interopRequireDefault(require("lodash-es/memoize"));

var _ClickOutside = require("../../ClickOutside");

var _ComboboxDropdown = _interopRequireDefault(require("./ComboboxDropdown"));

var _ComboboxDropdownLists = _interopRequireDefault(require("./ComboboxDropdownLists"));

var _DropdownItems = require("./DropdownItems");

var _helpers = require("../utils/helpers");

var _constants = require("../utils/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ComboboxCore =
/*#__PURE__*/
function (_Component) {
  _inherits(ComboboxCore, _Component);

  function ComboboxCore(props) {
    var _this;

    _classCallCheck(this, ComboboxCore);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ComboboxCore).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "onToggle", function () {
      var _this$props = _this.props,
          isOpen = _this$props.isOpen,
          onToggle = _this$props.onToggle;
      onToggle(!isOpen);
    });

    _defineProperty(_assertThisInitialized(_this), "onClose", function () {
      var onToggle = _this.props.onToggle;
      onToggle(false);
    });

    _defineProperty(_assertThisInitialized(_this), "onOpen", function () {
      var onToggle = _this.props.onToggle;
      onToggle(true);
    });

    _defineProperty(_assertThisInitialized(_this), "onSelect", function (id, evt) {
      if (evt) {
        evt.preventDefault();
      }

      var _this$props2 = _this.props,
          closeOnSelect = _this$props2.closeOnSelect,
          isMultiSelect = _this$props2.isMultiSelect,
          onSelect = _this$props2.onSelect,
          onToggle = _this$props2.onToggle,
          selectedItems = _this$props2.selectedItems;
      var isRemove = selectedItems.findIndex((0, _helpers.byItemId)(id)) > -1;
      onSelect(id, {
        isAdd: false,
        isRemove: isRemove,
        isReplace: !isRemove && (0, _helpers.isSelectionReplace)({
          isMultiSelect: isMultiSelect,
          selectedItems: selectedItems
        })
      });

      if (closeOnSelect) {
        _this.setState({
          keyboardSelection: null
        });

        onToggle(false);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onInputMouseDown", function (evt) {
      var openOnKeyboardFocus = _this.props.openOnKeyboardFocus;
      var input = evt.target;
      var isFocused = document.activeElement === input;

      if (isFocused) {
        _this.onToggle();
      } else {
        input.focus();
        if (!openOnKeyboardFocus) _this.onOpen();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onInputKeyDown", function (evt) {
      var key = evt.key;
      var _this$props3 = _this.props,
          isMultiSelect = _this$props3.isMultiSelect,
          isOpen = _this$props3.isOpen,
          items = _this$props3.items,
          onSearch = _this$props3.onSearch,
          onToggle = _this$props3.onToggle,
          selectedItems = _this$props3.selectedItems;
      var keyboardSelection = _this.state.keyboardSelection;
      var optionItems = items.filter(function (item) {
        return !item.isHeader;
      });
      var len = optionItems.length;
      var isDelete = key === 'Backspace' || key === 'Delete';
      var isEscape = key === 'Escape';
      var isEnter = key === 'Enter';
      var isDownArrow = key === 'ArrowDown' || key === 'Down';
      var isUpArrow = key === 'ArrowUp' || key === 'Up'; // (1) Open the dropdown when a key is pressed and it's closed

      var isKeyboardOpen = !isOpen && !isUpArrow && !isDelete && !isEscape && key !== 'Tab';

      if (isKeyboardOpen) {
        onToggle(true);
        return true;
      } // (2) Remove selections when encountering delete keys


      if (isDelete) {
        if (keyboardSelection != null) {
          evt.preventDefault();
          var inputVal = evt.target.value;

          if (onSearch) {
            onSearch(inputVal.substring(0, inputVal.length - 1));
          }

          _this.setState({
            keyboardSelection: null
          });
        }

        var isKeyboardRemove = !isMultiSelect && selectedItems.length === 1;
        if (isKeyboardRemove) _this.onSelect(selectedItems[0].id, evt);
        return true;
      } // (3) Finalize keyboard selection when enter is pressed


      var isKeyboardSelect = isOpen && keyboardSelection != null && isEnter;

      if (isKeyboardSelect) {
        evt.preventDefault();

        _this.onSelect(keyboardSelection);

        return true;
      } // (4) Adjust keyboard selection when an arrow is pressed


      var isKeyboardCycle = isOpen && (isDownArrow || isUpArrow) && len > 0;

      if (isKeyboardCycle) {
        evt.preventDefault();

        _this.setState(function (_ref) {
          var prevSelection = _ref.keyboardSelection;
          var prevIndex = prevSelection ? optionItems.findIndex((0, _helpers.byItemId)(prevSelection)) : null;
          var nextIndex = (0, _helpers.getNextIndex)(optionItems, prevIndex, isDownArrow ? 'desc' : 'asc');
          var dropdown = _this.dropdownRef.current; // This works since this mirrors `optionItems`
          // It may be faster to keep a refMap of items and augment the DOM access that way

          var childNodes = dropdown.querySelectorAll('.slds-listbox__option[role="option"]');
          (0, _helpers.scrollDropdown)(dropdown, childNodes[nextIndex]);
          var id = optionItems[nextIndex].id;
          return {
            keyboardSelection: id
          };
        });

        return true;
      }

      return false;
    });

    _defineProperty(_assertThisInitialized(_this), "onInputFocus", function (evt) {
      var _this$props4 = _this.props,
          onToggle = _this$props4.onToggle,
          openOnKeyboardFocus = _this$props4.openOnKeyboardFocus,
          isOpen = _this$props4.isOpen;
      if (openOnKeyboardFocus && evt.isTrusted) onToggle(!isOpen);
    });

    _defineProperty(_assertThisInitialized(_this), "onInputBlur", function (evt) {
      if (evt.isTrusted) _this.onClose();
    });

    _defineProperty(_assertThisInitialized(_this), "renderInput", function () {
      var _this$props5 = _this.props,
          id = _this$props5.id,
          isLoading = _this$props5.isLoading,
          placeholder = _this$props5.placeholder,
          onSearch = _this$props5.onSearch,
          search = _this$props5.search,
          renderInput = _this$props5.renderInput;

      var opts = _this.getOpts();

      var listboxId = "listbox-".concat(id);
      return renderInput({
        'aria-controls': listboxId,
        autoComplete: 'off',
        className: 'slds-combobox__input slds-combobox__input-value',
        id: id,
        showSpinner: isLoading,
        onChange: onSearch,
        onBlur: _this.onInputBlur,
        onFocus: _this.onInputFocus,
        onKeyDown: _this.onInputKeyDown,
        onMouseDown: _this.onInputMouseDown,
        placeholder: placeholder,
        role: 'textbox',
        value: onSearch ? search : undefined
      }, opts);
    });

    _defineProperty(_assertThisInitialized(_this), "renderItem", function (_ref2) {
      var id = _ref2.id,
          rest = _objectWithoutProperties(_ref2, ["id"]);

      var _this$props6 = _this.props,
          renderItem = _this$props6.renderItem,
          selectedItems = _this$props6.selectedItems;
      var keyboardSelection = _this.state.keyboardSelection;

      var opts = _this.getOpts();

      return renderItem(_objectSpread({}, rest, {
        id: id,
        isFocus: id === keyboardSelection,
        isSelected: selectedItems.findIndex((0, _helpers.byItemId)(id)) > -1
      }), opts);
    });

    _defineProperty(_assertThisInitialized(_this), "renderItemsAppended", function () {
      var _this$props7 = _this.props,
          isLoading = _this$props7.isLoading,
          renderItemsAppended = _this$props7.renderItemsAppended;
      if (!isLoading && !renderItemsAppended) return null;
      return _react.default.createElement(_react.default.Fragment, null, renderItemsAppended && renderItemsAppended(), isLoading && _react.default.createElement(_DropdownItems.LoadingIndicatorDropdownItem, null));
    });

    _defineProperty(_assertThisInitialized(_this), "renderListbox", function () {
      var _this$props8 = _this.props,
          isOpen = _this$props8.isOpen,
          labelListbox = _this$props8.labelListbox,
          renderListbox = _this$props8.renderListbox,
          selectedItems = _this$props8.selectedItems;

      var opts = _this.getOpts();

      return renderListbox({
        isOpen: isOpen,
        label: labelListbox,
        makeSelectHandler: _this.makeSelectHandler,
        selectedItems: selectedItems
      }, opts);
    });

    _this.state = {
      keyboardSelection: null
    };
    _this.dropdownRef = _react.default.createRef();
    _this.makeSelectHandler = (0, _memoize.default)(function (key) {
      return function (evt) {
        return _this.onSelect(key, evt);
      };
    });
    return _this;
  }

  _createClass(ComboboxCore, [{
    key: "getOpts",
    value: function getOpts() {
      var _this$props9 = this.props,
          isMultiSelect = _this$props9.isMultiSelect,
          isOpen = _this$props9.isOpen,
          items = _this$props9.items,
          onSearch = _this$props9.onSearch,
          onSelect = _this$props9.onSelect,
          onToggle = _this$props9.onToggle,
          search = _this$props9.search,
          selectedItems = _this$props9.selectedItems;
      var keyboardSelection = this.state.keyboardSelection;
      return {
        isMultiSelect: isMultiSelect,
        isOpen: isOpen,
        items: items,
        keyboardSelection: keyboardSelection,
        onToggle: onToggle,
        rawOnSelect: onSelect,
        search: onSearch ? search : undefined,
        selectedItems: selectedItems,
        makeSelectHandler: this.makeSelectHandler
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props10 = this.props,
          comboboxClassName = _this$props10.comboboxClassName,
          dropdownClassName = _this$props10.dropdownClassName,
          error = _this$props10.error,
          height = _this$props10.height,
          hideErrorMessage = _this$props10.hideErrorMessage,
          hideLabel = _this$props10.hideLabel,
          id = _this$props10.id,
          isInlineListboxSelection = _this$props10.isInlineListboxSelection,
          isLoading = _this$props10.isLoading,
          isMultiSelect = _this$props10.isMultiSelect,
          isOpen = _this$props10.isOpen,
          isRequired = _this$props10.isRequired,
          items = _this$props10.items,
          label = _this$props10.label,
          onLabelClick = _this$props10.onLabelClick,
          renderItemsAppended = _this$props10.renderItemsAppended,
          renderItemsPrepended = _this$props10.renderItemsPrepended,
          renderListbox = _this$props10.renderListbox,
          renderObjectSwitcher = _this$props10.renderObjectSwitcher,
          selectedItems = _this$props10.selectedItems;
      var keyboardSelection = this.state.keyboardSelection;
      return _react.default.createElement(_ClickOutside.ClickOutside, {
        handleEsc: true,
        onClickOutside: this.onClose,
        condition: isOpen
      }, _react.default.createElement(_ComboboxDropdown.default, {
        className: comboboxClassName,
        dropdownClassName: dropdownClassName,
        error: error,
        height: height,
        hideErrorMessage: hideErrorMessage,
        hideLabel: hideLabel,
        id: "combobox-".concat(id),
        isOpen: isOpen,
        isRequired: isRequired,
        isSingleInlineSelection: isInlineListboxSelection && !isMultiSelect && selectedItems.length === 1,
        label: label,
        listboxId: "listbox-".concat(id),
        onLabelClick: onLabelClick,
        ref: this.dropdownRef,
        renderObjectSwitcher: renderObjectSwitcher,
        renderInput: this.renderInput,
        renderListbox: renderListbox && isMultiSelect ? this.renderListbox : null,
        selectionLength: selectedItems.length
      }, _react.default.createElement(_ComboboxDropdownLists.default, {
        isOpen: isOpen,
        items: items,
        renderItem: this.renderItem,
        renderItemsAppended: this.renderItemsAppended,
        renderItemsPrepended: renderItemsPrepended // Passed down to bust `React.memo` caching if necessary
        ,
        isLoading: isLoading,
        keyboardSelection: keyboardSelection,
        renderAppended: renderItemsAppended,
        selectedItems: selectedItems
      })));
    }
  }]);

  return ComboboxCore;
}(_react.Component);

_defineProperty(ComboboxCore, "defaultProps", {
  comboboxClassName: null,
  dropdownClassName: null,
  error: null,
  height: 5,
  hideErrorMessage: false,
  hideLabel: false,
  isInlineListboxSelection: false,
  isRequired: false,
  labelListbox: 'Selected Items',
  onLabelClick: null,
  onSearch: null,
  openOnKeyboardFocus: true,
  renderItemsAppended: null,
  renderItemsPrepended: null,
  renderObjectSwitcher: null,
  search: ''
});

ComboboxCore.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Will close the selection dropdown upon selection when true
   */
  closeOnSelect: _propTypes.default.bool.isRequired,

  /**
   * Classname that will be applied to the <FormElement> wrapping input and listbox
   */
  comboboxClassName: _propTypes.default.string,

  /**
   * Classname that will be applied to the '.slds-dropdown'
   */
  dropdownClassName: _propTypes.default.string,

  /**
   * Error to display under the control
   * Notice: This is a custom addition to LDS Combobox spec!
   */
  error: _propTypes.default.string,

  /**
   * Number of results displayed in the result dropdown
   */
  height: _propTypes.default.oneOf([5, 7, 10]),

  /**
   * Prevent error from being shown
   * Notice: This is a custom addition to LDS Combobox spec!
   */
  hideErrorMessage: _propTypes.default.bool,

  /**
   * Determines whether the label is rendered
   */
  hideLabel: _propTypes.default.bool,

  /**
   * Unique identifier
   */
  id: _propTypes.default.string.isRequired,

  /**
   * Switch to render single selection as `inline` listboxs. Set by `EntityCombobox`
   */
  isInlineListboxSelection: _propTypes.default.bool,

  /**
   * Appends a `loading` spinner to the result items to
   */
  isLoading: _propTypes.default.bool.isRequired,

  /**
   * Defines whether the Combobox allows more than one selection
   */
  isMultiSelect: _propTypes.default.bool.isRequired,

  /**
   * Determines whether the result dropdown is rendered
   */
  isOpen: _propTypes.default.bool.isRequired,

  /**
   * Mark field as required
   * Notice: This is a custom addition to LDS Combobox spec!
   */
  isRequired: _propTypes.default.bool,

  /**
   * Array of items that will be displayed in the selection dropdown
   * `isHeader` items break the dropdown into sublists
   */
  items: _propTypes.default.arrayOf(_constants.itemType).isRequired,

  /**
   * Labels the Combobox
   */
  label: _propTypes.default.node.isRequired,

  /**
   * Assistive label for the Listbox of selected items
   */
  labelListbox: _propTypes.default.string,

  /**
   * Placeholder shown in the Dropdown input when no items are selected yet
   */
  placeholder: _propTypes.default.string.isRequired,

  /**
   * Attaches a click handler to the combobox label
   */
  onLabelClick: _propTypes.default.func,

  /**
   * Callback to update input state
   * Called with (value, { isClear })
   */
  onSearch: _propTypes.default.func,

  /**
   * Callback to update selection state
   * Called with (id, {
   *   isReplace (bool) whether the passed `id` should replace the current selection state
   *   isRemove (bool) whether the passed `id` is deselected
   *   isAdd (bool) whether the passed `id` is an item not present in the Combobox
   * })
   */
  onSelect: _propTypes.default.func.isRequired,

  /**
   * Callback to manage isOpen state
   * Called with (bool) indicating next state
   */
  onToggle: _propTypes.default.func.isRequired,

  /**
   * When false, receiving keyboard focus will not open the selection menu
   */
  openOnKeyboardFocus: _propTypes.default.bool,

  /**
   * Renders the input element
   */
  renderInput: _propTypes.default.func.isRequired,

  /**
   * Renders each non-header `item` in `items`
   */
  renderItem: _propTypes.default.func.isRequired,

  /**
   * Renders a `ComboboxDropdownItem` after the last displayed result
   */
  renderItemsAppended: _propTypes.default.func,

  /**
   * Renders a `ComboboxDropdownItem` after the last displayed result
   */
  renderItemsPrepended: _propTypes.default.func,

  /**
   * Renders beneath Combobox. Used to display a Listbox of Pills in multi-select Comboboxes
   */
  renderListbox: _propTypes.default.func.isRequired,

  /**
   * Render hook to render an additional object switcher combobox
   */
  renderObjectSwitcher: _propTypes.default.func,

  /**
   * Search, will be passed to `opts` for Combobox variants that support input
   */
  search: _propTypes.default.string,

  /**
   * Array of `item`-like shapes that are currently selected
   */
  selectedItems: _propTypes.default.arrayOf(_constants.itemType).isRequired
} : {};
var _default = ComboboxCore;
exports.default = _default;