"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Form = require("../../Form");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ComboboxDropdown = _react.default.forwardRef(function (props, ref) {
  var children = props.children,
      dropdownClassName = props.dropdownClassName,
      error = props.error,
      height = props.height,
      hideErrorMessage = props.hideErrorMessage,
      hideLabel = props.hideLabel,
      id = props.id,
      isOpen = props.isOpen,
      isRequired = props.isRequired,
      isSingleInlineSelection = props.isSingleInlineSelection,
      label = props.label,
      listboxId = props.listboxId,
      onLabelClick = props.onLabelClick,
      renderInput = props.renderInput,
      renderListbox = props.renderListbox,
      renderObjectSwitcher = props.renderObjectSwitcher,
      selectionLength = props.selectionLength,
      rest = _objectWithoutProperties(props, ["children", "dropdownClassName", "error", "height", "hideErrorMessage", "hideLabel", "id", "isOpen", "isRequired", "isSingleInlineSelection", "label", "listboxId", "onLabelClick", "renderInput", "renderListbox", "renderObjectSwitcher", "selectionLength"]);

  var comboboxContainerClasses = ['slds-combobox_container', {
    'slds-has-selection': isSingleInlineSelection
  }, {
    'slds-combobox-addon_end': renderObjectSwitcher
  }];
  var comboboxClasses = ['slds-combobox', 'slds-dropdown-trigger', 'slds-dropdown-trigger_click', {
    'slds-is-open': isOpen
  }];
  var comboboxFormElementClasses = ['slds-combobox__form-element', 'slds-input-has-icon', {
    'slds-input-has-icon_left-right': isSingleInlineSelection
  }, {
    'slds-input-has-icon_right': !isSingleInlineSelection
  }];
  var dropdownClasses = ['slds-dropdown', 'slds-dropdown_fluid', _defineProperty({}, "slds-dropdown_length-with-icon-".concat(height), height), dropdownClassName];

  var comboboxEl = _react.default.createElement("div", {
    className: (0, _classnames.default)(comboboxContainerClasses)
  }, _react.default.createElement("div", {
    className: (0, _classnames.default)(comboboxClasses),
    "aria-expanded": isOpen,
    "aria-haspopup": "listbox",
    role: "combobox"
  }, _react.default.createElement("div", {
    className: (0, _classnames.default)(comboboxFormElementClasses),
    role: "none"
  }, renderInput()), _react.default.createElement("div", {
    className: (0, _classnames.default)(dropdownClasses),
    id: listboxId,
    ref: ref,
    role: "listbox",
    tabIndex: "-1"
  }, children)));

  return _react.default.createElement(_Form.FormElement, _extends({
    error: error,
    required: isRequired
  }, rest), !hideLabel && _react.default.createElement(_Form.FormElementLabel, {
    id: id,
    label: label,
    onClick: onLabelClick,
    required: isRequired
  }), !hideErrorMessage && _react.default.createElement(_Form.FormElementError, {
    error: error,
    id: "error-".concat(id)
  }), _react.default.createElement(_Form.FormElementControl, null, renderObjectSwitcher ? _react.default.createElement(_react.Fragment, null, _react.default.createElement("div", {
    className: (0, _classnames.default)(['slds-combobox-group', {
      'slds-has-selection': selectionLength > 0
    }])
  }, _react.default.createElement("div", {
    className: "slds-combobox_object-switcher slds-combobox-addon_start"
  }, _react.default.createElement("div", {
    className: "slds-form-element"
  }, _react.default.createElement("div", {
    className: "slds-form-element__control"
  }, renderObjectSwitcher()))), comboboxEl), renderListbox && renderListbox()) : _react.default.createElement(_react.Fragment, null, comboboxEl, renderListbox && renderListbox())));
});

ComboboxDropdown.displayName = 'ComboboxDropdown';
ComboboxDropdown.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  dropdownClassName: _propTypes.default.string,
  error: _propTypes.default.string,
  height: _propTypes.default.number.isRequired,
  hideErrorMessage: _propTypes.default.bool,
  hideLabel: _propTypes.default.bool,
  id: _propTypes.default.string.isRequired,
  isOpen: _propTypes.default.bool.isRequired,
  isRequired: _propTypes.default.bool,
  isSingleInlineSelection: _propTypes.default.bool,
  label: _propTypes.default.node.isRequired,
  listboxId: _propTypes.default.string.isRequired,
  onLabelClick: _propTypes.default.func,
  renderInput: _propTypes.default.func.isRequired,
  renderListbox: _propTypes.default.func,
  renderObjectSwitcher: _propTypes.default.func,
  selectionLength: _propTypes.default.number
} : {};
ComboboxDropdown.defaultProps = {
  children: null,
  className: null,
  dropdownClassName: null,
  error: null,
  hideErrorMessage: false,
  hideLabel: false,
  isRequired: false,
  isSingleInlineSelection: false,
  onLabelClick: null,
  renderListbox: null,
  renderObjectSwitcher: null,
  selectionLength: 0
};
var _default = ComboboxDropdown;
exports.default = _default;