"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.RawComboboxDropdownLists = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _DropdownItems = require("./DropdownItems");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RawComboboxDropdownLists = function RawComboboxDropdownLists(_ref) {
  var items = _ref.items,
      isOpen = _ref.isOpen,
      renderItem = _ref.renderItem,
      renderItemsAppended = _ref.renderItemsAppended,
      renderItemsPrepended = _ref.renderItemsPrepended;
  var listClasses = 'slds-listbox slds-listbox_vertical';
  if (!isOpen) return null;

  if (!items.some(function (_ref2) {
    var isHeader = _ref2.isHeader;
    return isHeader;
  })) {
    return _react.default.createElement("ul", {
      className: listClasses
    }, renderItemsPrepended && renderItemsPrepended(), items.map(renderItem), renderItemsAppended && renderItemsAppended());
  }

  var groups = []; // In case first item is not a header, a list without a header will be rendered

  var currentGroup = {
    id: null,
    label: null,
    items: []
  };

  for (var i = 0; i < items.length; i += 1) {
    var current = items[i];

    if (current.isHeader) {
      groups.push(currentGroup);
      var id = current.id,
          label = current.label;
      currentGroup = {
        id: id,
        label: label,
        items: []
      };
    } else {
      currentGroup.items.push(current);
    }

    if (i === items.length - 1) groups.push(currentGroup);
  }

  return groups.map(function (_ref3, index) {
    var id = _ref3.id,
        label = _ref3.label,
        groupItems = _ref3.items;
    return _react.default.createElement("ul", {
      "aria-label": label,
      className: listClasses,
      key: id,
      role: "group"
    }, id && label && _react.default.createElement(_DropdownItems.HeaderDropdownItem, {
      id: id,
      label: label
    }), index === 0 && renderItemsPrepended && renderItemsPrepended(), groupItems.map(renderItem), index === groups.length - 1 && renderItemsAppended && renderItemsAppended());
  });
};

exports.RawComboboxDropdownLists = RawComboboxDropdownLists;
RawComboboxDropdownLists.propTypes = process.env.NODE_ENV !== "production" ? {
  isOpen: _propTypes.default.bool,
  items: _propTypes.default.arrayOf(_propTypes.default.shape({
    id: _propTypes.default.string.isRequired,
    label: _propTypes.default.string.isRequired
  })),
  renderItem: _propTypes.default.func.isRequired,
  renderItemsAppended: _propTypes.default.func,
  renderItemsPrepended: _propTypes.default.func
} : {};
RawComboboxDropdownLists.defaultProps = {
  isOpen: false,
  renderItemsAppended: null,
  renderItemsPrepended: null
};

var _default = _react.default.memo(RawComboboxDropdownLists);

exports.default = _default;