"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Pill = require("../../Pill");

var _Icon = require("../../Icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ComboboxListbox = function ComboboxListbox(_ref) {
  var isOpen = _ref.isOpen,
      label = _ref.label,
      makeSelectHandler = _ref.makeSelectHandler,
      selectedItems = _ref.selectedItems;
  if (isOpen || selectedItems.length === 0) return null;
  return _react.default.createElement("div", null, _react.default.createElement(_Pill.Listbox, {
    label: label
  }, selectedItems.map(function (_ref2) {
    var icon = _ref2.icon,
        id = _ref2.id,
        itemLabel = _ref2.label;
    return _react.default.createElement(_Pill.Pill, {
      key: id,
      icon: icon ? _react.default.createElement(_Icon.Icon, {
        icon: icon.icon,
        sprite: icon.sprite
      }) : null,
      label: itemLabel,
      title: itemLabel,
      onClose: makeSelectHandler(id)
    });
  })));
};

ComboboxListbox.propTypes = process.env.NODE_ENV !== "production" ? {
  isOpen: _propTypes.default.bool.isRequired,
  label: _propTypes.default.string.isRequired,
  makeSelectHandler: _propTypes.default.func.isRequired,
  selectedItems: _propTypes.default.arrayOf(_propTypes.default.shape({
    id: _propTypes.default.string.isRequired,
    label: _propTypes.default.string.isRequired
  })).isRequired
} : {};
var _default = ComboboxListbox;
exports.default = _default;