"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DropdownItemCore = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var DropdownItemCore = function DropdownItemCore(props) {
  var children = props.children,
      className = props.className,
      icon = props.icon,
      id = props.id,
      isDisabled = props.isDisabled,
      isFocus = props.isFocus,
      isHeader = props.isHeader,
      isPresentation = props.isPresentation,
      isSelected = props.isSelected,
      onSelect = props.onSelect,
      rest = _objectWithoutProperties(props, ["children", "className", "icon", "id", "isDisabled", "isFocus", "isHeader", "isPresentation", "isSelected", "onSelect"]);

  var optionClasses = ['slds-media', 'slds-media__small', 'slds-listbox__option', className, {
    'slds-is-selected': isSelected
  }, {
    'slds-has-focus': isFocus
  }];
  return _react.default.createElement("li", _extends({}, rest, {
    className: "slds-listbox__item",
    role: "presentation"
  }), _react.default.createElement("div", {
    "aria-disabled": isDisabled || null,
    id: id,
    className: (0, _classnames.default)(optionClasses),
    onMouseDown: !isDisabled ? onSelect : null,
    role: isHeader || isPresentation ? 'presentation' : 'option'
  }, icon, isHeader ? children : _react.default.createElement("span", {
    className: "slds-media__body"
  }, children)));
};

exports.DropdownItemCore = DropdownItemCore;
DropdownItemCore.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.node.isRequired,
  className: _propTypes.default.string,
  icon: _propTypes.default.node,
  id: _propTypes.default.string,
  isDisabled: _propTypes.default.bool,
  isFocus: _propTypes.default.bool,
  isHeader: _propTypes.default.bool,
  isPresentation: _propTypes.default.bool,
  isSelected: _propTypes.default.bool,
  onSelect: _propTypes.default.func
} : {};
DropdownItemCore.defaultProps = {
  className: null,
  icon: null,
  id: null,
  isDisabled: false,
  isFocus: false,
  isHeader: false,
  isPresentation: false,
  isSelected: false,
  onSelect: null
};