"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EntityDropdownItem = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _DropdownItemCore = require("./DropdownItemCore");

var _Icon = require("../../../Icon");

var _helpers = require("../../utils/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var EntityDropdownItem = function EntityDropdownItem(_ref) {
  var className = _ref.className,
      highlight = _ref.highlight,
      icon = _ref.icon,
      isDisabled = _ref.isDisabled,
      isMultiSelect = _ref.isMultiSelect,
      isSelected = _ref.isSelected,
      isSelectedAssistiveLabel = _ref.isSelectedAssistiveLabel,
      label = _ref.label,
      meta = _ref.meta,
      rest = _objectWithoutProperties(_ref, ["className", "highlight", "icon", "isDisabled", "isMultiSelect", "isSelected", "isSelectedAssistiveLabel", "label", "meta"]);

  var sprite = isSelected ? 'utility' : icon.sprite;
  var isUtilIcon = sprite === 'utility';
  var iconClassNames = (0, _classnames.default)([{
    'slds-icon_disabled': isDisabled
  }, {
    'slds-current-color': isUtilIcon
  }]);

  var iconEl = _react.default.createElement("span", {
    className: "slds-media__figure slds-listbox__option-icon"
  }, _react.default.createElement(_Icon.Icon, {
    className: iconClassNames,
    icon: isSelected ? 'check' : icon.icon,
    sprite: sprite,
    size: isUtilIcon && !isSelected ? 'x-small' : 'small'
  }));

  var itemClasses = ['slds-listbox__option_entity', {
    'slds-listbox__option_has-meta': meta
  }, className];
  return _react.default.createElement(_DropdownItemCore.DropdownItemCore, _extends({}, rest, {
    className: (0, _classnames.default)(itemClasses),
    isDisabled: isDisabled,
    isSelected: isSelected,
    icon: iconEl
  }), _react.default.createElement("span", {
    className: "slds-listbox__option-text slds-listbox__option-text_entity"
  }, isMultiSelect && isSelected && _react.default.createElement("span", {
    className: "slds-assistive-text"
  }, isSelectedAssistiveLabel), highlight.length > 0 ? (0, _helpers.defaultHighlighter)(label, highlight) : label), meta && _react.default.createElement("span", {
    className: "slds-listbox__option-meta slds-listbox__option-meta_entity"
  }, meta));
};

exports.EntityDropdownItem = EntityDropdownItem;
EntityDropdownItem.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes.default.string,
  highlight: _propTypes.default.string,
  icon: _propTypes.default.shape({
    icon: _propTypes.default.string.isRequired,
    sprite: _propTypes.default.string.isRequired
  }).isRequired,
  isDisabled: _propTypes.default.bool,
  isMultiSelect: _propTypes.default.bool,
  isSelected: _propTypes.default.bool,
  isSelectedAssistiveLabel: _propTypes.default.string,
  label: _propTypes.default.string.isRequired,
  meta: _propTypes.default.node
} : {};
EntityDropdownItem.defaultProps = {
  className: null,
  highlight: '',
  isDisabled: false,
  isMultiSelect: false,
  isSelected: false,
  isSelectedAssistiveLabel: 'Current Selection: ',
  meta: null
};