"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = void 0;

var _react = require("react");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _defaultCellRenderer = _interopRequireDefault(require("./defaultCellRenderer"));

var _defaultHeadRenderer = _interopRequireDefault(require("./defaultHeadRenderer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-disable react/no-unused-prop-types */
var propTypes = {
  cellRenderer: _propTypes.default.func,
  headRenderer: _propTypes.default.func,
  dataKey: _propTypes.default.string.isRequired,
  isResizable: _propTypes.default.bool,
  sortable: _propTypes.default.bool,
  title: _propTypes.default.string
}; // eslint-enable

/* eslint-disable react/prefer-stateless-function */

exports.propTypes = propTypes;

var DataTableColumn =
/*#__PURE__*/
function (_Component) {
  _inherits(DataTableColumn, _Component);

  function DataTableColumn() {
    _classCallCheck(this, DataTableColumn);

    return _possibleConstructorReturn(this, _getPrototypeOf(DataTableColumn).apply(this, arguments));
  }

  return DataTableColumn;
}(_react.Component);

_defineProperty(DataTableColumn, "defaultProps", {
  cellRenderer: _defaultCellRenderer.default,
  headRenderer: _defaultHeadRenderer.default,
  isResizable: false,
  sortable: false,
  title: null
});

DataTableColumn.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
var _default = DataTableColumn;
exports.default = _default;