"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = require("../Icon");

var _MediaObject = require("../MediaObject");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FileCaption = function FileCaption(_ref) {
  var fileType = _ref.fileType,
      hasActions = _ref.hasActions,
      title = _ref.title;

  var fileIcon = _react.default.createElement(_Icon.Icon, {
    icon: fileType,
    size: "x-small",
    sprite: "doctype",
    title: fileType
  });

  var captionClasses = ['slds-file__title', 'slds-file__title_card', {
    'slds-file-has-actions': hasActions
  }];
  return _react.default.createElement("figcaption", {
    className: (0, _classnames.default)(captionClasses)
  }, _react.default.createElement(_MediaObject.MediaObject, {
    center: true,
    figureLeft: fileIcon,
    size: "small"
  }, _react.default.createElement("span", {
    className: "slds-file__text slds-truncate",
    title: title
  }, title)));
};

FileCaption.propTypes = process.env.NODE_ENV !== "production" ? {
  fileType: _propTypes.default.string.isRequired,
  hasActions: _propTypes.default.bool.isRequired,
  title: _propTypes.default.string.isRequired
} : {};
var _default = FileCaption;
exports.default = _default;