"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Icon = require("../Icon");

var _Spinner = require("../Spinner");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FileMedia = function FileMedia(_ref) {
  var fileType = _ref.fileType,
      image = _ref.image,
      isLoading = _ref.isLoading,
      title = _ref.title;
  if (isLoading) return _react.default.createElement(_Spinner.Spinner, {
    size: "medium"
  });
  if (image && image.src) return _react.default.createElement("img", {
    src: image.src,
    alt: image.alt || title
  });
  return _react.default.createElement(_Icon.Icon, {
    className: "slds-file__icon",
    sprite: "doctype",
    icon: fileType,
    title: "".concat(title, " : ").concat(fileType)
  });
};

FileMedia.defaultProps = {
  image: null
};
FileMedia.propTypes = process.env.NODE_ENV !== "production" ? {
  fileType: _propTypes.default.string.isRequired,
  image: _propTypes.default.shape({
    alt: _propTypes.default.string,
    src: _propTypes.default.string
  }),
  isLoading: _propTypes.default.bool.isRequired,
  title: _propTypes.default.string.isRequired
} : {};
var _default = FileMedia;
exports.default = _default;