"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _CheckboxRaw = _interopRequireDefault(require("./CheckboxRaw"));

var _FormElement = _interopRequireDefault(require("./FormElement"));

var _FormElementControl = _interopRequireDefault(require("./FormElementControl"));

var _FormElementError = _interopRequireDefault(require("./FormElementError"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Checkbox = function Checkbox(props) {
  var error = props.error,
      hideErrorMessage = props.hideErrorMessage,
      id = props.id,
      required = props.required;
  return _react.default.createElement(_FormElement.default, {
    required: required,
    error: error
  }, _react.default.createElement(_FormElementControl.default, null, _react.default.createElement(_CheckboxRaw.default, props)), !hideErrorMessage && _react.default.createElement(_FormElementError.default, {
    error: error,
    id: id
  }));
};

Checkbox.defaultProps = {
  error: null,
  hideErrorMessage: false,
  hideLabel: false,
  required: false
};
Checkbox.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
  * renders an error for the checkbox
   */
  error: _propTypes.default.string,

  /**
   * hides the error message
   */
  hideErrorMessage: _propTypes.default.bool,

  /**
   * sets the label to render as assistive text
   */
  hideLabel: _propTypes.default.bool,

  /**
   * id of the checkbox
   */
  id: _propTypes.default.string.isRequired,

  /**
   * adds required attribute to the checkbox
   */
  required: _propTypes.default.bool
} : {};
var _default = Checkbox;
exports.default = _default;