"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var FormElement = function FormElement(props) {
  var children = props.children,
      className = props.className,
      error = props.error,
      fieldset = props.fieldset,
      isStatic = props.isStatic,
      required = props.required,
      rest = _objectWithoutProperties(props, ["children", "className", "error", "fieldset", "isStatic", "required"]);

  var sldsClasses = ['slds-form-element', {
    'slds-has-error': !!error
  }, {
    'slds-is-required': required
  }, {
    'slds-form-element_readonly': isStatic
  }, className];
  var Tag = fieldset ? 'fieldset' : 'div';
  return _react.default.createElement(Tag, _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses)
  }), children);
};

FormElement.defaultProps = {
  className: null,
  error: null,
  fieldset: false,
  isStatic: false,
  required: false
};
FormElement.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * form content
   */
  children: _propTypes.default.node.isRequired,

  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * can render errors for the given form element
   */
  error: _propTypes.default.string,

  /**
   * renders as a fieldset instead
   */
  fieldset: _propTypes.default.bool,

  /**
   * Renders in a static, "view" mode
   */
  isStatic: _propTypes.default.bool,

  /**
   * adds required-attribute to the form element
   */
  required: _propTypes.default.bool
} : {};
var _default = FormElement;
exports.default = _default;