"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var FormElementControl = function FormElementControl(props) {
  var children = props.children,
      className = props.className,
      hasIconLeft = props.hasIconLeft,
      hasIconRight = props.hasIconRight,
      rest = _objectWithoutProperties(props, ["children", "className", "hasIconLeft", "hasIconRight"]);

  var sldsClasses = ['slds-form-element__control', {
    'slds-input-has-icon': hasIconLeft || hasIconRight
  }, {
    'slds-input-has-icon_right': hasIconRight && !hasIconLeft
  }, {
    'slds-input-has-icon_left': hasIconLeft && !hasIconRight
  }, {
    'slds-input-has-icon_left-right': hasIconLeft && hasIconRight
  }, className];
  return _react.default.createElement("div", _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses)
  }), children);
};

FormElementControl.defaultProps = {
  className: null,
  hasIconLeft: false,
  hasIconRight: false
};
FormElementControl.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * control element(s)
   */
  children: _propTypes.default.node.isRequired,

  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * set this to true if the form element has a left icon
   */
  hasIconLeft: _propTypes.default.bool,

  /**
   * set this to true if the form element has a right icon
   */
  hasIconRight: _propTypes.default.bool
} : {};
var _default = FormElementControl;
exports.default = _default;