"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var FormElementError = function FormElementError(props) {
  var className = props.className,
      error = props.error,
      id = props.id,
      rest = _objectWithoutProperties(props, ["className", "error", "id"]);

  var renderError = function renderError() {
    if (error) {
      var sldsClasses = ['slds-form-element__help', className];
      return _react.default.createElement("div", _extends({}, rest, {
        id: (0, _utils.getUniqueHash)(error, id),
        className: (0, _classnames.default)(sldsClasses)
      }), error);
    }

    return null;
  };

  return renderError();
};

FormElementError.defaultProps = {
  error: null
};
FormElementError.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * element triggered on the containing form element
   */
  error: _propTypes.default.string,

  /**
   * id of the parent component carrying the error
   */
  id: _propTypes.default.string.isRequired
} : {};
var _default = FormElementError;
exports.default = _default;