"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodashEs = require("lodash-es");

var _utils = require("../../utils");

var _Button = require("../Button");

var _Icon = require("../Icon");

var _Spinner = require("../Spinner");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var InputRaw = _react.default.forwardRef(function (props, ref) {
  var bare = props.bare,
      className = props.className,
      disabled = props.disabled,
      error = props.error,
      errorIcon = props.errorIcon,
      hideErrorMessage = props.hideErrorMessage,
      iconLeft = props.iconLeft,
      iconRight = props.iconRight,
      iconRightOnClick = props.iconRightOnClick,
      id = props.id,
      onChange = props.onChange,
      onFocus = props.onFocus,
      onKeyPress = props.onKeyPress,
      placeholder = props.placeholder,
      required = props.required,
      role = props.role,
      showSpinner = props.showSpinner,
      type = props.type,
      value = props.value,
      rest = _objectWithoutProperties(props, ["bare", "className", "disabled", "error", "errorIcon", "hideErrorMessage", "iconLeft", "iconRight", "iconRightOnClick", "id", "onChange", "onFocus", "onKeyPress", "placeholder", "required", "role", "showSpinner", "type", "value"]);

  var renderIconLeft = function renderIconLeft() {
    if (_react.default.isValidElement(iconLeft)) return iconLeft;
    var iconName = error && errorIcon ? 'warning' : iconLeft;

    if (iconName) {
      var iconClasses = ['slds-icon', 'slds-input__icon', 'slds-input__icon_left', 'slds-icon-text-default'];
      return _react.default.createElement(_Icon.IconSVG, {
        className: (0, _classnames.default)(iconClasses),
        icon: iconName,
        sprite: "utility"
      });
    }

    return null;
  };

  var renderIconRight = function renderIconRight() {
    if (iconRight && iconRightOnClick) {
      var iconClasses = ['slds-input__icon', 'slds-input__icon_right'];
      return _react.default.createElement(_Button.IconButton, {
        icon: iconRight,
        sprite: "utility",
        className: (0, _classnames.default)(iconClasses),
        onClick: iconRightOnClick
      });
    }

    if (iconRight) {
      var _iconClasses = ['slds-icon-text-default', 'slds-icon', 'slds-input__icon', 'slds-input__icon_right'];
      return _react.default.createElement(_Icon.IconSVG, {
        className: (0, _classnames.default)(_iconClasses),
        sprite: "utility",
        icon: iconRight
      });
    }

    return null;
  };

  var sldsClasses = [bare ? 'slds-input_bare' : 'slds-input', className];
  return _react.default.createElement(_react.Fragment, null, renderIconLeft(), _react.default.createElement("input", _extends({}, (0, _lodashEs.omit)(rest, ['label']), {
    "aria-describedby": error && !hideErrorMessage ? (0, _utils.getUniqueHash)(error, id) : null,
    className: (0, _classnames.default)(sldsClasses),
    disabled: disabled,
    id: id,
    onChange: onChange,
    onFocus: onFocus,
    onKeyPress: onKeyPress,
    placeholder: placeholder,
    ref: ref,
    required: required,
    role: role,
    type: type,
    value: value
  })), showSpinner ? _react.default.createElement("div", {
    className: "slds-input__icon-group slds-input__icon-group_right"
  }, _react.default.createElement(_Spinner.Spinner, {
    flavor: "brand",
    className: "slds-input__spinner slds-m-right_xx-small",
    size: "x-small"
  }), renderIconRight()) : renderIconRight());
});

InputRaw.displayName = 'InputRaw';
InputRaw.defaultProps = {
  bare: false,
  className: null,
  disabled: false,
  error: null,
  errorIcon: false,
  hideErrorMessage: false,
  iconLeft: null,
  iconRight: null,
  iconRightOnClick: null,
  label: null,
  onChange: null,
  onFocus: null,
  onKeyPress: null,
  placeholder: null,
  role: null,
  required: false,
  showSpinner: false,
  type: 'text',
  value: undefined
};
InputRaw.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * renders a bare input
   */
  bare: _propTypes.default.bool,

  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * adds disabled attribute to the input field
   */
  disabled: _propTypes.default.bool,

  /**
   * renders an error for the input
   */
  error: _propTypes.default.string,

  /**
   * hides the error message
   */
  hideErrorMessage: _propTypes.default.bool,

  /**
   * renders an additional error icon if an error is set
   */
  errorIcon: _propTypes.default.bool,

  /**
   * icon rendered on the left side of the input (from utility sprite)
   */
  iconLeft: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element]),

  /**
   * icon rendered on the right side of the input (from utility sprite)
   */
  iconRight: _propTypes.default.string,

  /**
   * onClick handler for the right icon
   */
  iconRightOnClick: _propTypes.default.func,

  /**
   * id of the input field
   */
  id: _propTypes.default.string.isRequired,

  /**
   * label for the input
   */
  label: _propTypes.default.node,

  /**
   * onChange handler for input
   */
  onChange: _propTypes.default.func,

  /**
   * onFocus handler for input
   */
  onFocus: _propTypes.default.func,

  /**
   * onKeyPress handler
   */
  onKeyPress: _propTypes.default.func,

  /**
   * placeholder for the input
   */
  placeholder: _propTypes.default.string,

  /**
   * adds required attribute to input and label
   */
  required: _propTypes.default.bool,

  /**
   * role of the input field
   */
  role: _propTypes.default.string,

  /**
   * whether to show a spinner element inside the field, on the right end
   */
  showSpinner: _propTypes.default.bool,

  /**
   * input type. all HTML5 types are allowed, defaults to "text"
   * text, password, datetime, datetime-local, date, month, time, week, number, email, url, search, tel, and color
   */
  type: _propTypes.default.string,

  /**
   * value of the input field
   */
  value: _propTypes.default.string
} : {};
var _default = InputRaw;
exports.default = _default;