"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Container = function Container(props) {
  var El = props.as,
      children = props.children,
      className = props.className,
      flavor = props.flavor,
      size = props.size,
      rest = _objectWithoutProperties(props, ["as", "children", "className", "flavor", "size"]);

  var sldsClasses = [className, (0, _utils.applyDecorators)(flavor, 'container'), _defineProperty({}, "slds-container_".concat(size), !!size)];
  return _react.default.createElement(El, _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses)
  }), children);
};

Container.defaultProps = {
  as: 'div',
  children: null,
  className: null,
  flavor: [],
  size: null
};
Container.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Allows using an arbitrary DOM element as container
   */
  as: _propTypes.default.string,

  /**
   * container content
   */
  children: _propTypes.default.node,

  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * flavor: array of flavors, you can also provide a single flavor as string.
   * Flavors: fluid, left, center, right
   */
  flavor: (0, _utils.decoratorProp)(['fluid', 'left', 'center', 'right']),

  /*
   * sizes: small, medium, large, x-large
   */
  size: _propTypes.default.oneOf(['small', 'medium', 'large', 'x-large'])
} : {};
var _default = Container;
exports.default = _default;