"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = require("../../Icon");

var _Button = require("../../Button");

var _Pill = require("../../Pill");

var _OverflowContainer = require("./OverflowContainer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var isPropChanged = function isPropChanged(prop) {
  return function (a, b) {
    return a[prop] !== b[prop];
  };
};

var isLengthChanged = isPropChanged('length');
var isIdChanged = isPropChanged('id');
var isOpenChanged = isPropChanged('isOpen');

var ComboboxGroupedListbox =
/*#__PURE__*/
function (_Component) {
  _inherits(ComboboxGroupedListbox, _Component);

  function ComboboxGroupedListbox(props) {
    var _this;

    _classCallCheck(this, ComboboxGroupedListbox);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ComboboxGroupedListbox).call(this, props));
    _this.state = {
      forcedUpdateTimestamp: null
    };
    _this.listboxRef = _react.default.createRef();
    return _this;
  }

  _createClass(ComboboxGroupedListbox, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props = this.props,
          selectedItems = _this$props.selectedItems,
          isExpanded = _this$props.isExpanded;
      var prevSelectedItems = prevProps.selectedItems;
      if (isExpanded) return;

      if (isOpenChanged(this.props, prevProps) || isLengthChanged(selectedItems, prevSelectedItems)) {
        this.forceRecalculation();
        return;
      } // Optimization: Lists longer than 30 items will have an overflow present
      // We can skip a detailed check and assume that only a length change should trigger a recalculation


      if (selectedItems.length < 30 && selectedItems.some(function (item, i) {
        return isIdChanged(item, prevSelectedItems[i]);
      })) {
        this.forceRecalculation();
      }
    }
  }, {
    key: "forceRecalculation",
    value: function forceRecalculation() {
      // eslint-disable-next-line react/no-did-update-set-state
      this.setState({
        forcedUpdateTimestamp: Date.now()
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          hideWhenEmpty = _this$props2.hideWhenEmpty,
          isExpanded = _this$props2.isExpanded,
          isOpen = _this$props2.isOpen,
          label = _this$props2.label,
          makeSelectHandler = _this$props2.makeSelectHandler,
          onExpand = _this$props2.onExpand,
          overflowLabel = _this$props2.overflowLabel,
          renderPill = _this$props2.renderPill,
          selectedItems = _this$props2.selectedItems,
          showItemsWhenOpen = _this$props2.showItemsWhenOpen;
      var forcedUpdateTimestamp = this.state.forcedUpdateTimestamp;
      var sldsClasses = ['slds-listbox_selection-group', {
        'slds-is-expanded': isExpanded
      }, {
        'slds-hide': hideWhenEmpty && selectedItems.length === 0 || isOpen && !showItemsWhenOpen
      }];
      var makeExpandButtonTitle = typeof overflowLabel === 'function' ? overflowLabel : function () {
        return overflowLabel;
      };
      return _react.default.createElement(_OverflowContainer.OverflowContainer, {
        containerRef: this.listboxRef,
        forcedUpdateTimestamp: forcedUpdateTimestamp,
        skipCalculation: isExpanded || isOpen
      }, function (_ref) {
        var overflowCount = _ref.overflowCount;
        return _react.default.createElement("div", {
          className: (0, _classnames.default)(sldsClasses)
        }, !isExpanded && overflowCount > 0 && _react.default.createElement("span", {
          className: "slds-listbox-toggle",
          "aria-hidden": "true"
        }, _react.default.createElement(_Button.Button, {
          tabIndex: "-1",
          flavor: "none",
          onClick: onExpand,
          title: makeExpandButtonTitle(overflowCount)
        })), _react.default.createElement(_Pill.Listbox, {
          label: label,
          ref: _this2.listboxRef
        }, selectedItems.map(function (_ref2) {
          var icon = _ref2.icon,
              id = _ref2.id,
              itemLabel = _ref2.label,
              rest = _objectWithoutProperties(_ref2, ["icon", "id", "label"]);

          var pillProps = _objectSpread({}, rest, {
            key: id,
            icon: icon ? _react.default.createElement(_Icon.Icon, {
              icon: icon.icon,
              sprite: icon.sprite
            }) : null,
            label: itemLabel,
            title: itemLabel,
            onClose: makeSelectHandler(id)
          });

          return renderPill ? renderPill(pillProps) : _react.default.createElement(_Pill.Pill, pillProps);
        })));
      });
    }
  }]);

  return ComboboxGroupedListbox;
}(_react.Component);

_defineProperty(ComboboxGroupedListbox, "defaultProps", {
  hideWhenEmpty: false,
  isExpanded: false,
  overflowLabel: function overflowLabel(cnt) {
    return "+".concat(cnt, " more");
  },
  renderPill: null,
  showItemsWhenOpen: false
});

ComboboxGroupedListbox.propTypes = process.env.NODE_ENV !== "production" ? {
  isExpanded: _propTypes.default.bool,
  isOpen: _propTypes.default.bool.isRequired,
  hideWhenEmpty: _propTypes.default.bool,
  label: _propTypes.default.string.isRequired,
  makeSelectHandler: _propTypes.default.func.isRequired,
  onExpand: _propTypes.default.func.isRequired,
  overflowLabel: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.string]),
  renderPill: _propTypes.default.func,
  selectedItems: _propTypes.default.arrayOf(_propTypes.default.shape({
    id: _propTypes.default.string.isRequired,
    label: _propTypes.default.string.isRequired
  })).isRequired,
  showItemsWhenOpen: _propTypes.default.bool
} : {};
var _default = ComboboxGroupedListbox;
exports.default = _default;