"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withThrottle = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function rafThrottle(cb) {
  var currentExecution;

  var later = function later(context, args) {
    return function () {
      currentExecution = null;
      cb.apply(context, args);
    };
  };

  function throttled() {
    if (currentExecution == null) {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      currentExecution = requestAnimationFrame(later(this, args));
    }
  }

  return throttled;
}

var withThrottle = function withThrottle(Cmp) {
  return function (props) {
    return _react.default.createElement(Cmp, _extends({}, props, {
      throttleFn: rafThrottle
    }));
  };
};

exports.withThrottle = withThrottle;