"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _IconSVG = _interopRequireDefault(require("./IconSVG"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var iconClass = function iconClass(sprite, icon) {
  return icon.replace(/_/g, '-');
};

var Icon = function Icon(props) {
  var background = props.background,
      className = props.className,
      div = props.div,
      icon = props.icon,
      size = props.size,
      sprite = props.sprite,
      svgClassName = props.svgClassName,
      title = props.title,
      rest = _objectWithoutProperties(props, ["background", "className", "div", "icon", "size", "sprite", "svgClassName", "title"]);

  var backgroundClass = !background ? "slds-icon-".concat(sprite, "-").concat(iconClass(sprite, icon)) : "slds-icon-".concat(background);
  var sldsClasses = [{
    'slds-icon_container': true
  }, {
    'slds-icon_container_circle': sprite === 'action'
  }, _defineProperty({}, "".concat(backgroundClass), background !== false), className];
  var WrapperElement = div ? 'div' : 'span';
  return _react.default.createElement(WrapperElement, _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses),
    title: title
  }), _react.default.createElement(_IconSVG.default, {
    className: svgClassName,
    icon: icon,
    size: size,
    sprite: sprite
  }), _react.default.createElement("span", {
    className: "slds-assistive-text"
  }, title));
};

Icon.defaultProps = {
  background: null,
  className: null,
  div: false,
  size: null,
  svgClassName: null,
  title: null
};
Icon.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Set this if you want to override the default background class. set to false to not set a background */
  background: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),

  /** class name */
  className: _propTypes.default.string,

  /** <div>-container instead of a <span>-container */
  div: _propTypes.default.bool,

  /** Name of the icon */
  icon: _propTypes.default.string.isRequired,

  /** Size */
  size: _propTypes.default.oneOf(['xx-small', 'x-small', 'small', 'medium', 'large']),

  /** Name of the sprite containing the icon */
  sprite: _propTypes.default.oneOf(['action', 'custom', 'doctype', 'standard', 'utility']).isRequired,

  /** ClassName that will be handed over to the <svg /> */
  svgClassName: _propTypes.default.string,

  /** Descriptive Title */
  title: _propTypes.default.string
} : {};
var _default = Icon;
exports.default = _default;