"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var SCORES = ['negative', 'positive'];

var renderScore = function renderScore(score) {
  return _react.default.createElement("svg", {
    key: score,
    viewBox: "0 0 5 5",
    className: "slds-icon-score__".concat(score),
    "aria-hidden": "true"
  }, _react.default.createElement("circle", {
    cx: "50%",
    cy: "50%",
    r: "1.875"
  }));
};

var ScoreIcon = function ScoreIcon(props) {
  var assistiveText = props.assistiveText,
      className = props.className,
      score = props.score,
      title = props.title,
      rest = _objectWithoutProperties(props, ["assistiveText", "className", "score", "title"]);

  var assistive = assistiveText || title;
  return _react.default.createElement("div", _extends({
    className: (0, _classnames.default)('slds-icon_container', className)
  }, rest), _react.default.createElement("span", {
    className: "slds-icon-score",
    "data-slds-state": score,
    title: title
  }, SCORES.map(renderScore), assistive && _react.default.createElement("span", {
    className: "slds-assistive-text"
  }, assistive)));
};

ScoreIcon.defaultProps = {
  assistiveText: null,
  className: null,
  title: null
};
ScoreIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * AssistiveText of icon. Defaults to `title` if not present
   */
  assistiveText: _propTypes.default.string,

  /**
   * Additional classes that will be applied to `span#slds-icon-score`
   */
  className: _propTypes.default.string,

  /**
   * Indicates the icon that will be rendered: `positive` or `negative`
   */
  score: _propTypes.default.oneOf(SCORES).isRequired,

  /**
   * Sets a `title` tooltip. Also sets `assistiveText` if prop not present
   */
  title: _propTypes.default.string
} : {};
var _default = ScoreIcon;
exports.default = _default;