"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.MenuRaw = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _omit = _interopRequireDefault(require("lodash-es/omit"));

var _ControlledMenu = _interopRequireDefault(require("./ControlledMenu"));

var _ClickOutside = require("../ClickOutside");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// https://github.com/oliviertassinari/babel-plugin-transform-react-remove-prop-types#is-it-safe
var propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * The button that triggers the dropdown menu
   */
  button: _propTypes.default.element.isRequired,

  /**
  * indicates if the menu closes automatically on an outside click
  */
  closeOnClickOutside: _propTypes.default.bool,

  /**
   * menu should start open
   */
  defaultOpen: _propTypes.default.bool,

  /**
   * Called when menu is opened/closed
   */
  onToggle: _propTypes.default.func
} : {};

var MenuRaw =
/*#__PURE__*/
function (_Component) {
  _inherits(MenuRaw, _Component);

  function MenuRaw(props) {
    var _this;

    _classCallCheck(this, MenuRaw);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(MenuRaw).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "onClickOutside", function () {
      return _this.setState({
        open: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getButton", function () {
      var button = _this.props.button;
      return _react.default.cloneElement(button, {
        onClick: _this.toggle
      });
    });

    _defineProperty(_assertThisInitialized(_this), "toggle", function () {
      var onToggle = _this.props.onToggle;
      onToggle(!_this.state.open);

      _this.setState(function (prevState) {
        return {
          open: !prevState.open
        };
      });
    });

    var defaultOpen = _this.props.defaultOpen;
    _this.state = {
      open: defaultOpen
    };
    return _this;
  }

  _createClass(MenuRaw, [{
    key: "render",
    value: function render() {
      var closeOnClickOutside = this.props.closeOnClickOutside;
      var open = this.state.open;
      var rest = (0, _omit.default)(this.props, ['button', 'defaultOpen', 'closeOnClickOutside']);
      var condition = closeOnClickOutside && open;
      return _react.default.createElement(_ClickOutside.ClickOutside, {
        onClickOutside: this.onClickOutside,
        condition: condition
      }, _react.default.createElement(_ControlledMenu.default, _extends({}, rest, {
        button: this.getButton(),
        isOpen: open
      })));
    }
  }]);

  return MenuRaw;
}(_react.Component);

exports.MenuRaw = MenuRaw;

_defineProperty(MenuRaw, "defaultProps", {
  closeOnClickOutside: false,
  defaultOpen: false,
  onToggle: Function.prototype
});

MenuRaw.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};

var Menu = function Menu(props) {
  return _react.default.createElement(MenuRaw, _extends({
    closeOnClickOutside: true
  }, props));
};

var _default = Menu;
exports.default = _default;