"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var MenuSubHeader = function MenuSubHeader(props) {
  var children = props.children,
      className = props.className,
      divider = props.divider,
      rest = _objectWithoutProperties(props, ["children", "className", "divider"]);

  var sldsClasses = ['slds-dropdown__header', 'slds-truncate', {
    'slds-has-divider_top-space': divider
  }, className];
  return _react.default.createElement("li", _extends({
    className: (0, _classnames.default)(sldsClasses),
    title: children,
    role: "separator"
  }, rest), _react.default.createElement("span", null, children));
};

MenuSubHeader.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * The content of a menu item sub header, should be string or an element
   */
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element]).isRequired,

  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * set to true if a divider should appear above this list item
   */
  divider: _propTypes.default.bool
  /**
   * left icon that is only shown when selected is true
   */

} : {};
MenuSubHeader.defaultProps = {
  className: null,
  divider: false
};
var _default = MenuSubHeader;
exports.default = _default;