"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = require("../Button");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ModalFooter = function ModalFooter(_ref) {
  var children = _ref.children,
      className = _ref.className,
      closeButtonLabel = _ref.closeButtonLabel,
      directional = _ref.directional,
      hideCloseButton = _ref.hideCloseButton,
      onClose = _ref.onClose,
      _ = _ref.id,
      rest = _objectWithoutProperties(_ref, ["children", "className", "closeButtonLabel", "directional", "hideCloseButton", "onClose", "id"]);

  return _react.default.createElement("footer", _extends({}, rest, {
    className: (0, _classnames.default)('slds-modal__footer', {
      'slds-modal__footer_directional': directional
    }, className)
  }), !hideCloseButton && !!onClose && _react.default.createElement(_Button.Button, {
    onClick: onClose
  }, closeButtonLabel), children);
};

ModalFooter.defaultProps = {
  children: null,
  className: null,
  directional: false,
  hideCloseButton: false,
  closeButtonLabel: 'Cancel',
  onClose: null
};
ModalFooter.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Additional content in ModalFooter. Usually used to add a confirm button
   */
  children: _propTypes.default.node,

  /**
   * className that will be merged
   */
  className: _propTypes.default.string,

  /**
   * Renders a directional footer
   */
  directional: _propTypes.default.bool,

  /**
   * Hides the closeButton when `onClose` is set
   */
  hideCloseButton: _propTypes.default.bool,

  /**
   * Label for the closeButton that will be rendered
   */
  closeButtonLabel: _propTypes.default.string,

  /**
   * (PRIVATE) Passed down from Modal. Renders a close button with `closeButtonLabel`
   */
  onClose: _propTypes.default.func
} : {};
var _default = ModalFooter;
exports.default = _default;