"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = require("../Button");

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var ModalHeader = function ModalHeader(props) {
  var id = props.id,
      onClose = props.onClose,
      theme = props.theme,
      title = props.title,
      tagline = props.tagline;
  var isEmpty = !tagline && !title;
  return _react.default.createElement("header", {
    className: _classnames.default.apply(void 0, ['slds-modal__header', {
      'slds-modal__header_empty': isEmpty
    }].concat(_toConsumableArray((0, _utils.getThemeClass)(theme))))
  }, onClose && _react.default.createElement(_Button.IconButton, {
    className: "slds-modal__close",
    flavor: "inverse",
    onClick: onClose,
    tabIndex: 0
  }, _react.default.createElement(_Button.ButtonIcon, {
    sprite: "utility",
    icon: "close",
    size: "large"
  })), title && _react.default.createElement("h2", {
    className: "slds-text-heading_medium slds-hyphenate",
    id: id
  }, title), tagline && _react.default.createElement("p", {
    className: "slds-m-top_x-small"
  }, tagline));
};

ModalHeader.defaultProps = {
  id: null,
  onClose: null,
  title: null,
  tagline: null,
  theme: null
};
ModalHeader.propTypes = process.env.NODE_ENV !== "production" ? {
  id: _propTypes.default.string,
  onClose: _propTypes.default.func,
  theme: _propTypes.default.oneOf(_utils.THEMES),
  title: _propTypes.default.string,
  tagline: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element])
} : {};
var _default = ModalHeader;
exports.default = _default;