"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Value = exports.Name = exports.List = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var List = function List(_ref) {
  var children = _ref.children,
      className = _ref.className,
      mode = _ref.mode,
      rest = _objectWithoutProperties(_ref, ["children", "className", "mode"]);

  return _react.default.createElement("dl", _extends({}, rest, {
    className: (0, _classnames.default)(["slds-list_".concat(mode), {
      'slds-wrap': mode === 'horizontal'
    }, className])
  }), children);
};

exports.List = List;
List.defaultProps = {
  className: null,
  mode: 'horizontal'
};
List.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * one or more sets of `Value` or `Name` components
   */
  children: _propTypes.default.node.isRequired,
  className: _propTypes.default.string,
  mode: _propTypes.default.oneOf(['horizontal', 'inline', 'stacked'])
} : {};

var NameOrValue = function NameOrValue(_ref2) {
  var El = _ref2.as,
      className = _ref2.className,
      children = _ref2.children,
      title = _ref2.title,
      rest = _objectWithoutProperties(_ref2, ["as", "className", "children", "title"]);

  return _react.default.createElement(El, _extends({}, rest, {
    className: (0, _classnames.default)([className, 'slds-truncate']),
    title: title || (typeof children === 'string' ? children : '')
  }), children);
};

NameOrValue.defaultProps = {
  className: null,
  title: null
};
NameOrValue.propTypes = process.env.NODE_ENV !== "production" ? {
  as: _propTypes.default.oneOf(['dd', 'dt']).isRequired,
  children: _propTypes.default.node.isRequired,
  className: _propTypes.default.string,
  title: _propTypes.default.string
} : {};

var Name = function Name(_ref3) {
  var className = _ref3.className,
      rest = _objectWithoutProperties(_ref3, ["className"]);

  return _react.default.createElement(NameOrValue, _extends({}, rest, {
    as: "dt",
    className: (0, _classnames.default)(['slds-item_label', 'slds-text-color_weak', className])
  }));
};

exports.Name = Name;
Name.defaultProps = {
  className: null,
  title: null
};
Name.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.node.isRequired,

  /**
   * additional class names, added to `dt`
   */
  className: _propTypes.default.string,

  /**
   * title `attribute`, overwrites `children` if `children` is a string
   */
  title: _propTypes.default.string
} : {};

var Value = function Value(_ref4) {
  var className = _ref4.className,
      rest = _objectWithoutProperties(_ref4, ["className"]);

  return _react.default.createElement(NameOrValue, _extends({}, rest, {
    as: "dd",
    className: (0, _classnames.default)(['slds-item_detail', className])
  }));
};

exports.Value = Value;
Value.defaultProps = {
  className: null,
  title: null
};
Value.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.node.isRequired,

  /**
   * additional class names, added to `dd`
   */
  className: _propTypes.default.string,

  /**
   * title `attribute`, overwrites `children` if `children` is a string
   */
  title: _propTypes.default.string
} : {};