"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = require("../Icon");

var _MediaObject = require("../MediaObject");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var PageHeaderBase = function PageHeaderBase(props) {
  var className = props.className,
      _props$icon = props.icon,
      icon = _props$icon.icon,
      sprite = _props$icon.sprite,
      info = props.info,
      title = props.title,
      rest = _objectWithoutProperties(props, ["className", "icon", "info", "title"]);

  var sldsClasses = ['slds-page-header', className];
  return _react.default.createElement("div", _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses)
  }), _react.default.createElement("div", {
    className: "slds-page-header__row"
  }, _react.default.createElement("div", {
    className: "slds-page-header__col-title"
  }, _react.default.createElement(_MediaObject.MediaObject, {
    figureLeft: _react.default.createElement(_Icon.Icon, {
      sprite: sprite,
      icon: icon,
      svgClassName: "slds-page-header__icon"
    })
  }, _react.default.createElement("div", {
    className: "slds-page-header__name"
  }, _react.default.createElement("div", {
    className: "slds-page-header__name-title"
  }, _react.default.createElement("h1", null, _react.default.createElement("span", {
    className: "slds-page-header__title slds-truncate",
    title: title
  }, title)))), _react.default.createElement("p", {
    className: "slds-page-header__name-meta"
  }, info)))));
};

PageHeaderBase.defaultProps = {
  className: null
};
PageHeaderBase.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * icon and sprite
   */
  icon: _propTypes.default.shape({
    sprite: _propTypes.default.string.isRequired,
    icon: _propTypes.default.string.isRequired
  }).isRequired,

  /**
   * info subtitle
   */
  info: _propTypes.default.string.isRequired,

  /**
   * title
   */
  title: _propTypes.default.string.isRequired
} : {};
var _default = PageHeaderBase;
exports.default = _default;