"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ObjectHome = _interopRequireDefault(require("./ObjectHome"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var RecordHome = function RecordHome(_ref) {
  var detailItems = _ref.detailItems,
      headerButtons = _ref.headerButtons,
      icon = _ref.icon,
      recordType = _ref.recordType,
      title = _ref.title,
      rest = _objectWithoutProperties(_ref, ["detailItems", "headerButtons", "icon", "recordType", "title"]);

  return _react.default.createElement(_ObjectHome.default, _extends({}, rest, {
    icon: icon,
    recordType: recordType,
    title: title,
    topButtons: headerButtons,
    bottomButtons: null,
    titleMenu: null
  }), _react.default.createElement("div", {
    className: "slds-page-header__row slds-page-header__row_gutters"
  }, _react.default.createElement("div", {
    className: "slds-page-header__col-details"
  }, detailItems.length > 0 && _react.default.createElement("ul", {
    className: "slds-grid slds-page-header__detail-row"
  }, detailItems.map(function (_ref2, index) {
    var itemTitle = _ref2.title,
        itemContent = _ref2.content;
    return (// eslint-disable-next-line react/no-array-index-key
      _react.default.createElement("li", {
        className: "slds-page-header__detail-block",
        key: "".concat(itemTitle, "-").concat(index)
      }, _react.default.createElement("div", {
        className: "slds-text-title slds-truncate",
        title: itemTitle
      }, itemTitle), _react.default.createElement("div", {
        className: "slds-truncate",
        title: itemContent
      }, itemContent))
    );
  })))));
};

RecordHome.defaultProps = {
  className: null,
  detailItems: [],
  headerButtons: null
};
RecordHome.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * entries for the detail row, can be just strings or more complex nodes like
   * links or text with icons etc...
   */
  detailItems: _propTypes.default.arrayOf(_propTypes.default.shape({
    title: _propTypes.default.node.isRequired,
    content: _propTypes.default.node.isRequired
  })),

  /**
   * buttons that are rendered on the right side of the header
   */
  headerButtons: _propTypes.default.node,

  /**
   * sprite and icon
   */
  icon: _propTypes.default.shape({
    sprite: _propTypes.default.string.isRequired,
    icon: _propTypes.default.string.isRequired
  }).isRequired,

  /**
   * record type header above the title
   */
  recordType: _propTypes.default.string.isRequired,

  /**
   * title
   */
  title: _propTypes.default.string.isRequired
} : {};
var _default = RecordHome;
exports.default = _default;