"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Path = function Path(props) {
  var button = props.button,
      children = props.children,
      className = props.className,
      rest = _objectWithoutProperties(props, ["button", "children", "className"]);

  var sldsClasses = ['slds-path-coach', className];
  return _react.default.createElement("div", _extends({
    className: (0, _classnames.default)(sldsClasses)
  }, rest), _react.default.createElement("div", {
    className: "slds-grid"
  }, _react.default.createElement("div", {
    className: "slds-tabs_path",
    role: "application"
  }, _react.default.createElement("ul", {
    className: "slds-tabs_path__nav",
    role: "listbox"
  }, children)), button));
};

Path.defaultProps = {
  className: null
};
Path.propTypes = process.env.NODE_ENV !== "production" ? {
  /*
   * button to change selected stage status
   */
  button: _propTypes.default.node.isRequired,

  /*
   * children should be PathStages
   */
  children: _propTypes.default.node.isRequired,

  /*
   * class name
   */
  className: _propTypes.default.string
} : {};
var _default = Path;
exports.default = _default;