"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = require("../Icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var PathStage = function PathStage(props) {
  var assistiveText = props.assistiveText,
      className = props.className,
      complete = props.complete,
      current = props.current,
      label = props.label,
      onStageClick = props.onStageClick,
      selected = props.selected,
      rest = _objectWithoutProperties(props, ["assistiveText", "className", "complete", "current", "label", "onStageClick", "selected"]);

  var sldsClasses = ['slds-tabs_path__item', {
    'slds-is-complete': complete
  }, {
    'slds-is-current': current
  }, {
    'slds-is-incomplete': !complete && !current
  }, {
    'slds-is-active': selected && !current
  }, className];
  return _react.default.createElement("li", _extends({
    className: (0, _classnames.default)(sldsClasses),
    role: "presentation"
  }, rest), _react.default.createElement("a", {
    "aria-selected": selected,
    className: "slds-tabs_path__link",
    role: "option",
    tabIndex: selected ? 0 : -1,
    onClick: onStageClick
  }, _react.default.createElement("span", {
    className: "slds-tabs_path__stage"
  }, complete && _react.default.createElement(_Icon.IconSVG, {
    sprite: "utility",
    icon: "check",
    size: "x-small"
  }), _react.default.createElement("span", {
    className: "slds-assistive-text"
  }, assistiveText)), _react.default.createElement("span", {
    className: "slds-tabs_path__title"
  }, label)));
};

PathStage.defaultProps = {
  assistiveText: null,
  className: null,
  complete: false,
  current: false,
  selected: false
};
PathStage.propTypes = process.env.NODE_ENV !== "production" ? {
  /*
   * aria assistive text
   */
  assistiveText: _propTypes.default.string,

  /*
   * class name
   */
  className: _propTypes.default.string,

  /*
   * stage is current stage
   */
  current: _propTypes.default.bool,

  /*
   * stage is complete
   */
  complete: _propTypes.default.bool,

  /*
   * string or node as label of the stage
   */
  label: _propTypes.default.node.isRequired,

  /*
   * function to be called on stage click
   */
  onStageClick: _propTypes.default.func.isRequired,

  /*
   * stage is selected
   */
  selected: _propTypes.default.bool
} : {};
var _default = PathStage;
exports.default = _default;