"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Listbox = _react.default.forwardRef(function (props, ref) {
  var children = props.children,
      className = props.className,
      label = props.label,
      rest = _objectWithoutProperties(props, ["children", "className", "label"]);

  var sldsClasses = ['slds-listbox', 'slds-listbox_horizontal', className];

  var renderChild = function renderChild(child, i) {
    if (!child) return null;

    var clonedChild = _react.default.cloneElement(child, {
      'aria-selected': true,
      tabIndex: i === 0 ? 0 : null
    });

    return _react.default.createElement("li", {
      key: i,
      role: "presentation"
    }, clonedChild);
  };
  /* eslint-disable jsx-a11y/role-supports-aria-props */


  return _react.default.createElement("ul", _extends({}, rest, {
    "aria-label": label,
    "aria-orientation": "horizontal",
    className: (0, _classnames.default)(sldsClasses),
    ref: ref,
    role: "listbox"
  }), _react.default.Children.map(children, renderChild));
});

Listbox.displayName = 'Listbox';
Listbox.defaultProps = {
  className: null,
  label: null
};
Listbox.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * child nodes
   */
  children: _propTypes.default.node.isRequired,

  /**
   * optional classname
   */
  className: _propTypes.default.string,

  /**
   * ARIA-label for listbox
   */
  label: _propTypes.default.string
} : {};
var _default = Listbox;
exports.default = _default;