"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _omit = _interopRequireDefault(require("lodash-es/omit"));

var _utils = require("../../utils");

var _Button = require("../Button");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// https://github.com/oliviertassinari/babel-plugin-transform-react-remove-prop-types#is-it-safe
var propTypes = {
  /**
   * Open popover
   */
  open: _propTypes.default.bool,

  /**
   * Show close button
   */
  closeable: _propTypes.default.bool,

  /**
   * onClose handler
   */
  onClose: _propTypes.default.func.isRequired,

  /**
   * Popover header content
   */
  header: _propTypes.default.node,

  /**
   * Popover body content
   */
  body: _propTypes.default.node,

  /**
   * Popover footer content
   */
  footer: _propTypes.default.node,

  /**
   * Additional css classes
   */
  className: _propTypes.default.string,

  /**
   * Optional panel layout
   */
  panels: _propTypes.default.bool,

  /**
   * Optional position of nubbin. Positions: left, left-top, left-bottom,
   * top-left, top-right, right-top, right-bottom, bottom-left, bottom-right
   */
  nubbin: _propTypes.default.oneOf(['left', 'left-top', 'left-top-corner', 'left-bottom', 'left-bottom-corner', 'top-left', 'top-left-corner', 'top-right', 'top-right-corner', 'right-top', 'right-top-corner', 'right-bottom', 'right-bottom-corner', 'bottom-left', 'bottom-left-corner', 'bottom-right', 'bottom-right-corner']),

  /**
   * Optional custom Header theme. Themes: warning, error, success, info
   */
  customHeaderTheme: _propTypes.default.oneOf(_utils.THEMES),

  /**
   * themes: alt-inverse, default, error, info, inverse, offline, shade, success, warning
   */
  theme: _propTypes.default.oneOf(_utils.THEMES)
};

var Popover =
/*#__PURE__*/
function (_Component) {
  _inherits(Popover, _Component);

  _createClass(Popover, null, [{
    key: "shouldInvertIcon",
    value: function shouldInvertIcon(themeStr) {
      if (typeof themeStr === 'string') {
        return themeStr.includes('error') || themeStr.includes('success') || themeStr.includes('info') || themeStr.includes('offline');
      }

      return false;
    }
  }]);

  function Popover(props, _ref) {
    var cssPrefix = _ref.cssPrefix;

    _classCallCheck(this, Popover);

    return _possibleConstructorReturn(this, _getPrototypeOf(Popover).call(this, props, {
      cssPrefix: cssPrefix
    }));
  }

  _createClass(Popover, [{
    key: "renderHeader",
    value: function renderHeader() {
      var _this$props = this.props,
          header = _this$props.header,
          panels = _this$props.panels,
          customHeaderTheme = _this$props.customHeaderTheme;
      var headerClasses = ['slds-popover__header', (0, _utils.getThemeClass)(customHeaderTheme)];
      var headerContent;
      var borderRadius;

      if (panels && !customHeaderTheme) {
        headerContent = _react.default.createElement("h2", {
          className: "slds-text-heading_small slds-p-around_xxx-small"
        }, header);
        borderRadius = {
          borderTopLeftRadius: 'calc(0.25rem - 1px)',
          borderTopRightRadius: 'calc(0.25rem - 1px)'
        };
      } else {
        headerContent = header;
      }

      return _react.default.createElement("header", {
        className: (0, _classnames.default)(headerClasses),
        style: borderRadius
      }, headerContent);
    }
  }, {
    key: "renderBody",
    value: function renderBody() {
      var body = this.props.body;
      return _react.default.createElement("div", {
        className: "slds-popover__body"
      }, body);
    }
  }, {
    key: "renderFooter",
    value: function renderFooter() {
      var footer = this.props.footer;
      return _react.default.createElement("footer", {
        className: "slds-popover__footer"
      }, _react.default.createElement("p", null, footer));
    }
  }, {
    key: "renderCloseButton",
    value: function renderCloseButton() {
      var _this$props2 = this.props,
          onClose = _this$props2.onClose,
          customHeaderTheme = _this$props2.customHeaderTheme,
          theme = _this$props2.theme;
      var invertIcon = Popover.shouldInvertIcon(customHeaderTheme || theme);
      var closeButtonClasses = ['slds-float_right', 'slds-popover__close'];
      return _react.default.createElement(_Button.IconButton, {
        flavor: invertIcon ? 'inverse' : null,
        className: (0, _classnames.default)(closeButtonClasses),
        onClick: onClose,
        size: "small",
        sprite: "utility",
        icon: "close"
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          className = _this$props3.className,
          closeable = _this$props3.closeable,
          open = _this$props3.open,
          customHeaderTheme = _this$props3.customHeaderTheme,
          nubbin = _this$props3.nubbin,
          panels = _this$props3.panels,
          header = _this$props3.header,
          body = _this$props3.body,
          footer = _this$props3.footer,
          theme = _this$props3.theme;
      var rest = (0, _omit.default)(this.props, Object.keys(propTypes));
      var sldsClasses = ['slds-popover', _defineProperty({}, "slds-nubbin_".concat(nubbin), !!nubbin), {
        'slds-popover_panel': panels && !customHeaderTheme
      }, {
        'slds-hide': !open
      }, (0, _utils.getThemeClass)(theme), className];
      return _react.default.createElement("section", _extends({}, rest, {
        className: (0, _classnames.default)(sldsClasses),
        role: "dialog"
      }), closeable ? this.renderCloseButton() : null, header ? this.renderHeader() : null, body ? this.renderBody() : null, footer ? this.renderFooter() : null);
    }
  }]);

  return Popover;
}(_react.Component);

_defineProperty(Popover, "defaultProps", {
  body: null,
  header: null,
  footer: null,
  className: null,
  customHeaderTheme: null,
  open: false,
  closeable: true,
  panels: false,
  nubbin: 'bottom-left',
  theme: null
});

Popover.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
var _default = Popover;
exports.default = _default;