"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Grid = require("../Grid");

var _utils = require("./utils");

var _ProgressBar = _interopRequireDefault(require("./ProgressBar"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var DescriptiveProgressBar = function DescriptiveProgressBar(_ref) {
  var completeLabel = _ref.completeLabel,
      id = _ref.id,
      label = _ref.label,
      max = _ref.max,
      min = _ref.min,
      progress = _ref.progress,
      rest = _objectWithoutProperties(_ref, ["completeLabel", "id", "label", "max", "min", "progress"]);

  return _react.default.createElement("div", null, _react.default.createElement(_Grid.Grid, {
    className: "slds-p-bottom_x-small",
    align: "spread",
    id: id
  }, _react.default.createElement("span", null, label), _react.default.createElement("span", {
    "aria-hidden": "true"
  }, _react.default.createElement("strong", null, "".concat((0, _utils.getClampedProgress)(progress, min, max), "% ").concat(completeLabel)))), _react.default.createElement(_ProgressBar.default, _extends({
    "aria-labelledby": id,
    completeLabel: completeLabel,
    min: min,
    max: max,
    progress: progress
  }, rest)));
};

DescriptiveProgressBar.defaultProps = {
  completeLabel: 'Complete',
  max: 100,
  min: 0,
  progress: 0
};
DescriptiveProgressBar.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Labels the 'Complete' percentage, e.g. "25% Complete" */
  completeLabel: _propTypes.default.string,

  /** Ties label to ProgressBar for assistive technology */
  id: _propTypes.default.string.isRequired,

  /** Main label */
  label: _propTypes.default.node.isRequired,

  /** See ProgressBar */
  max: _propTypes.default.number,

  /** See ProgressBar */
  min: _propTypes.default.number,

  /** See ProgressBar */
  progress: _propTypes.default.number
} : {};
var _default = DescriptiveProgressBar;
exports.default = _default;