"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = require("../Button");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// TODO: Support for step tooltip is still missing.
var ProgressIndicatorItem = function ProgressIndicatorItem(_ref) {
  var assistiveText = _ref.assistiveText,
      className = _ref.className,
      isActive = _ref.isActive,
      isError = _ref.isError,
      isCompleted = _ref.isCompleted,
      isSuccess = _ref.isSuccess,
      rest = _objectWithoutProperties(_ref, ["assistiveText", "className", "isActive", "isError", "isCompleted", "isSuccess"]);

  var classNames = (0, _classnames.default)('slds-progress__item', {
    'slds-is-active': isActive,
    'slds-is-completed': isCompleted || isSuccess,
    'slds-has-error': isError
  }, className);
  var icon = isError ? 'error' : 'success';
  return _react.default.createElement("li", _extends({}, rest, {
    className: classNames
  }), !isCompleted && !isError && !isSuccess ? _react.default.createElement(_Button.Button, {
    className: "slds-progress__marker",
    title: assistiveText,
    flavor: null
  }, assistiveText && _react.default.createElement("span", {
    className: "slds-assistive-text"
  }, assistiveText)) : _react.default.createElement(_Button.IconButton, {
    className: "slds-progress__marker slds-progress__marker_icon",
    title: assistiveText
  }, _react.default.createElement(_Button.ButtonIcon, {
    sprite: "utility",
    icon: icon
  })));
};

ProgressIndicatorItem.defaultProps = {
  assistiveText: null,
  className: null,
  isActive: false,
  isCompleted: false,
  isError: false,
  isSuccess: false
};
ProgressIndicatorItem.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Assisitive text for this step
   */
  assistiveText: _propTypes.default.string,

  /**
   * Additional className
   */
  className: _propTypes.default.string,

  /**
   * Whether this step is active
   */
  isActive: _propTypes.default.bool,

  /**
   * Whether this step is complete
   */
  isCompleted: _propTypes.default.bool,

  /**
   * Whether this step is succeeded
   */
  isSuccess: _propTypes.default.bool,

  /**
   * Whether this step has an error
   */
  isError: _propTypes.default.bool
} : {};
var _default = ProgressIndicatorItem;
exports.default = _default;