"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = require("../Icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var VerticalProgressIndicatorItem = function VerticalProgressIndicatorItem(_ref) {
  var assistiveText = _ref.assistiveText,
      className = _ref.className,
      isActive = _ref.isActive,
      isError = _ref.isError,
      isCompleted = _ref.isCompleted,
      children = _ref.children,
      isSuccess = _ref.isSuccess,
      rest = _objectWithoutProperties(_ref, ["assistiveText", "className", "isActive", "isError", "isCompleted", "children", "isSuccess"]);

  var classNames = (0, _classnames.default)('slds-progress__item', {
    'slds-is-active': isActive,
    'slds-is-completed': isCompleted || isSuccess,
    'slds-has-error': isError
  }, className);
  var icon = isError ? 'error' : 'success';
  return _react.default.createElement("li", _extends({}, rest, {
    className: classNames
  }), !isCompleted && !isError && !isSuccess ? _react.default.createElement("div", {
    className: "slds-progress__marker"
  }) : _react.default.createElement(_Icon.Icon, {
    size: "xx-small",
    sprite: "utility",
    icon: icon,
    className: (0, _classnames.default)('slds-progress__marker slds-progress__marker_icon', {
      'slds-progress__marker_icon-success': isSuccess
    }),
    title: assistiveText
  }), _react.default.createElement("div", {
    className: "slds-progress__item_content slds-grid slds-grid_align-spread"
  }, children || assistiveText));
};

VerticalProgressIndicatorItem.defaultProps = {
  assistiveText: null,
  className: null,
  children: null,
  isActive: false,
  isCompleted: false,
  isError: false,
  isSuccess: false
};
VerticalProgressIndicatorItem.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Assisitive text for this step
   */
  assistiveText: _propTypes.default.string,

  /**
   * Step content
   */
  children: _propTypes.default.node,

  /**
   * Additional className
   */
  className: _propTypes.default.string,

  /**
   * Whether this step is active
   */
  isActive: _propTypes.default.bool,

  /**
   * Whether this step is complete
   */
  isCompleted: _propTypes.default.bool,

  /**
   * Whether this step is succeeded
   */
  isSuccess: _propTypes.default.bool,

  /**
   * Whether this step has an error
   */
  isError: _propTypes.default.bool
} : {};
var _default = VerticalProgressIndicatorItem;
exports.default = _default;