"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getClampedProgress = getClampedProgress;

function clamp(num) {
  var min = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var max = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 100;
  return Math.min(Math.max(num, min), max);
}

function fraction(num) {
  var min = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var max = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 100;
  return (num - min) / (max - min);
}

function getClampedProgress(progress, min, max) {
  return fraction(clamp(progress, min, max), min, max) * 100;
}