"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = require("../Icon");

var _MediaObject = require("../MediaObject");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// eslint-disable-next-line react/prop-types
var defaultIconRenderer = function defaultIconRenderer(_ref) {
  var theme = _ref.theme,
      size = _ref.size;
  return _react.default.createElement(_Icon.Icon, {
    icon: "info",
    sprite: "utility",
    size: size,
    svgClassName: theme === 'dark' ? null : 'slds-icon-text-default',
    title: "information"
  });
};

var ScopedNotification = function ScopedNotification(props) {
  var children = props.children,
      className = props.className,
      renderIcon = props.renderIcon,
      theme = props.theme,
      rest = _objectWithoutProperties(props, ["children", "className", "renderIcon", "theme"]);

  var sldsClasses = ['slds-scoped-notification', _defineProperty({}, "slds-scoped-notification_".concat(theme), theme && theme !== 'base'), className];
  return _react.default.createElement(_MediaObject.MediaObject, _extends({}, rest, {
    center: true,
    className: (0, _classnames.default)(sldsClasses),
    figureLeft: renderIcon({
      theme: theme,
      size: 'small'
    }),
    role: "status"
  }), children);
};

ScopedNotification.defaultProps = {
  className: null,
  renderIcon: defaultIconRenderer,
  theme: null
};
ScopedNotification.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Notification content
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Optional className, applied to `slds-scoped-notification`
   */
  className: _propTypes.default.string,

  /**
   * Optional func. to render the notification icon. It returns an `<Icon />` by default. Params: `{ theme, size }`
   */
  renderIcon: _propTypes.default.func,

  /**
   * Notifcation theme. Passing `"base"` and `null` both maps to the default theme
   */
  theme: _propTypes.default.oneOf(['base', 'light', 'dark'])
} : {};
var _default = ScopedNotification;
exports.default = _default;