"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = require("../Button");

var _Progress = require("../Progress");

var _MediaObject = require("../MediaObject");

var _SummaryDetail = require("../SummaryDetail");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var SetupAssistantItem = function SetupAssistantItem(_ref) {
  var children = _ref.children,
      className = _ref.className,
      isOpen = _ref.isOpen,
      title = _ref.title,
      stepProgress = _ref.stepProgress,
      step = _ref.step,
      renderProgress = _ref.renderProgress,
      renderAddon = _ref.renderAddon,
      renderOpenContent = _ref.renderOpenContent,
      onOpen = _ref.onOpen,
      rest = _objectWithoutProperties(_ref, ["children", "className", "isOpen", "title", "stepProgress", "step", "renderProgress", "renderAddon", "renderOpenContent", "onOpen"]);

  var renderTitle = function renderTitle(_title) {
    return _react.default.createElement("div", {
      className: "slds-setup-assistant__step-summary"
    }, _react.default.createElement(_MediaObject.MediaObject, {
      figureLeft: renderProgress({
        stepProgress: stepProgress,
        step: step
      }),
      bodyClassName: "slds-m-top_x-small",
      center: false
    }, _react.default.createElement(_MediaObject.MediaObject, {
      figureRight: renderAddon(),
      bodyClassName: "slds-setup-assistant__step-summary-content",
      center: false
    }, _react.default.createElement("h3", {
      className: "slds-setup-assistant__step-summary-title slds-text-heading_small"
    }, onOpen ? _react.default.createElement(_Button.Button, {
      flavor: null,
      className: "slds-button_reset",
      onClick: onOpen
    }, _title) : _title), _react.default.createElement("p", null, children))));
  };

  return _react.default.createElement("li", _extends({
    className: (0, _classnames.default)('slds-setup-assistant__item', className)
  }, rest), _react.default.createElement("article", {
    className: "slds-setup-assistant__step"
  }, onOpen ? _react.default.createElement(_SummaryDetail.SummaryDetail, {
    containerClassName: "slds-container_fluid",
    iconButtonClassName: "slds-m-top_x-small",
    isOpen: isOpen,
    onOpen: onOpen,
    renderTitle: renderTitle,
    title: title
  }, renderOpenContent && function () {
    return _react.default.createElement("div", {
      className: "slds-setup-assistant__step-detail"
    }, renderOpenContent({
      isOpen: isOpen
    }));
  }) : renderTitle(title)));
};

SetupAssistantItem.defaultProps = {
  children: null,
  className: null,
  stepProgress: null,
  step: null,
  isOpen: false,
  onOpen: null,
  renderAddon: function renderAddon() {
    return null;
  },
  renderOpenContent: function renderOpenContent() {
    return null;
  },
  // eslint-disable-next-line react/prop-types
  renderProgress: function renderProgress(_ref2) {
    var stepProgress = _ref2.stepProgress,
        step = _ref2.step;
    return (step || stepProgress) && _react.default.createElement(_Progress.ProgressRing, {
      progress: stepProgress,
      status: "active-step",
      size: "large"
    }, step);
  }
};
SetupAssistantItem.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Item content
   */
  children: _propTypes.default.node,

  /**
   * Additional className
   */
  className: _propTypes.default.string,

  /**
   * Defines the expanded state
   */
  isOpen: _propTypes.default.bool,

  /**
   * Triggered on expand icon and title click
   */
  onOpen: _propTypes.default.func,

  /**
   * Function that renders the expanded content. Called when isOpen is true
   */
  renderAddon: _propTypes.default.func,

  /**
   * Renders the expanded content
   */
  renderOpenContent: _propTypes.default.func,

  /**
   * Renders the progress ring
   */
  renderProgress: _propTypes.default.func,

  /**
   * Passed to renderProgress
   */
  step: _propTypes.default.element,

  /**
   * Passed to renderProgress
   */
  stepProgress: _propTypes.default.number,

  /**
   * Step title
   */
  title: _propTypes.default.string.isRequired
} : {};
var _default = SetupAssistantItem;
exports.default = _default;