"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _SpinnerContainer = _interopRequireDefault(require("./SpinnerContainer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Spinner = function Spinner(props) {
  var assistiveLabel = props.assistiveLabel,
      className = props.className,
      container = props.container,
      delayed = props.delayed,
      flavor = props.flavor,
      inline = props.inline,
      size = props.size,
      rest = _objectWithoutProperties(props, ["assistiveLabel", "className", "container", "delayed", "flavor", "inline", "size"]);

  var baseClass = 'slds-spinner';
  var sldsClasses = [baseClass, _defineProperty({}, "".concat(baseClass, "_").concat(size), !!size), _defineProperty({}, "".concat(baseClass, "_").concat(flavor), !!flavor), _defineProperty({}, "".concat(baseClass, "_delayed"), !!delayed), _defineProperty({}, "".concat(baseClass, "_inline"), !!inline), className];

  var spinner = _react.default.createElement("div", _extends({}, rest, {
    role: "status",
    className: (0, _classnames.default)(sldsClasses)
  }), _react.default.createElement("span", {
    className: "slds-assistive-text"
  }, assistiveLabel), _react.default.createElement("div", {
    className: "slds-spinner__dot-a"
  }), _react.default.createElement("div", {
    className: "slds-spinner__dot-b"
  }));

  if (container) return _react.default.createElement(_SpinnerContainer.default, null, spinner);
  return spinner;
};

Spinner.defaultProps = {
  assistiveLabel: 'Loading',
  className: null,
  container: false,
  delayed: false,
  flavor: null,
  inline: false,
  size: 'medium'
};
Spinner.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Label that will be shown on hover
   */
  assistiveLabel: _propTypes.default.string,

  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * convenience prop to wrap Spinner in SpinnerContainer
   */
  container: _propTypes.default.bool,

  /**
   * Adds a 300ms start delay
   */
  delayed: _propTypes.default.bool,

  /**
   * Flavor. Can be either 'brand' or 'inverse'
   */
  flavor: _propTypes.default.oneOf(['brand', 'inverse']),

  /**
   * inline variation
   */
  inline: _propTypes.default.bool,

  /**
   * spinner sizes: xx-small, x-small, small, medium, large
   */
  size: _propTypes.default.oneOf(['xx-small', 'x-small', 'small', 'medium', 'large'])
} : {};
var _default = Spinner;
exports.default = _default;