"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ControlledSplitView = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ToggleButton = require("./ToggleButton");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FULL_HEIGHT = {
  height: '100%'
};
var DETAIL_VIEW_STYLE = {
  marginLeft: _ToggleButton.TOGGLE_BUTTON_WIDTH
};

var ControlledSplitView =
/*#__PURE__*/
function (_Component) {
  _inherits(ControlledSplitView, _Component);

  function ControlledSplitView() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ControlledSplitView);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ControlledSplitView)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "getMasterViewId", function () {
      var id = _this.props.id;
      return "master_view_".concat(id);
    });

    _defineProperty(_assertThisInitialized(_this), "toggle", function () {
      var _this$props = _this.props,
          isOpen = _this$props.isOpen,
          onOpen = _this$props.onOpen,
          onClose = _this$props.onClose;

      if (isOpen) {
        onClose();
      } else {
        onOpen();
      }
    });

    return _this;
  }

  _createClass(ControlledSplitView, [{
    key: "renderMasterView",
    value: function renderMasterView() {
      var _this$props2 = this.props,
          isOpen = _this$props2.isOpen,
          master = _this$props2.master;
      return isOpen && _react.default.createElement("article", {
        id: this.getMasterViewId(),
        className: "slds-split-view slds-grid slds-grid_vertical slds-grow slds-scrollable_none"
      }, master);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          assistiveTextOpen = _this$props3.assistiveTextOpen,
          assistiveTextClose = _this$props3.assistiveTextClose,
          className = _this$props3.className,
          detail = _this$props3.detail,
          id = _this$props3.id,
          isOpen = _this$props3.isOpen,
          masterMaxWidth = _this$props3.masterMaxWidth,
          masterMinWidth = _this$props3.masterMinWidth;
      var masterStyle = isOpen ? {
        maxWidth: masterMaxWidth,
        minWidth: masterMinWidth
      } : null;
      return _react.default.createElement("div", {
        id: id,
        className: (0, _classnames.default)('slds-grid', className),
        style: FULL_HEIGHT
      }, _react.default.createElement("div", {
        style: masterStyle,
        className: (0, _classnames.default)('slds-split-view_container', {
          'slds-is-open': isOpen
        }, {
          'slds-is-closed': !isOpen
        })
      }, _react.default.createElement(_ToggleButton.ToggleButton, {
        ariaControls: this.getMasterViewId(),
        assistiveTextOpen: assistiveTextOpen,
        assistiveTextClose: assistiveTextClose,
        isOpen: isOpen,
        onClick: this.toggle
      }), this.renderMasterView()), _react.default.createElement("div", {
        style: DETAIL_VIEW_STYLE,
        className: "slds-grow slds-scrollable_y"
      }, detail));
    }
  }]);

  return ControlledSplitView;
}(_react.Component);

exports.ControlledSplitView = ControlledSplitView;

_defineProperty(ControlledSplitView, "defaultProps", {
  assistiveTextOpen: '',
  assistiveTextClose: '',
  className: null,
  masterMaxWidth: '20rem',
  masterMinWidth: '20rem'
});

ControlledSplitView.propTypes = process.env.NODE_ENV !== "production" ? {
  assistiveTextOpen: _propTypes.default.string,
  assistiveTextClose: _propTypes.default.string,
  className: _propTypes.default.string,
  detail: _propTypes.default.node.isRequired,
  id: _propTypes.default.string.isRequired,
  master: _propTypes.default.node.isRequired,
  masterMaxWidth: _propTypes.default.string,
  masterMinWidth: _propTypes.default.string,
  onOpen: _propTypes.default.func.isRequired,
  onClose: _propTypes.default.func.isRequired,
  isOpen: _propTypes.default.bool.isRequired
} : {};