"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ToggleButton = exports.TOGGLE_BUTTON_WIDTH = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = require("../Icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TOGGLE_BUTTON_WIDTH = '0.75rem';
exports.TOGGLE_BUTTON_WIDTH = TOGGLE_BUTTON_WIDTH;
var NO_SHADOW = {
  boxShadow: 'none'
};

var ToggleButton = function ToggleButton(_ref) {
  var ariaControls = _ref.ariaControls,
      assistiveTextOpen = _ref.assistiveTextOpen,
      assistiveTextClose = _ref.assistiveTextClose,
      isOpen = _ref.isOpen,
      onClick = _ref.onClick;
  var assistiveText = isOpen ? assistiveTextOpen : assistiveTextClose;
  var buttonClassName = (0, _classnames.default)('slds-button slds-button_icon slds-split-view__toggle-button', {
    'slds-is-open': isOpen
  });
  return _react.default.createElement("button", {
    "aria-controls": ariaControls,
    "aria-expanded": isOpen,
    className: buttonClassName,
    onClick: onClick,
    style: NO_SHADOW,
    title: assistiveText,
    type: "button"
  }, _react.default.createElement(_Icon.IconSVG, {
    className: "slds-button__icon slds-button__icon_x-small"
    /* SLDS applies rotate tranform to this icon,
       so we don't need to change icon itself
     */
    ,
    icon: "left",
    isButton: true,
    sprite: "utility"
  }), _react.default.createElement("span", {
    className: "slds-assistive-text"
  }, assistiveText));
};

exports.ToggleButton = ToggleButton;
ToggleButton.propTypes = process.env.NODE_ENV !== "production" ? {
  ariaControls: _propTypes.default.string.isRequired,
  assistiveTextOpen: _propTypes.default.string.isRequired,
  assistiveTextClose: _propTypes.default.string.isRequired,
  isOpen: _propTypes.default.bool.isRequired,
  onClick: _propTypes.default.func.isRequired
} : {};