"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = require("../Button");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SummaryDetail = function SummaryDetail(_ref) {
  var children = _ref.children,
      containerClassName = _ref.containerClassName,
      iconButtonClassName = _ref.iconButtonClassName,
      isOpen = _ref.isOpen,
      onOpen = _ref.onOpen,
      renderTitle = _ref.renderTitle,
      title = _ref.title;
  return _react.default.createElement("div", {
    className: (0, _classnames.default)('slds-summary-detail', {
      'slds-is-open': isOpen
    })
  }, onOpen && _react.default.createElement(_Button.IconButton, {
    onClick: onOpen,
    className: (0, _classnames.default)('slds-m-right_x-small', iconButtonClassName)
  }, _react.default.createElement(_Button.ButtonIcon, {
    className: "slds-summary-detail__action-icon",
    icon: "switch",
    sprite: "utility"
  })), _react.default.createElement("div", {
    className: (0, _classnames.default)(containerClassName)
  }, _react.default.createElement("div", {
    className: "slds-summary-detail__title"
  }, renderTitle(title)), children && _react.default.createElement("div", {
    "aria-hidden": !isOpen,
    className: "slds-summary-detail__content"
  }, children({
    isOpen: isOpen
  }))));
};

SummaryDetail.defaultProps = {
  children: null,
  containerClassName: null,
  iconButtonClassName: null,
  isOpen: false,
  onOpen: null,
  renderTitle: function renderTitle(title) {
    return _react.default.createElement("h3", {
      className: "slds-text-heading_small slds-truncate"
    }, title);
  }
};
SummaryDetail.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Function that renders the content. Takes { isOpen } as arguments
   */
  children: _propTypes.default.func,

  /**
   * Additional className for container
   */
  containerClassName: _propTypes.default.string,

  /**
   * Additional className for the expand icon
   */
  iconButtonClassName: _propTypes.default.string,

  /**
   * Whether the content is expanded
   */
  isOpen: _propTypes.default.bool,

  /**
   * Triggered on open icon and title click
   */
  onOpen: _propTypes.default.func,

  /**
   * Renders custom title markup if provided. Receives title as an argument
   */
  renderTitle: _propTypes.default.func,

  /**
   * Title to be used by the renderTitle function
   */
  title: _propTypes.default.string.isRequired
} : {};
var _default = SummaryDetail;
exports.default = _default;