"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Row = _react.default.forwardRef(function (props, ref) {
  var children = props.children,
      className = props.className,
      sticky = props.sticky,
      variation = props.variation,
      style = props.style,
      rest = _objectWithoutProperties(props, ["children", "className", "sticky", "variation", "style"]);

  var rowStyle = sticky ? _objectSpread({}, Row.STICKY_SCROLLED_STYLE, {}, style) : style;
  var variationClasses = Array.isArray(variation) ? variation.map(function (f) {
    return "slds-".concat(f);
  }) : "slds-".concat(variation);
  return _react.default.createElement("tr", _extends({}, rest, {
    className: (0, _classnames.default)([variationClasses, className]),
    ref: ref,
    style: rowStyle
  }), children);
});

Row.STICKY_SCROLLED_STYLE = {
  position: 'sticky',
  top: 0,
  zIndex: 1
};
Row.defaultProps = {
  children: null,
  className: null,
  sticky: false,
  style: {},
  variation: []
};
Row.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * row content
   */
  children: _propTypes.default.node,

  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * Should only be set for rows nested in thead. Sets `position:sticky` to attach to top of the scrolling ctx
   */
  sticky: _propTypes.default.bool,
  style: _propTypes.default.object,

  /**
   * variation: string or array of strings. Variations: is-selected, hint-parent
   */
  variation: _propTypes.default.oneOfType([_propTypes.default.oneOf(['is-selected', 'hint-parent']), _propTypes.default.arrayOf(_propTypes.default.oneOf(['is-selected', 'hint-parent']))])
} : {};
var _default = Row;
exports.default = _default;