"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.propTypes = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Table = function Table(props) {
  var children = props.children,
      className = props.className,
      flavor = props.flavor,
      stickyHeader = props.stickyHeader,
      variation = props.variation,
      rest = _objectWithoutProperties(props, ["children", "className", "flavor", "stickyHeader", "variation"]);

  var sldsClasses = ['slds-table', 'slds-table_cell-buffer', className, (0, _utils.applyDecorators)(flavor, 'table'), (0, _utils.applyDecorators)(variation)];
  return _react.default.createElement("table", _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses)
  }), children);
}; // https://github.com/oliviertassinari/babel-plugin-transform-react-remove-prop-types#is-it-safe


var propTypes = {
  /**
   * table content
   */
  children: _propTypes.default.node,

  /**
   * class name
   */
  className: _propTypes.default.string,

  /**
   * flavor: array of flavors, you can also provide a single flavor string.
   * Flavors: bordered, col-bordered, striped, fixed-layout
   */
  flavor: (0, _utils.decoratorProp)(['bordered', 'col-bordered', 'striped', 'fixed-layout', 'header-hidden']),

  /**
   * Make table header stick to the top
   */
  stickyHeader: _propTypes.default.bool,

  /**
   * variation: array of variations, you can also provide a single variation string.
   * Variations: no-row-hover, max-medium-table_stacked,
   max-medium-table_stacked-horizontal
   */
  variation: (0, _utils.decoratorProp)(['no-row-hover', 'max-medium-table_stacked', 'max-medium-table_stacked-horizontal'])
};
exports.propTypes = propTypes;
Table.defaultProps = {
  children: null,
  className: null,
  flavor: [],
  stickyHeader: false,
  variation: []
};
Table.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
var _default = Table;
exports.default = _default;