"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Tab = function Tab(props) {
  var children = props.children,
      className = props.className,
      id = props.id,
      isActive = props.isActive,
      scoped = props.scoped,
      _ = props.renderTitle,
      __ = props.title,
      rest = _objectWithoutProperties(props, ["children", "className", "id", "isActive", "scoped", "renderTitle", "title"]);

  return _react.default.createElement("div", _extends({}, rest, {
    "aria-labelledby": (0, _utils.getAriaLabel)(id),
    className: (0, _classnames.default)((0, _utils.getTabsClass)('__content', scoped), isActive ? 'slds-show' : 'slds-hide'),
    id: id,
    role: "tabpanel"
  }), isActive === null ? null : children);
};

Tab.defaultProps = {
  className: null,
  isActive: false,
  renderTitle: null,
  scoped: false
};
Tab.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Tab content
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Additional classes
   */
  className: _propTypes.default.string,

  /**
   * Unique id, used to reference navigation
   */
  id: _propTypes.default.string.isRequired,

  /**
   * Function to render `title`. Called with ({ id, isActive, isFocused, title})
   */
  renderTitle: _propTypes.default.func,

  /**
   * Title in Navigation
   */
  title: _propTypes.default.string.isRequired,

  /**
   * (PRIVATE) Set by parent Tabs
   */
  isActive: _propTypes.default.bool,

  /**
   * (PRIVATE) Set by parent Tabs
   */
  scoped: _propTypes.default.bool
} : {};
var _default = Tab;
exports.default = _default;