"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _MediaObject = require("../MediaObject");

var _Title = _interopRequireDefault(require("./components/Title"));

var _TitleRow = _interopRequireDefault(require("./components/TitleRow"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Tile = function Tile(props) {
  var as = props.as,
      board = props.board,
      children = props.children,
      className = props.className,
      action = props.action,
      figure = props.figure,
      title = props.title,
      titleText = props.titleText,
      rest = _objectWithoutProperties(props, ["as", "board", "children", "className", "action", "figure", "title", "titleText"]);

  var tileClasses = (0, _classnames.default)(['slds-tile', {
    'slds-tile_board': board
  }, {
    'slds-hint-parent': !!action
  }, className]);

  var tileContent = _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_TitleRow.default, {
    action: action
  }, _react.default.createElement(_Title.default, {
    title: title,
    titleText: titleText
  })), _react.default.createElement("div", {
    className: "slds-tile__detail"
  }, children));

  if (figure) {
    return _react.default.createElement(_MediaObject.MediaObject, _extends({}, rest, {
      as: as,
      center: false,
      className: tileClasses,
      figureLeft: figure
    }), tileContent);
  }

  var El = as;
  return _react.default.createElement(El, _extends({}, rest, {
    className: tileClasses
  }), tileContent);
};

Tile.defaultProps = {
  as: 'article',
  board: false,
  className: null,
  figure: null,
  action: null,
  titleText: ''
};
Tile.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * HTML element name
   */
  as: _propTypes.default.string,

  /**
   * adds `slds-tile_board` modifier
   */
  board: _propTypes.default.bool,

  /**
   * `Tile` content
   */
  children: _propTypes.default.node.isRequired,

  /**
   * additional class names, added to `.slds-tile`
   */
  className: _propTypes.default.string,

  /**
   * action that renders on the right side of the tile
   */
  action: _propTypes.default.node,

  /**
   * figure (Icon,Avatar,Checkbox) that renders on the left side of the tile
   */
  figure: _propTypes.default.node,

  /**
   * title node
   */
  title: _propTypes.default.node.isRequired,

  /**
   * fallback `title` attribute for `.slds-tile__title` if `title` is not a string
   */
  titleText: _propTypes.default.string
} : {};
var _default = Tile;
exports.default = _default;