"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.POSITIONS = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactPopper = require("react-popper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ELEMENT_STYLE = {
  display: 'inline-block'
};
var POSITIONS = ['top', 'top-start', 'top-end', 'left', 'right', 'bottom', 'bottom-start', 'bottom-end'];
exports.POSITIONS = POSITIONS;

var getNubbin = function getNubbin(position) {
  var nubbinMap = {
    bottom: 'top',
    left: 'right',
    right: 'left',
    top: 'bottom',
    end: 'right',
    start: 'left'
  };
  return position.split('-').map(function (x) {
    return nubbinMap[x];
  }).join('-');
};

var getPopperProps = function getPopperProps(position, customOffset) {
  var offset;

  if (!customOffset) {
    if (position === 'left' || position === 'right') {
      offset = '0, 16';
    } else if (position.endsWith('start')) {
      offset = '-16, 16';
    } else if (position.endsWith('end')) {
      offset = '16, 16';
    } else {
      offset = '0, 16';
    }
  } else {
    offset = customOffset;
  }

  return {
    placement: position,
    positionFixed: true,
    modifiers: {
      offset: {
        enabled: true,
        offset: offset
      },
      flip: {
        enabled: true,
        boundariesElement: 'window',
        padding: 0
      },
      preventOverflow: {
        enabled: true,
        boundariesElement: 'window',
        padding: 0
      }
    }
  };
};

var ControlledTooltip =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(ControlledTooltip, _PureComponent);

  function ControlledTooltip() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ControlledTooltip);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ControlledTooltip)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "renderPopper", function () {
      var _this$props = _this.props,
          className = _this$props.className,
          id = _this$props.id,
          isOpen = _this$props.isOpen,
          offset = _this$props.offset,
          position = _this$props.position,
          renderTitle = _this$props.renderTitle,
          title = _this$props.title;
      var popoverClasses = (0, _classnames.default)(['slds-popover', 'slds-popover_tooltip', "slds-nubbin_".concat(getNubbin(position)), className]);
      return _react.default.createElement(_reactPopper.Popper, getPopperProps(position, offset), function (_ref) {
        var placement = _ref.placement,
            ref = _ref.ref,
            style = _ref.style;
        if (!isOpen) return null;
        return _react.default.createElement("div", {
          className: popoverClasses,
          id: id,
          ref: ref,
          role: "tooltip",
          style: style,
          "data-placement": placement
        }, _react.default.createElement("div", {
          className: "slds-popover__body"
        }, renderTitle ? renderTitle(title) : title));
      });
    });

    _defineProperty(_assertThisInitialized(_this), "render", function () {
      var _this$props2 = _this.props,
          children = _this$props2.children,
          id = _this$props2.id,
          onOpen = _this$props2.onOpen,
          onClose = _this$props2.onClose,
          portalSelector = _this$props2.portalSelector;
      var popper = portalSelector ? _reactDom.default.createPortal(_this.renderPopper(), document.querySelector(portalSelector)) : _this.renderPopper();
      return _react.default.createElement(_reactPopper.Manager, null, _react.default.createElement(_reactPopper.Reference, null, function (_ref2) {
        var ref = _ref2.ref;
        return _react.default.createElement("div", {
          "aria-describedby": id,
          onMouseEnter: onOpen,
          onFocus: onOpen,
          onMouseLeave: onClose,
          onBlur: onClose,
          ref: ref,
          style: ELEMENT_STYLE
        }, children);
      }), popper);
    });

    return _this;
  }

  return ControlledTooltip;
}(_react.PureComponent);

ControlledTooltip.defaultProps = {
  className: null,
  isOpen: true,
  offset: null,
  onOpen: null,
  onClose: null,
  portalSelector: null,
  position: 'top-start',
  renderTitle: null
};
ControlledTooltip.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Will be wrapped with a div referencing the tooltip
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Optional className applied to the slds-popover element
   */
  className: _propTypes.default.string,

  /**
   * Id linking the popover to the reference
   */
  id: _propTypes.default.string.isRequired,

  /**
   * Controls whether the popover is visible
   */
  isOpen: _propTypes.default.bool,

  /**
   * Allows you to set popper offsets manually
   * Usage: https://popper.js.org/popper-documentation.html#modifiers..offset
   */
  offset: _propTypes.default.string,

  /**
   * Function toggled when hovering or focussing the reference
   */
  onOpen: _propTypes.default.func,

  /**
   * Function toggled when blurring the reference (when open)
   */
  onClose: _propTypes.default.func,

  /**
   * If set, use element with this selector as Portal for Popper
   */
  portalSelector: _propTypes.default.string,

  /**
   * Position of the popover. The popover will move if it hits a window boundary
   */
  position: _propTypes.default.oneOf(POSITIONS),

  /**
   * Function that renders `title` if set. Is passed the `title` prop
   */
  renderTitle: _propTypes.default.func,

  /**
   * Static title property
   */
  title: _propTypes.default.oneOfType([_propTypes.default.element, _propTypes.default.string]).isRequired
} : {};
var _default = ControlledTooltip;
exports.default = _default;