"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var VerticalNavigation = function VerticalNavigation(props) {
  var children = props.children,
      className = props.className,
      flavor = props.flavor,
      prependElement = props.prependElement,
      rest = _objectWithoutProperties(props, ["children", "className", "flavor", "prependElement"]);

  var sldsClasses = ['slds-nav-vertical', className, (0, _utils.applyDecorators)(flavor, 'nav-vertical')];
  return _react.default.createElement("nav", _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses)
  }), prependElement, children);
};

VerticalNavigation.defaultProps = {
  className: null,
  flavor: [],
  prependElement: null
};
VerticalNavigation.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * One or more VerticalNavigationSection or VerticalNavigationOverflow elements
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Classname to be applied to the parent
   */
  className: _propTypes.default.string,

  /**
   * flavor: array of flavors, you can also provide a single flavor as a string.
   * Flavors: compact, shade
   */
  flavor: (0, _utils.decoratorProp)(['compact', 'shade']),

  /**
   * Element that will be rendered above the navigation
   */
  prependElement: _propTypes.default.element
} : {};
var _default = VerticalNavigation;
exports.default = _default;