"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = require("../Button");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var getToggleHandler = function getToggleHandler(state, fn) {
  return function (evt) {
    return fn(!state, evt);
  };
};

var VerticalNavigationOverflow = function VerticalNavigationOverflow(props) {
  var children = props.children,
      className = props.className,
      id = props.id,
      isOpen = props.isOpen,
      labelOpen = props.labelOpen,
      labelClosed = props.labelClosed,
      onToggle = props.onToggle,
      title = props.title,
      rest = _objectWithoutProperties(props, ["children", "className", "id", "isOpen", "labelOpen", "labelClosed", "onToggle", "title"]);

  var renderChild = function renderChild(child) {
    return _react.default.cloneElement(child, {
      'aria-describedby': id
    });
  };

  var sldsClasses = ['slds-nav-vertical__overflow', className];
  return _react.default.createElement("div", _extends({
    className: (0, _classnames.default)(sldsClasses)
  }, rest), _react.default.createElement(_Button.Button, {
    icon: "chevronright",
    sprite: "utility",
    className: "slds-button_reset slds-nav-vertical__action slds-nav-vertical__action_overflow",
    flavor: null,
    onClick: getToggleHandler(isOpen, onToggle),
    "aria-controls": id,
    "aria-expanded": isOpen
  }, _react.default.createElement("span", {
    className: "slds-nav-vertical__action-text"
  }, isOpen ? labelOpen : labelClosed, _react.default.createElement("span", {
    className: "slds-assistive-text"
  }, title))), _react.default.createElement("div", {
    id: id,
    className: isOpen ? 'slds-show' : 'slds-hide'
  }, _react.default.createElement("ul", null, _react.default.Children.map(children, renderChild))));
};

VerticalNavigationOverflow.defaultProps = {
  className: null,
  labelOpen: 'Show less',
  labelClosed: 'Show more'
};
VerticalNavigationOverflow.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * One or more VerticalNavigationItem
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Classname to be applied to the parent
   */
  className: _propTypes.default.string,

  /**
   * Id of title, will relate children to parent
   */
  id: _propTypes.default.string.isRequired,

  /**
   * Button text when open
   */
  labelOpen: _propTypes.default.string,

  /**
   * Button text when closed
   */
  labelClosed: _propTypes.default.string,

  /**
   * Open state of overflow
   */
  isOpen: _propTypes.default.bool.isRequired,

  /**
   * Button click callback, called with: (nextState, evt)
   */
  onToggle: _propTypes.default.func.isRequired,

  /**
   * Parent section title, accessibility only
   */
  title: _propTypes.default.string.isRequired
} : {};
var _default = VerticalNavigationOverflow;
exports.default = _default;