"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var VerticalNavigationSection = function VerticalNavigationSection(props) {
  var children = props.children,
      className = props.className,
      id = props.id,
      title = props.title,
      rest = _objectWithoutProperties(props, ["children", "className", "id", "title"]);

  var sldsClasses = ['slds-nav-vertical__section', className];

  var renderChild = function renderChild(child) {
    return _react.default.cloneElement(child, {
      'aria-describedby': id
    });
  };

  return _react.default.createElement("div", _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses)
  }), _react.default.createElement("h2", {
    className: "slds-nav-vertical__title",
    id: id
  }, title), _react.default.createElement("ul", null, _react.default.Children.map(children, renderChild)));
};

VerticalNavigationSection.defaultProps = {
  className: null
};
VerticalNavigationSection.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * One or more VerticalNavigationItem
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Classname to be applied to the parent
   */
  className: _propTypes.default.string,

  /**
   * Id of title, will relate children to parent
   */
  id: _propTypes.default.string.isRequired,

  /**
   * Section title
   */
  title: _propTypes.default.string.isRequired
} : {};
var _default = VerticalNavigationSection;
exports.default = _default;