"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Form = require("../Form");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var VisualPicker = function VisualPicker(props) {
  var caption = props.caption,
      children = props.children,
      className = props.className,
      disabled = props.disabled,
      id = props.id,
      inputProps = props.inputProps,
      size = props.size,
      type = props.type,
      rest = _objectWithoutProperties(props, ["caption", "children", "className", "disabled", "id", "inputProps", "size", "type"]);

  var sldsClasses = ['slds-visual-picker', "slds-visual-picker_".concat(size), className];
  return _react.default.createElement("div", _extends({}, rest, {
    className: (0, _classnames.default)(sldsClasses)
  }), _react.default.createElement(_Form.InputRaw, _extends({}, inputProps, {
    disabled: disabled,
    id: id,
    type: type,
    value: id,
    name: "options"
  })), _react.default.createElement("label", {
    htmlFor: id
  }, children, caption));
};

VisualPicker.defaultProps = {
  caption: null,
  className: null,
  disabled: false,
  inputProps: {},
  size: 'medium',
  type: 'radio'
};
VisualPicker.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Caption element rendered underneath the tile. Should be `VisualPickerTileCaption`
   */
  caption: _propTypes.default.element,

  /**
   * Tile content. Should either be: `VisualPickerText` or `VisualPickerIcon`
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Optional className applied to wrapper `div`
   */
  className: _propTypes.default.string,

  /**
   * Disabled state for input
   */
  disabled: _propTypes.default.bool,

  /**
   * Input id
   */
  id: _propTypes.default.string.isRequired,

  /**
   * Additional input props. `name`, `value`, `type` and `id` are overwritten
   */
  inputProps: _propTypes.default.object,

  /**
   * Tile size
   */
  size: _propTypes.default.oneOf(['medium', 'large']),

  /**
   * Input type. Should be the same for all tiles in one `VisualPickerContainer`
   */
  type: _propTypes.default.oneOf(['radio', 'checkbox'])
} : {};
var _default = VisualPicker;
exports.default = _default;