"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _MediaObject = require("../MediaObject");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var linkIconRenderer = function linkIconRenderer(figure, classes) {
  return _react.default.createElement("div", {
    className: (0, _classnames.default)([].concat(_toConsumableArray(classes), ['slds-media__figure_fixed-width', 'slds-align_absolute-center', 'slds-m-left_xx-small']))
  }, figure);
};

var VisualPickerLink = function VisualPickerLink(_ref) {
  var className = _ref.className,
      children = _ref.children,
      href = _ref.href,
      icon = _ref.icon,
      title = _ref.title,
      rest = _objectWithoutProperties(_ref, ["className", "children", "href", "icon", "title"]);

  var sldsClasses = ['slds-box', 'slds-box_link', 'slds-box_x-small', className];
  return _react.default.createElement(_MediaObject.MediaObject, _extends({}, rest, {
    center: false,
    as: "a" // eslint-disable-next-line no-script-url
    ,
    href: href || 'javascript:void(0)',
    bodyClassName: "slds-border_left slds-p-around_small",
    className: (0, _classnames.default)(sldsClasses),
    figureLeft: icon,
    renderFigureLeft: linkIconRenderer
  }), _react.default.createElement("h2", {
    className: "slds-truncate slds-text-heading_small",
    title: title
  }, title), _react.default.createElement("p", {
    className: "slds-m-top_small"
  }, children));
};

VisualPickerLink.defaultProps = {
  className: null,
  href: null
};
VisualPickerLink.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Optional className applied to `slds-box`
   */
  className: _propTypes.default.string,

  /**
   * Flow content
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Link target. If you need to support a routing library, leave empty and apply `onClick`
   */
  href: _propTypes.default.string,

  /**
   * Icon rendered on the left. May need to have `svgClassName="slds-icon-text-default"` set for icons from the utility sprite
   */
  icon: _propTypes.default.element.isRequired,

  /**
   * Title renderd as `heading_small`
   */
  title: _propTypes.default.string.isRequired
} : {};
var _default = VisualPickerLink;
exports.default = _default;