"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = require("../Icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var VisualPickerTileIcon = function VisualPickerTileIcon(_ref) {
  var className = _ref.className,
      icon = _ref.icon,
      sprite = _ref.sprite;
  var figureClasses = ['slds-visual-picker__figure', 'slds-visual-picker__icon', {
    'slds-visual-picker__text': false
  }, 'slds-align_absolute-center', className];
  return _react.default.createElement("span", {
    className: (0, _classnames.default)(figureClasses)
  }, _react.default.createElement("span", {
    className: "slds-is-selected"
  }, _react.default.createElement(_Icon.Icon, {
    icon: "check",
    size: "large",
    sprite: "action"
  })), _react.default.createElement("span", {
    className: "slds-is-not-selected"
  }, _react.default.createElement(_Icon.Icon, {
    icon: icon,
    sprite: sprite,
    svgClassName: sprite === 'utility' ? 'slds-icon-text-default' : null,
    size: "large"
  })));
};

VisualPickerTileIcon.defaultProps = {
  className: null
};
VisualPickerTileIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Optional className, applied to `slds-visual-picker__figure`
   */
  className: _propTypes.default.string,

  /**
   * Icon name
   */
  icon: _propTypes.default.string.isRequired,

  /**
   * Sprite name
   */
  sprite: _propTypes.default.string.isRequired
} : {};
var _default = VisualPickerTileIcon;
exports.default = _default;