"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _VisualPicker = _interopRequireDefault(require("./VisualPicker"));

var _VisualPickerTileText = _interopRequireDefault(require("./VisualPickerTileText"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var VisualPickerVertical = function VisualPickerVertical(_ref) {
  var children = _ref.children,
      className = _ref.className,
      title = _ref.title,
      rest = _objectWithoutProperties(_ref, ["children", "className", "title"]);

  return _react.default.createElement(_VisualPicker.default, _extends({}, rest, {
    className: (0, _classnames.default)('slds-visual-picker_vertical', className),
    caption: null,
    size: null
  }), _react.default.createElement(_VisualPickerTileText.default, {
    title: title
  }, children));
};

VisualPickerVertical.defaultProps = {
  className: null
};
VisualPickerVertical.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Text content of `VisualPickerTileText`
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Optional className applied to `slds-visual-picker`
   */
  className: _propTypes.default.string,

  /**
   * Title of `VisualPickerTileText`
   */
  title: _propTypes.default.string.isRequired
} : {};
var _default = VisualPickerVertical;
exports.default = _default;