"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Modal = require("../Modal");

var _WelcomeMatContent = _interopRequireDefault(require("./components/WelcomeMatContent"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var WelcomeMat = function WelcomeMat(_ref) {
  var id = _ref.id,
      isOpen = _ref.isOpen,
      onClose = _ref.onClose,
      rest = _objectWithoutProperties(_ref, ["id", "isOpen", "onClose"]);

  return _react.default.createElement(_Modal.Modal, {
    id: id,
    open: isOpen,
    onClose: onClose,
    size: "small"
  }, _react.default.createElement(_Modal.ModalContent, {
    collapsePadding: true
  }, _react.default.createElement(_WelcomeMatContent.default, _extends({}, rest, {
    id: id,
    onClose: onClose
  }))));
};

WelcomeMat.defaultProps = {
  isOpen: false
};
WelcomeMat.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Identifier for `Modal`, ties to `WelcomeMat` title
   */
  id: _propTypes.default.string.isRequired,

  /**
   * Controls `isOpen` state of the underlying `Modal`
   */
  isOpen: _propTypes.default.bool,

  /**
   * Passed to `Modal` & `WelcomeMatContent`
   */
  onClose: _propTypes.default.func.isRequired
} : {};
var _default = WelcomeMat;
exports.default = _default;