"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WelcomeMatStep = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _constants = require("../constants");

var _Icon = require("../../Icon");

var _MediaObject = require("../../MediaObject");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var renderFigure = function renderFigure(figure, classes) {
  return _react.default.createElement("div", {
    className: _classnames.default.apply(void 0, _toConsumableArray(classes).concat(['slds-media__figure_fixed-width', 'slds-align_absolute-center']))
  }, figure);
};

var WelcomeMatStep = function WelcomeMatStep(_ref) {
  var isInfoOnly = _ref.isInfoOnly,
      onComplete = _ref.onComplete,
      step = _ref.step;
  var description = step.description,
      icon = step.icon,
      id = step.id,
      isCompleted = step.isCompleted,
      sprite = step.sprite,
      title = step.title;
  var isComplete = !isInfoOnly && isCompleted;
  var sldsClasses = ['slds-welcome-mat__tile', {
    'slds-welcome-mat__tile_info-only': isInfoOnly
  }, {
    'slds-welcome-mat__tile_complete': isComplete
  }];

  var iconEl = _react.default.createElement(_Icon.Icon, {
    sprite: sprite,
    icon: icon,
    svgClassName: "slds-icon-text-default"
  });

  return _react.default.createElement("li", {
    className: (0, _classnames.default)(sldsClasses)
  }, _react.default.createElement(_MediaObject.MediaObject, {
    as: isInfoOnly ? 'div' : 'a',
    className: isInfoOnly ? null : 'slds-box slds-box_link',
    href: isInfoOnly ? undefined : 'javascript:void(0)',
    center: false,
    "data-target-id": id,
    onClick: isInfoOnly ? null : onComplete,
    responsive: false,
    renderFigureLeft: renderFigure,
    figureLeft: _react.default.createElement("div", {
      className: "slds-welcome-mat__tile-figure"
    }, isComplete ? _react.default.createElement("div", {
      className: "slds-welcome-mat__tile-icon-container"
    }, iconEl, _react.default.createElement(_Icon.Icon, {
      className: "slds-icon_container_circle",
      icon: "check",
      sprite: "action",
      svgClassName: "slds-welcome-mat__icon-check"
    })) : iconEl)
  }, _react.default.createElement("div", {
    className: "slds-welcome-mat__tile-body"
  }, _react.default.createElement("h3", {
    className: "slds-welcome-mat__tile-title"
  }, title), _react.default.createElement("p", {
    className: "slds-welcome-mat__tile-description"
  }, description))));
};

exports.WelcomeMatStep = WelcomeMatStep;
WelcomeMatStep.defaultProps = {
  onComplete: null
};
WelcomeMatStep.propTypes = process.env.NODE_ENV !== "production" ? {
  isInfoOnly: _propTypes.default.bool.isRequired,
  onComplete: _propTypes.default.func,
  step: _constants.stepType.isRequired
} : {};