"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.hashFromString = void 0;

var hashFromString = function hashFromString(str) {
  if (!str || typeof str !== 'string' || str.length === 0) {
    return null;
  }

  var hash = 0;

  for (var i = 0; i < str.length; i += 1) {
    var char = str.charCodeAt(i);
    /* eslint-disable no-bitwise */

    hash = (hash << 5) - hash + char;
    hash &= hash; // Convert to 32bit integer
  }

  return hash;
};

exports.hashFromString = hashFromString;

var getUniqueHash = function getUniqueHash(str, id) {
  return "".concat(id, "-").concat(hashFromString(str));
};

var _default = getUniqueHash;
exports.default = _default;