"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getThemeClass = getThemeClass;
exports.THEMES = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var themeNames = ['alt-inverse', 'default', 'error', 'info', 'inverse', 'offline', 'shade', 'success', 'warning'];
var THEMES = themeNames.reduce(function (acc, curr) {
  return [].concat(_toConsumableArray(acc), [curr, "".concat(curr, " texture")]);
}, []);
exports.THEMES = THEMES;

function getThemeClass(theme) {
  var classes = [];

  if (/\stexture/.test(theme)) {
    classes.push("slds-theme_".concat(theme.split(' ')[0]));
    classes.push('slds-theme_alert-texture');
  } else if (theme) {
    classes.push("slds-theme_".concat(theme));
  }

  return classes;
}