import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Button, IconButton } from '../Button';

var AccordionSection = function AccordionSection(props) {
  var children = props.children,
      className = props.className,
      id = props.id,
      isOpen = props.isOpen,
      summary = props.summary,
      summaryOnClick = props.summaryOnClick,
      rest = _objectWithoutProperties(props, ["children", "className", "id", "isOpen", "summary", "summaryOnClick"]);

  var liClasses = ['slds-accordion__list-item', className];
  var sectionClasses = ['slds-accordion__section', {
    'slds-is-open': isOpen
  }];
  return React.createElement("li", _extends({}, rest, {
    className: cx(liClasses),
    key: id
  }), React.createElement("section", {
    className: cx(sectionClasses),
    id: id
  }, React.createElement("div", {
    className: "slds-accordion__summary"
  }, React.createElement("h3", {
    className: "slds-accordion__summary-heading"
  }, React.createElement(Button, {
    sprite: "utility",
    icon: isOpen ? 'chevrondown' : 'chevronright',
    className: "slds-button_reset slds-accordion__summary-action",
    flavor: null,
    "aria-controls": "accordion-details-".concat(id),
    "aria-expanded": isOpen ? 'true' : 'false'
  }, React.createElement("span", {
    className: "slds-truncate",
    title: summary
  }, summary))), React.createElement(IconButton, {
    sprite: "utility",
    icon: "down",
    "aria-haspopup": "true",
    border: "filled",
    className: "slds-shrink-none",
    onClick: summaryOnClick,
    size: "x-small",
    title: "More Options"
  })), React.createElement("div", {
    hidden: !isOpen ? 'hidden' : null,
    className: "slds-accordion__content",
    id: id
  }, children)));
};

AccordionSection.defaultProps = {
  className: null,
  isOpen: false,
  summaryOnClick: function summaryOnClick() {}
};
AccordionSection.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * section content
   */
  children: PropTypes.node.isRequired,

  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * section id
   */
  id: PropTypes.string.isRequired,

  /**
   * section is open
   */
  isOpen: PropTypes.bool,

  /**
   * section summary
   */
  summary: PropTypes.string.isRequired,

  /**
   * function for the button on the right of summary
   */
  summaryOnClick: PropTypes.func
} : {};
export default AccordionSection;