import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import { THEMES } from '../../utils';
import { Modal, ModalContent, ModalFooter } from '../Modal';

var Prompt = function Prompt(props) {
  var children = props.children,
      className = props.className,
      closeButtonLabel = props.closeButtonLabel,
      id = props.id,
      onClose = props.onClose,
      open = props.open,
      theme = props.theme,
      title = props.title,
      rest = _objectWithoutProperties(props, ["children", "className", "closeButtonLabel", "id", "onClose", "open", "theme", "title"]);

  return React.createElement("div", null, React.createElement(Modal, _extends({}, rest, {
    className: className,
    id: id,
    open: open,
    onClose: onClose,
    prompt: theme,
    title: title
  }), React.createElement(ModalContent, null, children), React.createElement(ModalFooter, {
    className: "slds-theme_default",
    closeButtonLabel: closeButtonLabel
  })));
};

Prompt.defaultProps = {
  className: null,
  closeButtonLabel: 'Okay',
  open: false,
  theme: 'error'
};
Prompt.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * prompt content
   */
  children: PropTypes.node.isRequired,

  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * Prompt Id
   */
  id: PropTypes.string.isRequired,

  /**
   * Close button label
   */
  closeButtonLabel: PropTypes.string,

  /**
   * fires when close is clicked or when esc is pressed when the prompt is visible
   */
  onClose: PropTypes.func.isRequired,

  /**
   * opens the prompt
   */
  open: PropTypes.bool,

  /**
   * slds theme
   */
  theme: PropTypes.oneOf(THEMES),

  /**
   * prompt title
   */
  title: PropTypes.string.isRequired
} : {};
export default Prompt;