import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var BrandBand = function BrandBand(props) {
  var className = props.className,
      cover = props.cover,
      noBackground = props.noBackground,
      size = props.size,
      rest = _objectWithoutProperties(props, ["className", "cover", "noBackground", "size"]);

  var baseClass = 'slds-brand-band';
  var sldsClasses = [baseClass, _defineProperty({}, "".concat(baseClass, "_none"), noBackground), _defineProperty({}, "".concat(baseClass, "_cover"), cover), _defineProperty({}, "".concat(baseClass, "_").concat(size), !!size), className];
  return React.createElement("div", _extends({}, rest, {
    className: cx(sldsClasses)
  }));
};

BrandBand.defaultProps = {
  className: null,
  cover: false,
  noBackground: false,
  size: 'medium'
};
BrandBand.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Optional additional classes
   */
  className: PropTypes.string,

  /**
   * Changes background image to be set to cover rather than contain
  */
  cover: PropTypes.bool,

  /**
   * Removes image but keeps page background
   */
  noBackground: PropTypes.bool,

  /**
   * Sets height of brand band to {size}. Can either be: small, medium, large
   */
  size: PropTypes.oneOf(['small', 'medium', 'large'])
} : {};
export default BrandBand;