import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.array.map";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var Breadcrumb = function Breadcrumb(props) {
  var children = props.children,
      className = props.className,
      rest = _objectWithoutProperties(props, ["children", "className"]);

  var filtered = children;

  if (!Array.isArray(children)) {
    filtered = [children];
  }

  var sldsClasses = ['slds-breadcrumb', 'slds-list_horizontal', 'slds-wrap', className];
  var wrapItems = filtered.map(function (child) {
    return React.createElement("li", {
      className: "slds-breadcrumb__item",
      key: child.key
    }, child);
  });
  return React.createElement("nav", _extends({}, rest, {
    className: className,
    "aria-label": "Breadcrumbs"
  }), React.createElement("ol", {
    className: cx(sldsClasses)
  }, wrapItems));
};

Breadcrumb.defaultProps = {
  className: null
};
Breadcrumb.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * One or many children, that automatically get wrapped into the surrounding
   * `<ol><li></li></ol>` structure of the breadcrumb. Don't forget to add
   * unique keys since react requires this to render more efficiently.
   */
  children: PropTypes.node.isRequired,

  /**
   * class name
   */
  className: PropTypes.string
} : {};
export default Breadcrumb;