import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { IconSVG } from '../../Icon';

var ButtonIcon = function ButtonIcon(props) {
  var className = props.className,
      icon = props.icon,
      size = props.size,
      sprite = props.sprite,
      position = props.position,
      rest = _objectWithoutProperties(props, ["className", "icon", "size", "sprite", "position"]);

  var sldsClasses = cx('slds-button__icon', _defineProperty({}, "slds-button__icon_".concat(size), !!size), _defineProperty({}, "slds-button__icon_".concat(position), !!position), className);
  return React.createElement(IconSVG, _extends({}, rest, {
    className: sldsClasses,
    isButton: true,
    icon: icon,
    sprite: sprite
  }));
};

ButtonIcon.defaultProps = {
  className: null,
  position: null,
  size: null
};
ButtonIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Icon that will be rendered
   */
  icon: PropTypes.string.isRequired,

  /**
   * Sprite containing `icon`
   */
  sprite: PropTypes.string.isRequired,

  /**
   * Optional size. Either `x-small`, `small` or `large`
   */
  size: PropTypes.oneOf(['x-small', 'small', 'large']),

  /**
   * Position in `Button`. Either left or right, can also be `null`
   */
  position: PropTypes.oneOf(['left', 'right']),

  /**
   * Optional additional className
   */
  className: PropTypes.string
} : {};
export default ButtonIcon;