import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import ButtonIcon from './ButtonIcon';

var renderStatefulButtonIcon = function renderStatefulButtonIcon(icon, sprite) {
  return React.createElement(ButtonIcon, {
    position: "left",
    icon: icon,
    size: "small",
    sprite: sprite
  });
};

var StatefulButtonState = function StatefulButtonState(props) {
  var className = props.className,
      icon = props.icon,
      sprite = props.sprite,
      state = props.state,
      title = props.title,
      rest = _objectWithoutProperties(props, ["className", "icon", "sprite", "state", "title"]);

  var selectedClass = null;

  switch (state) {
    case 'selected':
      selectedClass = 'slds-text-selected';
      break;

    case 'focus':
      selectedClass = 'slds-text-selected-focus';
      break;

    default:
      selectedClass = 'slds-text-not-selected';
  }

  return React.createElement("span", _extends({}, rest, {
    className: cx(selectedClass, className)
  }), renderStatefulButtonIcon(icon, sprite), title);
};

StatefulButtonState.defaultProps = {
  className: null
};
StatefulButtonState.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Button state described by this component. A `StatefulButton` needs all states present
   */
  state: PropTypes.oneOf(['selected', 'not-selected', 'focus']).isRequired,

  /**
   * Icon rendered in this state
   */
  icon: PropTypes.string.isRequired,

  /**
   * Sprite containing `icon`
   */
  sprite: PropTypes.string.isRequired,

  /**
   * Button content for `state`
   */
  title: PropTypes.string.isRequired,

  /**
   * Optional additional className
   */
  className: PropTypes.string
} : {};
export default StatefulButtonState;