import "core-js/modules/es.symbol";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.array.map";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import * as ReactIs from 'react-is';
import cx from 'classnames';

var ButtonGroup = function ButtonGroup(props) {
  var children = props.children,
      className = props.className,
      list = props.list,
      row = props.row,
      rest = _objectWithoutProperties(props, ["children", "className", "list", "row"]);

  var wrapLi = function wrapLi(parentEl, i) {
    var isFragment = ReactIs.typeOf(parentEl) === ReactIs.Fragment;

    var toLi = function toLi(childEl, index) {
      return React.createElement("li", {
        className: row ? 'slds-button-group-item' : null,
        key: index
      }, childEl);
    };

    return isFragment ? React.Children.map(parentEl.props.children, function (child, j) {
      return toLi(child, "".concat(i, "-").concat(j));
    }) : toLi(parentEl, i);
  };

  var isDivGroup = !list && !row;
  var sldsClasses = cx({
    'slds-button-group': isDivGroup
  }, {
    'slds-button-group-list': list
  }, {
    'slds-button-group-row': row
  }, className);
  var ButtonGroupEl = isDivGroup ? 'div' : 'ul';
  var childEls = !isDivGroup ? React.Children.map(children, wrapLi) : children;
  return React.createElement(ButtonGroupEl, _extends({}, rest, {
    className: cx(sldsClasses),
    role: isDivGroup ? 'group' : null
  }), childEls);
};

ButtonGroup.defaultProps = {
  className: null,
  list: false,
  row: false
};
ButtonGroup.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Any number and combination of button elements
   */
  children: PropTypes.node.isRequired,

  /**
   * Optional additional classNames
   */
  className: PropTypes.string,

  /**
   * Renders the button group as a list
   */
  list: PropTypes.bool,

  /**
   * Renders the button group as a row of separate buttons
   */
  row: PropTypes.bool
} : {};
export default ButtonGroup;