import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var CheckboxButton = function CheckboxButton(props) {
  var checked = props.checked,
      className = props.className,
      id = props.id,
      label = props.label,
      rest = _objectWithoutProperties(props, ["checked", "className", "id", "label"]);

  var sldsClasses = cx('slds-assistive-text', className);
  return React.createElement("div", {
    className: "slds-checkbox_add-button"
  }, React.createElement("input", _extends({}, rest, {
    checked: checked,
    className: cx(sldsClasses),
    id: id,
    type: "checkbox",
    value: checked ? 'on' : 'off'
  })), React.createElement("label", {
    className: "slds-checkbox_faux",
    htmlFor: id
  }, React.createElement("span", {
    className: "slds-assistive-text"
  }, label)));
};

CheckboxButton.defaultProps = {
  className: null
};
CheckboxButton.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Checkbox state
   */
  checked: PropTypes.bool.isRequired,

  /**
   * `id` of input. Links input and label
   */
  id: PropTypes.string.isRequired,

  /**
   * Input label, will be present for screen readers
   */
  label: PropTypes.string.isRequired,

  /**
   * Optional additional className
   */
  className: PropTypes.string
} : {};
export default CheckboxButton;