import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import Button from '../Base/Button';
import ButtonIcon from '../Base/ButtonIcon';
var prefix = 'slds-button_icon';

var IconButton = function IconButton(props) {
  var border = props.border,
      children = props.children,
      className = props.className,
      container = props.container,
      flavor = props.flavor,
      icon = props.icon,
      more = props.more,
      size = props.size,
      sprite = props.sprite,
      title = props.title,
      rest = _objectWithoutProperties(props, ["border", "children", "className", "container", "flavor", "icon", "more", "size", "sprite", "title"]);

  var isInverse = flavor === 'inverse';
  /* eslint-disable no-nested-ternary */

  var borderSuffix = isInverse && border ? 'border-inverse' : border === 'filled' ? 'border-filled' : 'border';
  /* eslint-enable */

  var sldsClasses = cx(prefix, _defineProperty({}, "".concat(prefix, "-").concat(size), !!size), _defineProperty({}, "".concat(prefix, "-").concat(borderSuffix), !!border), _defineProperty({}, "".concat(prefix, "-container"), container), _defineProperty({}, "".concat(prefix, "-inverse"), isInverse && !border), _defineProperty({}, "".concat(prefix, "-more"), more), _defineProperty({}, "".concat(prefix, "-").concat(flavor), flavor && !isInverse), className);
  var isShortcut = !!icon && !!sprite;
  return React.createElement(Button, _extends({}, rest, {
    className: sldsClasses,
    flavor: null,
    title: title
  }), !isShortcut ? children : React.createElement(ButtonIcon, {
    icon: icon,
    sprite: sprite
  }), more && React.createElement(ButtonIcon, {
    icon: "down",
    size: "x-small",
    sprite: "utility"
  }), title && React.createElement("span", {
    className: "slds-assistive-text"
  }, title));
};

IconButton.defaultProps = {
  border: null,
  children: null,
  className: null,
  container: false,
  icon: null,
  sprite: null,
  more: false,
  flavor: null,
  title: null,
  size: null
};
IconButton.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Shortcut to render a ButtonIcon. Used in combination with `sprite`
   */
  icon: PropTypes.string,

  /**
   * Shortcut to render a ButtonIcon. Used in combination with `icon`
   */
  sprite: PropTypes.string,

  /**
   * If shortcut does not suffice (e.g. you need more control over ButtonIcon), you can add a ButtonIcon as child
   */
  children: PropTypes.node,

  /**
   * Renders a border. Can be `true` to render a transparent border or filled to render a visible border
   */
  border: PropTypes.oneOf([true, 'filled']),

  /**
   * Adjust icon sizes. Used to render transparent icons with padding
   */
  container: PropTypes.bool,

  /**
   * Optional additional classNames
   */
  className: PropTypes.string,

  /**
   * Renders a small down chevron besides the main icon. Used for example in IconButton groups
   */
  more: PropTypes.bool,

  /**
   * Can be either `brand`, `error` or `inverse`
   */
  flavor: PropTypes.oneOf(['brand', 'error', 'inverse']),

  /**
   * Adjusts icon size. Can be `xx-small`, `x-small` or `small`
   */
  size: PropTypes.oneOf(['xx-small', 'x-small', 'small']),

  /**
   * Title for hover and screenreaders
   */
  title: PropTypes.string
} : {};
export default IconButton;