import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import IconButton from './IconButton';

var StatefulIconButton = function StatefulIconButton(props) {
  var className = props.className,
      flavor = props.flavor,
      selected = props.selected,
      rest = _objectWithoutProperties(props, ["className", "flavor", "selected"]);

  var sldsClasses = cx({
    'slds-is-selected': selected
  }, className);
  return React.createElement(IconButton, _extends({}, rest, {
    className: sldsClasses,
    "aria-pressed": selected,
    flavor: flavor,
    border: "filled"
  }));
};

StatefulIconButton.defaultProps = {
  className: null,
  flavor: null,
  selected: false
};
StatefulIconButton.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Optional additional className
   */
  className: PropTypes.string,

  /**
   * Button flavor. Can be `inverse`
   */
  flavor: PropTypes.oneOf(['inverse']),

  /**
   * Whether the `IconButton` should render as selected
   */
  selected: PropTypes.bool
} : {};
export default StatefulIconButton;