import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import CardHeader from './CardHeader';

var Card = function Card(_ref) {
  var Tag = _ref.as,
      boundary = _ref.boundary,
      children = _ref.children,
      className = _ref.className,
      isBoundary = _ref.isBoundary,
      isPadded = _ref.isPadded,
      renderFooter = _ref.renderFooter,
      renderHeader = _ref.renderHeader,
      body = _ref.body,
      footer = _ref.footer,
      headerRight = _ref.headerRight,
      title = _ref.title,
      icon = _ref.icon,
      rest = _objectWithoutProperties(_ref, ["as", "boundary", "children", "className", "isBoundary", "isPadded", "renderFooter", "renderHeader", "body", "footer", "headerRight", "title", "icon"]);

  return React.createElement(Tag, _extends({}, rest, {
    className: cx(['slds-card', {
      'slds-card_boundary': isBoundary || boundary
    }, className])
  }), renderHeader ? renderHeader() : title && React.createElement(CardHeader, {
    icon: icon,
    title: title
  }, headerRight), React.createElement("div", {
    className: cx(['slds-card__body', {
      'slds-card__body_inner': isPadded
    }])
  }, children || body), renderFooter ? renderFooter() : footer && React.createElement("footer", {
    className: "slds-card__footer"
  }, footer));
};

Card.defaultProps = {
  as: 'article',
  children: null,
  className: null,
  isBoundary: false,
  isPadded: true,
  renderFooter: null,
  renderHeader: null,
  body: null,
  boundary: false,
  footer: null,
  headerRight: null,
  icon: null,
  title: null
};
Card.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Determines the HTML element type that the Card renders as
   */
  as: PropTypes.string,

  /**
   * Content
   */
  children: PropTypes.node,

  /**
   * Optional classname, applied to top-level tag
   */
  className: PropTypes.string,

  /**
   * Should be set to true for the outermost `Card`
   */
  isBoundary: PropTypes.bool,

  /**
   * By default, the content receives `medium` padding. Set to `false` to remove this
   */
  isPadded: PropTypes.bool,

  /**
   * Render function for the Card footer. Can use `<CardFooter />`
   */
  renderFooter: PropTypes.func,

  /**
   * Render function for the Card header. Can use `<CardHeader />`
   */
  renderHeader: PropTypes.func,

  /**
   * DEPRECATED: Use `children` instead
   */
  body: PropTypes.node,

  /**
   * DEPRECATED: Use `isHeader`  instead
   */
  boundary: PropTypes.bool,

  /**
   * DEPRECATED: Use `renderFooter()` instead
   */
  footer: PropTypes.node,

  /**
   * DEPRECATED: Set this in `renderHeader()` => `<CardHeader />` instead
   */
  title: PropTypes.string,

  /**
   * DEPRECATED: Use `renderHeader()` instead (see example)
   */
  headerRight: PropTypes.node,

  /**
   * DEPRECATED: Set this in `renderHeader()` => `<CardHeader />` instead
   */
  icon: PropTypes.element
} : {};
export default Card;