import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var CardFooter = function CardFooter(_ref) {
  var assistiveText = _ref.assistiveText,
      className = _ref.className,
      linkText = _ref.linkText,
      linkProps = _ref.linkProps,
      rest = _objectWithoutProperties(_ref, ["assistiveText", "className", "linkText", "linkProps"]);

  return React.createElement("footer", _extends({}, rest, {
    className: cx(['slds-card__footer', className])
  }), linkText && React.createElement("a", linkProps, linkText, assistiveText && React.createElement("span", {
    className: "slds-assistive-text"
  }, assistiveText)));
};

CardFooter.defaultProps = {
  assistiveText: null,
  className: null,
  linkProps: {},
  linkText: null
};
CardFooter.propTypes = process.env.NODE_ENV !== "production" ? {
  assistiveText: PropTypes.string,

  /**
   * Applied to top-level element `slds-card__footer`
   */
  className: PropTypes.string,

  /**
   * Props passed to the link `a` tag
   */
  linkProps: PropTypes.object,

  /**
   * Link text
   */
  linkText: PropTypes.string
} : {};
export default CardFooter;