import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { EventContent } from './Content';

var ChatListItemBookend = function ChatListItemBookend(_ref) {
  var isEnd = _ref.isEnd,
      message = _ref.message,
      timestamp = _ref.timestamp;
  var classNamesBookend = cx(['slds-chat-bookend', {
    'slds-chat-bookend_stop': isEnd
  }]);
  return React.createElement("div", {
    className: classNamesBookend
  }, React.createElement(EventContent, {
    icon: isEnd ? 'end_chat' : 'chat',
    message: message,
    timestamp: timestamp
  }));
};

ChatListItemBookend.defaultProps = {
  isEnd: false,
  timestamp: null
};
ChatListItemBookend.propTypes = process.env.NODE_ENV !== "production" ? {
  isEnd: PropTypes.bool,
  message: PropTypes.node.isRequired,
  timestamp: PropTypes.string
} : {};
export default ChatListItemBookend;