import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { EventContent } from './Content';

var ChatListItemEvent = function ChatListItemEvent(_ref) {
  var icon = _ref.icon,
      isError = _ref.isError,
      message = _ref.message,
      meta = _ref.meta,
      timestamp = _ref.timestamp;
  var eventClassName = cx(['slds-chat-event', {
    'slds-has-error': isError
  }]);
  return React.createElement("div", {
    className: eventClassName
  }, React.createElement("div", {
    className: "slds-chat-event__body"
  }, React.createElement(EventContent, {
    icon: icon,
    message: message,
    timestamp: timestamp
  })), !isError && meta && React.createElement("div", {
    className: "slds-chat-event__agent-message"
  }, meta));
};

ChatListItemEvent.defaultProps = {
  icon: null,
  meta: null,
  timestamp: null
};
ChatListItemEvent.propTypes = process.env.NODE_ENV !== "production" ? {
  icon: PropTypes.string,
  isError: PropTypes.bool.isRequired,
  message: PropTypes.node.isRequired,
  meta: PropTypes.node,
  timestamp: PropTypes.string
} : {};
export default ChatListItemEvent;