import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { MessageContent } from './Content';

var ChatListItemMessage = function ChatListItemMessage(_ref) {
  var author = _ref.author,
      avatar = _ref.avatar,
      isFirstMessage = _ref.isFirstMessage,
      isPastChat = _ref.isPastChat,
      rest = _objectWithoutProperties(_ref, ["author", "avatar", "isFirstMessage", "isPastChat"]);

  var hasAvatar = !!avatar;
  var classNamesMessage = cx(['slds-chat-message', {
    'slds-chat-message_faux-avatar': hasAvatar && !isFirstMessage
  }]);
  return React.createElement("div", {
    className: classNamesMessage
  }, !isPastChat && hasAvatar && isFirstMessage && React.createElement("span", {
    "aria-hidden": "true",
    className: "slds-avatar slds-avatar_circle slds-chat-avatar"
  }, React.createElement("abbr", {
    className: "slds-avatar__initials slds-avatar__initials_inverse",
    title: author
  }, avatar)), React.createElement("div", {
    className: "slds-chat-message__body"
  }, React.createElement(MessageContent, _extends({
    author: author,
    avatar: avatar,
    isPastChat: isPastChat
  }, rest))));
};

ChatListItemMessage.defaultProps = {
  avatar: null
};
ChatListItemMessage.propTypes = process.env.NODE_ENV !== "production" ? {
  author: PropTypes.string.isRequired,
  avatar: PropTypes.string,
  isFirstMessage: PropTypes.bool.isRequired,
  isPastChat: PropTypes.bool.isRequired
} : {};
export default ChatListItemMessage;