import React from 'react';
import { PropTypes } from 'prop-types';
import { Icon } from '../../Icon';
/* eslint-disable react/jsx-one-expression-per-line */

export var EventContent = function EventContent(_ref) {
  var icon = _ref.icon,
      message = _ref.message,
      timestamp = _ref.timestamp;
  return React.createElement(React.Fragment, null, icon && React.createElement(Icon, {
    className: "slds-chat-icon",
    icon: icon,
    size: "x-small",
    sprite: "utility",
    svgClassName: "slds-icon-text-default"
  }), React.createElement("p", null, timestamp ? React.createElement(React.Fragment, null, message, " \u2022 ", timestamp) : message));
};
/* eslint-enable react/jsx-one-expression-per-line */

EventContent.defaultProps = {
  icon: null,
  message: null,
  timestamp: null
};
EventContent.propTypes = process.env.NODE_ENV !== "production" ? {
  icon: PropTypes.string,
  message: PropTypes.node,
  timestamp: PropTypes.string
} : {};