import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import { File } from '../../File';
import { Icon } from '../../Icon';
export var MessageFile = function MessageFile(_ref) {
  var alt = _ref.alt,
      fileType = _ref.fileType,
      isLink = _ref.isLink,
      src = _ref.src,
      title = _ref.title,
      rest = _objectWithoutProperties(_ref, ["alt", "fileType", "isLink", "src", "title"]);

  return isLink ? React.createElement(React.Fragment, null, React.createElement(Icon, {
    className: "slds-chat-icon",
    icon: "attachment",
    size: "small",
    sprite: "doctype"
  }), React.createElement("a", {
    href: src,
    title: title
  }, title)) : React.createElement("div", {
    style: {
      width: '15rem'
    }
  }, React.createElement(File, _extends({
    fileType: fileType,
    image: src && {
      alt: alt || title,
      src: src
    },
    title: title
  }, rest)));
};
MessageFile.defaultProps = {
  alt: '',
  isLink: false,
  src: null
};
MessageFile.propTypes = process.env.NODE_ENV !== "production" ? {
  alt: PropTypes.string,
  fileType: PropTypes.string.isRequired,
  isLink: PropTypes.bool,
  src: PropTypes.string,
  title: PropTypes.string.isRequired
} : {};