import React from 'react';
import PropTypes from 'prop-types';
import { Button } from '../../Button';
import { Grid } from '../../Grid';
import { Icon } from '../../Icon';
import { Meta } from './Meta';
export var MessageMeta = function MessageMeta(_ref) {
  var author = _ref.author,
      id = _ref.id,
      isConsecutive = _ref.isConsecutive,
      isDeliveryFailure = _ref.isDeliveryFailure,
      isPastChat = _ref.isPastChat,
      meta = _ref.meta,
      onResend = _ref.onResend,
      timestamp = _ref.timestamp,
      translations = _ref.translations;
  var metaCmp = React.createElement(Meta, {
    author: author,
    isPastChat: isPastChat,
    meta: meta,
    timestamp: timestamp,
    translations: translations
  });

  if (isDeliveryFailure) {
    var labelResend = translations.resend;

    var onClick = function onClick() {
      return onResend(id);
    };

    return React.createElement(Grid, {
      align: "spread"
    }, metaCmp, React.createElement(Button, {
      disabled: !onResend,
      className: "slds-chat-message__action slds-m-top_xxx-small",
      flavor: "none",
      onClick: onClick,
      title: labelResend
    }, React.createElement(Icon, {
      className: "slds-chat-icon",
      icon: "redo",
      size: "xx-small",
      sprite: "utility"
    }), labelResend));
  }

  return !isConsecutive && metaCmp;
};
MessageMeta.defaultProps = {
  timestamp: null,
  onResend: null
};
MessageMeta.propTypes = process.env.NODE_ENV !== "production" ? {
  author: PropTypes.string.isRequired,
  id: PropTypes.string.isRequired,
  isConsecutive: PropTypes.bool.isRequired,
  isDeliveryFailure: PropTypes.bool.isRequired,
  isPastChat: PropTypes.bool.isRequired,
  onResend: PropTypes.func,
  timestamp: PropTypes.string,
  translations: PropTypes.shape({
    at: PropTypes.string,
    resend: PropTypes.string,
    said: PropTypes.string
  }).isRequired
} : {};