import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Icon } from '../../Icon';
export var MessageStatus = function MessageStatus(_ref) {
  var isDeliveryFailure = _ref.isDeliveryFailure,
      isUnsupportedType = _ref.isUnsupportedType,
      message = _ref.message;
  var classNamesStatusIcon = cx([{
    'slds-icon-text-warning': isUnsupportedType
  }, {
    'slds-icon-text-error': isDeliveryFailure
  }]);
  return React.createElement(React.Fragment, null, React.createElement(Icon, {
    className: "slds-chat-icon",
    icon: isUnsupportedType ? 'warning' : 'error',
    svgClassName: classNamesStatusIcon,
    size: "x-small",
    sprite: "utility"
  }), React.createElement("span", null, message));
};
MessageStatus.propTypes = process.env.NODE_ENV !== "production" ? {
  isDeliveryFailure: PropTypes.bool.isRequired,
  isUnsupportedType: PropTypes.bool.isRequired,
  message: PropTypes.node.isRequired
} : {};