import "core-js/modules/es.array.concat";
import React from 'react';
import PropTypes from 'prop-types';
/* eslint-disable react/jsx-one-expression-per-line */

export var Meta = function Meta(_ref) {
  var author = _ref.author,
      isPastChat = _ref.isPastChat,
      meta = _ref.meta,
      timestamp = _ref.timestamp,
      _ref$translations = _ref.translations,
      at = _ref$translations.at,
      said = _ref$translations.said;
  return React.createElement("div", {
    className: "slds-chat-message__meta",
    "aria-label": "".concat(said, " ").concat(author, " ").concat(at, " ").concat(timestamp)
  }, meta || React.createElement(React.Fragment, null, isPastChat ? React.createElement("b", null, author) : author, "\u2022 ", timestamp));
};
Meta.defaultProps = {
  author: null,
  meta: null,
  timestamp: null
};
Meta.propTypes = process.env.NODE_ENV !== "production" ? {
  author: PropTypes.string,
  isPastChat: PropTypes.bool.isRequired,
  meta: PropTypes.node,
  timestamp: PropTypes.string,
  translations: PropTypes.shape({
    at: PropTypes.string,
    said: PropTypes.string
  }).isRequired
} : {};