import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { FormElement } from '../Form';

var hiddenWhen = function hiddenWhen(hidden) {
  return {
    'slds-assistive-text': hidden
  };
};

var CheckboxToggle = function CheckboxToggle(props) {
  var checked = props.checked,
      disabled = props.disabled,
      hideStatusLabels = props.hideStatusLabels,
      hideLabel = props.hideLabel,
      id = props.id,
      label = props.label,
      _props$statusLabels = props.statusLabels,
      labelUnchecked = _props$statusLabels.unchecked,
      labelChecked = _props$statusLabels.checked,
      rest = _objectWithoutProperties(props, ["checked", "disabled", "hideStatusLabels", "hideLabel", "id", "label", "statusLabels"]);

  var descId = "".concat(id, "-description");
  var statusHidden = hiddenWhen(hideStatusLabels);
  return React.createElement(FormElement, null, React.createElement("label", {
    className: "slds-checkbox_toggle slds-grid"
  }, React.createElement("span", {
    className: cx('slds-form-element__label', 'slds-m-bottom_none', hiddenWhen(hideLabel))
  }, label), React.createElement("input", _extends({
    type: "checkbox",
    checked: checked,
    disabled: disabled,
    id: id,
    "aria-describedby": descId
  }, rest, {
    name: "checkbox",
    value: checked ? 'on' : 'off'
  })), React.createElement("span", {
    id: descId,
    className: "slds-checkbox_faux_container",
    "aria-live": "assertive"
  }, React.createElement("span", {
    className: "slds-checkbox_faux"
  }), React.createElement("span", {
    className: cx('slds-checkbox_on', statusHidden)
  }, labelChecked), React.createElement("span", {
    className: cx('slds-checkbox_off', statusHidden)
  }, labelUnchecked))));
};

CheckboxToggle.defaultProps = {
  checked: false,
  disabled: false,
  hideLabel: false,
  hideStatusLabels: false,
  statusLabels: {
    unchecked: 'Disabled',
    checked: 'Enabled'
  }
};
CheckboxToggle.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Unique Id
   */
  id: PropTypes.string.isRequired,

  /**
   * Checkbox label
   */
  label: PropTypes.node.isRequired,

  /**
   * :checked state. Pass `null` for an uncontrolled checkbox
   */
  checked: PropTypes.bool,

  /**
   * Disable the checkbox
   */
  disabled: PropTypes.bool,

  /**
   * Hides the checkbox label (still visible for screen readers)
   */
  hideLabel: PropTypes.bool,

  /**
   * Hide the status labels beneath the checkbox (still visible for screen readers)
   */
  hideStatusLabels: PropTypes.bool,

  /**
   * Status labels beneath the checkbox
   */
  statusLabels: PropTypes.shape({
    unchecked: PropTypes.node.isRequired,
    checked: PropTypes.node.isRequired
  })
} : {};
export default CheckboxToggle;