import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { Fragment } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { FormElement, FormElementControl, FormElementError, FormElementLabel } from '../../Form';
var ComboboxDropdown = React.forwardRef(function (props, ref) {
  var children = props.children,
      dropdownClassName = props.dropdownClassName,
      error = props.error,
      height = props.height,
      hideErrorMessage = props.hideErrorMessage,
      hideLabel = props.hideLabel,
      id = props.id,
      isOpen = props.isOpen,
      isRequired = props.isRequired,
      isSingleInlineSelection = props.isSingleInlineSelection,
      label = props.label,
      listboxId = props.listboxId,
      onLabelClick = props.onLabelClick,
      renderInput = props.renderInput,
      renderListbox = props.renderListbox,
      renderObjectSwitcher = props.renderObjectSwitcher,
      selectionLength = props.selectionLength,
      rest = _objectWithoutProperties(props, ["children", "dropdownClassName", "error", "height", "hideErrorMessage", "hideLabel", "id", "isOpen", "isRequired", "isSingleInlineSelection", "label", "listboxId", "onLabelClick", "renderInput", "renderListbox", "renderObjectSwitcher", "selectionLength"]);

  var comboboxContainerClasses = ['slds-combobox_container', {
    'slds-has-selection': isSingleInlineSelection
  }, {
    'slds-combobox-addon_end': renderObjectSwitcher
  }];
  var comboboxClasses = ['slds-combobox', 'slds-dropdown-trigger', 'slds-dropdown-trigger_click', {
    'slds-is-open': isOpen
  }];
  var comboboxFormElementClasses = ['slds-combobox__form-element', 'slds-input-has-icon', {
    'slds-input-has-icon_left-right': isSingleInlineSelection
  }, {
    'slds-input-has-icon_right': !isSingleInlineSelection
  }];
  var dropdownClasses = ['slds-dropdown', 'slds-dropdown_fluid', _defineProperty({}, "slds-dropdown_length-with-icon-".concat(height), height), dropdownClassName];
  var comboboxEl = React.createElement("div", {
    className: cx(comboboxContainerClasses)
  }, React.createElement("div", {
    className: cx(comboboxClasses),
    "aria-expanded": isOpen,
    "aria-haspopup": "listbox",
    role: "combobox"
  }, React.createElement("div", {
    className: cx(comboboxFormElementClasses),
    role: "none"
  }, renderInput()), React.createElement("div", {
    className: cx(dropdownClasses),
    id: listboxId,
    ref: ref,
    role: "listbox",
    tabIndex: "-1"
  }, children)));
  return React.createElement(FormElement, _extends({
    error: error,
    required: isRequired
  }, rest), !hideLabel && React.createElement(FormElementLabel, {
    id: id,
    label: label,
    onClick: onLabelClick,
    required: isRequired
  }), !hideErrorMessage && React.createElement(FormElementError, {
    error: error,
    id: "error-".concat(id)
  }), React.createElement(FormElementControl, null, renderObjectSwitcher ? React.createElement(Fragment, null, React.createElement("div", {
    className: cx(['slds-combobox-group', {
      'slds-has-selection': selectionLength > 0
    }])
  }, React.createElement("div", {
    className: "slds-combobox_object-switcher slds-combobox-addon_start"
  }, React.createElement("div", {
    className: "slds-form-element"
  }, React.createElement("div", {
    className: "slds-form-element__control"
  }, renderObjectSwitcher()))), comboboxEl), renderListbox && renderListbox()) : React.createElement(Fragment, null, comboboxEl, renderListbox && renderListbox())));
});
ComboboxDropdown.displayName = 'ComboboxDropdown';
ComboboxDropdown.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node,
  className: PropTypes.string,
  dropdownClassName: PropTypes.string,
  error: PropTypes.string,
  height: PropTypes.number.isRequired,
  hideErrorMessage: PropTypes.bool,
  hideLabel: PropTypes.bool,
  id: PropTypes.string.isRequired,
  isOpen: PropTypes.bool.isRequired,
  isRequired: PropTypes.bool,
  isSingleInlineSelection: PropTypes.bool,
  label: PropTypes.node.isRequired,
  listboxId: PropTypes.string.isRequired,
  onLabelClick: PropTypes.func,
  renderInput: PropTypes.func.isRequired,
  renderListbox: PropTypes.func,
  renderObjectSwitcher: PropTypes.func,
  selectionLength: PropTypes.number
} : {};
ComboboxDropdown.defaultProps = {
  children: null,
  className: null,
  dropdownClassName: null,
  error: null,
  hideErrorMessage: false,
  hideLabel: false,
  isRequired: false,
  isSingleInlineSelection: false,
  onLabelClick: null,
  renderListbox: null,
  renderObjectSwitcher: null,
  selectionLength: 0
};
export default ComboboxDropdown;