import "core-js/modules/es.array.map";
import "core-js/modules/es.array.some";
import React from 'react';
import PropTypes from 'prop-types';
import { HeaderDropdownItem } from './DropdownItems';
export var RawComboboxDropdownLists = function RawComboboxDropdownLists(_ref) {
  var items = _ref.items,
      isOpen = _ref.isOpen,
      renderItem = _ref.renderItem,
      renderItemsAppended = _ref.renderItemsAppended,
      renderItemsPrepended = _ref.renderItemsPrepended;
  var listClasses = 'slds-listbox slds-listbox_vertical';
  if (!isOpen) return null;

  if (!items.some(function (_ref2) {
    var isHeader = _ref2.isHeader;
    return isHeader;
  })) {
    return React.createElement("ul", {
      className: listClasses
    }, renderItemsPrepended && renderItemsPrepended(), items.map(renderItem), renderItemsAppended && renderItemsAppended());
  }

  var groups = []; // In case first item is not a header, a list without a header will be rendered

  var currentGroup = {
    id: null,
    label: null,
    items: []
  };

  for (var i = 0; i < items.length; i += 1) {
    var current = items[i];

    if (current.isHeader) {
      groups.push(currentGroup);
      var id = current.id,
          label = current.label;
      currentGroup = {
        id: id,
        label: label,
        items: []
      };
    } else {
      currentGroup.items.push(current);
    }

    if (i === items.length - 1) groups.push(currentGroup);
  }

  return groups.map(function (_ref3, index) {
    var id = _ref3.id,
        label = _ref3.label,
        groupItems = _ref3.items;
    return React.createElement("ul", {
      "aria-label": label,
      className: listClasses,
      key: id,
      role: "group"
    }, id && label && React.createElement(HeaderDropdownItem, {
      id: id,
      label: label
    }), index === 0 && renderItemsPrepended && renderItemsPrepended(), groupItems.map(renderItem), index === groups.length - 1 && renderItemsAppended && renderItemsAppended());
  });
};
RawComboboxDropdownLists.propTypes = process.env.NODE_ENV !== "production" ? {
  isOpen: PropTypes.bool,
  items: PropTypes.arrayOf(PropTypes.shape({
    id: PropTypes.string.isRequired,
    label: PropTypes.string.isRequired
  })),
  renderItem: PropTypes.func.isRequired,
  renderItemsAppended: PropTypes.func,
  renderItemsPrepended: PropTypes.func
} : {};
RawComboboxDropdownLists.defaultProps = {
  isOpen: false,
  renderItemsAppended: null,
  renderItemsPrepended: null
};
export default React.memo(RawComboboxDropdownLists);