import "core-js/modules/es.array.map";
import React from 'react';
import PropTypes from 'prop-types';
import { Listbox, Pill } from '../../Pill';
import { Icon } from '../../Icon';

var ComboboxListbox = function ComboboxListbox(_ref) {
  var isOpen = _ref.isOpen,
      label = _ref.label,
      makeSelectHandler = _ref.makeSelectHandler,
      selectedItems = _ref.selectedItems;
  if (isOpen || selectedItems.length === 0) return null;
  return React.createElement("div", null, React.createElement(Listbox, {
    label: label
  }, selectedItems.map(function (_ref2) {
    var icon = _ref2.icon,
        id = _ref2.id,
        itemLabel = _ref2.label;
    return React.createElement(Pill, {
      key: id,
      icon: icon ? React.createElement(Icon, {
        icon: icon.icon,
        sprite: icon.sprite
      }) : null,
      label: itemLabel,
      title: itemLabel,
      onClose: makeSelectHandler(id)
    });
  })));
};

ComboboxListbox.propTypes = process.env.NODE_ENV !== "production" ? {
  isOpen: PropTypes.bool.isRequired,
  label: PropTypes.string.isRequired,
  makeSelectHandler: PropTypes.func.isRequired,
  selectedItems: PropTypes.arrayOf(PropTypes.shape({
    id: PropTypes.string.isRequired,
    label: PropTypes.string.isRequired
  })).isRequired
} : {};
export default ComboboxListbox;