import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Icon } from '../../../Icon';
import { DropdownItemCore } from './DropdownItemCore';
import { defaultHighlighter } from '../../utils/helpers';
export var BaseDropdownItem = function BaseDropdownItem(props) {
  var highlight = props.highlight,
      icon = props.icon,
      id = props.id,
      isDisabled = props.isDisabled,
      isMultiSelect = props.isMultiSelect,
      isSelected = props.isSelected,
      isSelectedAssistiveLabel = props.isSelectedAssistiveLabel,
      label = props.label,
      meta = props.meta,
      rest = _objectWithoutProperties(props, ["highlight", "icon", "id", "isDisabled", "isMultiSelect", "isSelected", "isSelectedAssistiveLabel", "label", "meta"]);

  var iconEl;

  if (isSelected || icon) {
    var iconClassNames = cx([{
      'slds-icon_disabled': !!isDisabled
    }, 'slds-current-color']);
    iconEl = React.createElement(Icon, {
      className: iconClassNames,
      icon: isSelected ? 'check' : icon.icon,
      sprite: isSelected ? 'utility' : icon.sprite,
      size: "x-small"
    });
  }

  return React.createElement(DropdownItemCore, _extends({}, rest, {
    className: "slds-listbox__option_plain",
    isDisabled: isDisabled,
    isSelected: isSelected,
    icon: React.createElement("span", {
      className: "slds-media__figure slds-listbox__option-icon"
    }, iconEl)
  }), React.createElement("span", {
    className: "slds-truncate",
    title: label
  }, isMultiSelect && isSelected && React.createElement("span", {
    className: "slds-assistive-text"
  }, isSelectedAssistiveLabel), highlight.length > 0 ? defaultHighlighter(label, highlight) : label), meta && React.createElement("span", {
    className: "slds-listbox__option-meta"
  }, meta));
};
BaseDropdownItem.propTypes = process.env.NODE_ENV !== "production" ? {
  highlight: PropTypes.string,
  icon: PropTypes.shape({
    icon: PropTypes.string.isRequired,
    sprite: PropTypes.string.isRequired
  }),
  id: PropTypes.string.isRequired,
  isDisabled: PropTypes.bool,
  isMultiSelect: PropTypes.bool,
  isSelected: PropTypes.bool,
  isSelectedAssistiveLabel: PropTypes.string,
  label: PropTypes.string.isRequired,
  meta: PropTypes.node
} : {};
BaseDropdownItem.defaultProps = {
  highlight: '',
  icon: null,
  isDisabled: false,
  isMultiSelect: false,
  isSelected: false,
  isSelectedAssistiveLabel: 'Current Selection: ',
  meta: null
};