import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
export var DropdownItemCore = function DropdownItemCore(props) {
  var children = props.children,
      className = props.className,
      icon = props.icon,
      id = props.id,
      isDisabled = props.isDisabled,
      isFocus = props.isFocus,
      isHeader = props.isHeader,
      isPresentation = props.isPresentation,
      isSelected = props.isSelected,
      onSelect = props.onSelect,
      rest = _objectWithoutProperties(props, ["children", "className", "icon", "id", "isDisabled", "isFocus", "isHeader", "isPresentation", "isSelected", "onSelect"]);

  var optionClasses = ['slds-media', 'slds-media__small', 'slds-listbox__option', className, {
    'slds-is-selected': isSelected
  }, {
    'slds-has-focus': isFocus
  }];
  return React.createElement("li", _extends({}, rest, {
    className: "slds-listbox__item",
    role: "presentation"
  }), React.createElement("div", {
    "aria-disabled": isDisabled || null,
    id: id,
    className: cx(optionClasses),
    onMouseDown: !isDisabled ? onSelect : null,
    role: isHeader || isPresentation ? 'presentation' : 'option'
  }, icon, isHeader ? children : React.createElement("span", {
    className: "slds-media__body"
  }, children)));
};
DropdownItemCore.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  icon: PropTypes.node,
  id: PropTypes.string,
  isDisabled: PropTypes.bool,
  isFocus: PropTypes.bool,
  isHeader: PropTypes.bool,
  isPresentation: PropTypes.bool,
  isSelected: PropTypes.bool,
  onSelect: PropTypes.func
} : {};
DropdownItemCore.defaultProps = {
  className: null,
  icon: null,
  id: null,
  isDisabled: false,
  isFocus: false,
  isHeader: false,
  isPresentation: false,
  isSelected: false,
  onSelect: null
};