import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { DropdownItemCore } from './DropdownItemCore';
import { Icon } from '../../../Icon';
import { defaultHighlighter } from '../../utils/helpers';
export var EntityDropdownItem = function EntityDropdownItem(_ref) {
  var className = _ref.className,
      highlight = _ref.highlight,
      icon = _ref.icon,
      isDisabled = _ref.isDisabled,
      isMultiSelect = _ref.isMultiSelect,
      isSelected = _ref.isSelected,
      isSelectedAssistiveLabel = _ref.isSelectedAssistiveLabel,
      label = _ref.label,
      meta = _ref.meta,
      rest = _objectWithoutProperties(_ref, ["className", "highlight", "icon", "isDisabled", "isMultiSelect", "isSelected", "isSelectedAssistiveLabel", "label", "meta"]);

  var sprite = isSelected ? 'utility' : icon.sprite;
  var isUtilIcon = sprite === 'utility';
  var iconClassNames = cx([{
    'slds-icon_disabled': isDisabled
  }, {
    'slds-current-color': isUtilIcon
  }]);
  var iconEl = React.createElement("span", {
    className: "slds-media__figure slds-listbox__option-icon"
  }, React.createElement(Icon, {
    className: iconClassNames,
    icon: isSelected ? 'check' : icon.icon,
    sprite: sprite,
    size: isUtilIcon && !isSelected ? 'x-small' : 'small'
  }));
  var itemClasses = ['slds-listbox__option_entity', {
    'slds-listbox__option_has-meta': meta
  }, className];
  return React.createElement(DropdownItemCore, _extends({}, rest, {
    className: cx(itemClasses),
    isDisabled: isDisabled,
    isSelected: isSelected,
    icon: iconEl
  }), React.createElement("span", {
    className: "slds-listbox__option-text slds-listbox__option-text_entity"
  }, isMultiSelect && isSelected && React.createElement("span", {
    className: "slds-assistive-text"
  }, isSelectedAssistiveLabel), highlight.length > 0 ? defaultHighlighter(label, highlight) : label), meta && React.createElement("span", {
    className: "slds-listbox__option-meta slds-listbox__option-meta_entity"
  }, meta));
};
EntityDropdownItem.propTypes = process.env.NODE_ENV !== "production" ? {
  className: PropTypes.string,
  highlight: PropTypes.string,
  icon: PropTypes.shape({
    icon: PropTypes.string.isRequired,
    sprite: PropTypes.string.isRequired
  }).isRequired,
  isDisabled: PropTypes.bool,
  isMultiSelect: PropTypes.bool,
  isSelected: PropTypes.bool,
  isSelectedAssistiveLabel: PropTypes.string,
  label: PropTypes.string.isRequired,
  meta: PropTypes.node
} : {};
EntityDropdownItem.defaultProps = {
  className: null,
  highlight: '',
  isDisabled: false,
  isMultiSelect: false,
  isSelected: false,
  isSelectedAssistiveLabel: 'Current Selection: ',
  meta: null
};