import "core-js/modules/es.symbol";
import "core-js/modules/es.symbol.description";
import "core-js/modules/es.symbol.iterator";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.object.get-prototype-of";
import "core-js/modules/es.object.set-prototype-of";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.string.iterator";
import "core-js/modules/web.dom-collections.iterator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { Component } from 'react';
import PropTypes from 'prop-types';
import defaultCellRenderer from './defaultCellRenderer';
import defaultHeadRenderer from './defaultHeadRenderer';
/* eslint-disable react/no-unused-prop-types */

export var propTypes = {
  cellRenderer: PropTypes.func,
  headRenderer: PropTypes.func,
  dataKey: PropTypes.string.isRequired,
  isResizable: PropTypes.bool,
  sortable: PropTypes.bool,
  title: PropTypes.string
}; // eslint-enable

/* eslint-disable react/prefer-stateless-function */

var DataTableColumn =
/*#__PURE__*/
function (_Component) {
  _inherits(DataTableColumn, _Component);

  function DataTableColumn() {
    _classCallCheck(this, DataTableColumn);

    return _possibleConstructorReturn(this, _getPrototypeOf(DataTableColumn).apply(this, arguments));
  }

  return DataTableColumn;
}(Component);

_defineProperty(DataTableColumn, "defaultProps", {
  cellRenderer: defaultCellRenderer,
  headRenderer: defaultHeadRenderer,
  isResizable: false,
  sortable: false,
  title: null
});

DataTableColumn.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
export default DataTableColumn;