import React from 'react';
import cx from 'classnames';
import { Cell } from '../Table';
/* eslint-disable react/prop-types */

export default (function (_ref) {
  var dataKey = _ref.dataKey,
      onSort = _ref.onSort,
      sortable = _ref.sortable,
      sortBy = _ref.sortBy,
      sortDirection = _ref.sortDirection,
      title = _ref.title;
  var onClick = sortable ? function () {
    return onSort(dataKey);
  } : null;
  var classNames = cx({
    'slds-is-sorted': sortBy === dataKey
  });
  return React.createElement(Cell, {
    className: classNames,
    key: dataKey,
    onClick: onClick,
    scope: "col",
    sortable: sortable,
    sortDirection: sortDirection
  }, title);
});