import "core-js/modules/es.symbol";
import "core-js/modules/es.symbol.description";
import "core-js/modules/es.symbol.iterator";
import "core-js/modules/es.array.filter";
import "core-js/modules/es.array.for-each";
import "core-js/modules/es.array.from";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.array.map";
import "core-js/modules/es.array.reduce";
import "core-js/modules/es.date.to-string";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.get-own-property-descriptor";
import "core-js/modules/es.object.get-own-property-descriptors";
import "core-js/modules/es.object.get-prototype-of";
import "core-js/modules/es.object.keys";
import "core-js/modules/es.object.set-prototype-of";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.regexp.to-string";
import "core-js/modules/es.string.iterator";
import "core-js/modules/web.dom-collections.for-each";
import "core-js/modules/web.dom-collections.iterator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import Moment from 'moment-timezone'; // eslint-disable-next-line

import { extendMoment } from 'moment-range';
import { ClickOutside } from '../ClickOutside';
import { Input } from '../Form';
import { IconButton } from '../Button';
var moment = extendMoment(Moment);
var defaultDateFormat = 'l';
var placeholderDateFormat = 'L';
var iso8601DateFormat = 'YYYY-MM-DD';
var defaultTranslations = {
  inputFieldError: '',
  inputFieldLabel: 'Date',
  today: 'Today'
};
export var DatepickerRaw =
/*#__PURE__*/
function (_Component) {
  _inherits(DatepickerRaw, _Component);

  _createClass(DatepickerRaw, null, [{
    key: "renderWeekHeader",

    /**
     * Renders visible weekdays
     * @return {ReactElement} thead
     */
    value: function renderWeekHeader() {
      return React.createElement("thead", null, React.createElement("tr", {
        id: "weekdays"
      }, moment.weekdaysShort().map(function (wd) {
        return React.createElement("th", {
          key: wd,
          id: wd
        }, React.createElement("abbr", {
          title: wd
        }, wd));
      })));
    }
    /**
     * Checks whether a date is valid
     * @param {String|Object} date date as string or moment object
     * @return {ReactElement}      thead
     */

  }]);

  function DatepickerRaw(props, context) {
    var _this;

    _classCallCheck(this, DatepickerRaw);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DatepickerRaw).call(this, props, context));

    _defineProperty(_assertThisInitialized(_this), "onDatepickerChange", function (day) {
      var _this$props = _this.props,
          date = _this$props.date,
          onChange = _this$props.onChange;
      var isControlled = DatepickerRaw.isControlled(date);
      var inputValue = day ? moment(day).format(defaultDateFormat).toString() : moment().format(defaultDateFormat).toString();
      var viewedDate = day ? moment(day) : moment();

      if (!isControlled) {
        _this.setState({
          inputValue: inputValue,
          isValid: true,
          open: false,
          viewedDate: viewedDate
        });
      }

      var output = day ? day.format(iso8601DateFormat) : moment().format(iso8601DateFormat);
      onChange(output, true);
    });

    _defineProperty(_assertThisInitialized(_this), "onInputFieldChange", function (value) {
      var _this$props2 = _this.props,
          date = _this$props2.date,
          onChange = _this$props2.onChange,
          required = _this$props2.required;
      var newDate = moment(value, defaultDateFormat);
      var isControlled = DatepickerRaw.isControlled(date);

      if (moment(value, defaultDateFormat, true).isValid()) {
        if (!isControlled) {
          _this.setState({
            inputValue: value,
            isValid: true,
            open: false,
            viewedDate: newDate
          });
        }

        onChange(newDate.format(iso8601DateFormat), true);
      } else if (value === '') {
        if (!isControlled) {
          _this.setState({
            inputValue: '',
            isValid: !required,
            open: !!required,
            viewedDate: moment()
          });
        }

        onChange(null, !required);
      } else {
        if (!isControlled) {
          _this.setState({
            inputValue: value,
            isValid: false,
            open: true
          });
        }

        onChange(value, false);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onYearChange", function (e) {
      var viewedDate = _this.state.viewedDate;

      _this.setState({
        viewedDate: viewedDate.set('year', e.target.value)
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onMonthChange", function (relativeMonth) {
      var viewedDate = _this.state.viewedDate;

      _this.setState({
        viewedDate: viewedDate.add(relativeMonth, 'month')
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onInputFieldClick", function (value) {
      var required = _this.props.required;
      var date = moment(value, defaultDateFormat);
      var isValid = DatepickerRaw.validate(date);

      _this.setState({
        isValid: value === null || value === '' ? !required : isValid,
        open: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onClickOutside", function () {
      _this.setState({
        open: false
      });
    });

    var _this$props3 = _this.props,
        _date = _this$props3.date,
        initialDate = _this$props3.initialDate,
        locale = _this$props3.locale,
        open = _this$props3.open,
        timezone = _this$props3.timezone,
        translations = _this$props3.translations;
    moment.locale(locale.toLowerCase());
    moment.tz.setDefault(timezone);
    defaultTranslations.inputFieldError = "Please enter a valid date in the following format:\n      ".concat(moment().localeData().longDateFormat(placeholderDateFormat));

    if (_date && initialDate) {
      // eslint-disable-next-line no-console
      console.warn('[react-lds] Datepicker:', 'You are supplying both `initialDate` & `date`, ignoring `initialDate`.', 'The component will work as a controlled component');
    }

    var initial;

    var _isValid;

    var _isControlled = DatepickerRaw.isControlled(_date);

    if (_isControlled) {
      initial = _date;
      _isValid = DatepickerRaw.validate(_date);
    } else {
      initial = initialDate;
      _isValid = DatepickerRaw.validate(initialDate);
    }

    _this.state = {
      open: open,
      inputValue: _isValid ? moment(initial).format(defaultDateFormat).toString() : '',
      isValid: true,
      viewedDate: _isValid ? moment(initial) : moment()
    };
    _this.mergedTranslations = _objectSpread({}, defaultTranslations, {}, translations);
    return _this;
  }

  _createClass(DatepickerRaw, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var nextDate = nextProps.date;
      var _this$props4 = this.props,
          previousDate = _this$props4.date,
          required = _this$props4.required;
      var isControlled = DatepickerRaw.isControlled(previousDate);

      if (isControlled) {
        var nextValidDate = moment(nextDate, [iso8601DateFormat, defaultDateFormat]);
        var isValid = DatepickerRaw.validate(nextDate);
        var isEmptyDate = nextDate === null || nextDate === '';
        this.setState({
          inputValue: isValid ? nextValidDate.format(defaultDateFormat).toString() : nextDate,
          isValid: isEmptyDate ? !required : isValid,
          viewedDate: isValid ? nextValidDate : moment(),
          open: isEmptyDate ? !!required : !isValid
        });
      }
    }
    /**
     * Callback when a day is selected or the link to reset to today is clicked
     * @param  {Object} value moment object
     * @return {void}         interacts with component state and callback from props
     */

  }, {
    key: "getTranslations",

    /**
     * Get provided translations or fall back to default values
     * @param  {String} key translation key
     * @return {String}     translation string
     */
    value: function getTranslations(key) {
      return this.mergedTranslations[key];
    }
    /**
     * Get all weeks touched by the current month and mark days within it
     * @return {Array} all visible days organized by week
     */

  }, {
    key: "getMonthDays",
    value: function getMonthDays() {
      var viewedDate = this.state.viewedDate; // Construct range consisting of all days in month and another range consisting
      // of all days of all weeks which the month is in

      var firstDay = moment(viewedDate).startOf('month');
      var lastDay = moment(viewedDate).endOf('month'); // Get the first Sunday of the first week and the last Saturday of the last week
      // touched by the current month

      var firstDayFirstWeek = moment(firstDay).isoWeekday() === 7 ? moment(firstDay) : moment(firstDay).startOf('isoweek').subtract(1, 'days');
      var lastDayLastWeek = moment(lastDay).isoWeekday() === 7 ? moment(lastDay).add(6, 'days') : moment(lastDay).endOf('isoweek').subtract(1, 'days'); // Create two ranges, one spanning all weeks touched by the current month,
      // and one spanning only the month

      var monthRange = moment.range(firstDay, lastDay);
      var fullWeekRange = moment.range(firstDayFirstWeek, lastDayLastWeek); // Return filled week bins

      return Array.from(fullWeekRange.by('days')).reduce(function (acc, val) {
        if (moment(val).day() % 7 === 0) {
          acc.push([]);
        }

        acc[acc.length - 1].push([moment(val), monthRange.contains(val)]);
        return acc;
      }, [[]]).filter(function (bin) {
        return bin.length > 1;
      });
    }
    /**
     * Renders year options
     * @return {ReactElement} option
     */

  }, {
    key: "renderYearOptions",
    value: function renderYearOptions() {
      var yearSpan = this.props.yearSpan;
      var viewedDate = this.state.viewedDate;
      var yearDuration = moment.duration({
        years: yearSpan
      });
      var prevYears = moment(viewedDate).subtract(yearDuration);
      var nextYears = moment(viewedDate).add(yearDuration);
      var yearsRange = moment.range(prevYears, nextYears);
      return Array.from(yearsRange.by('years')).map(function (momentYear) {
        var year = moment(momentYear).year();
        return React.createElement("option", {
          key: year,
          value: year
        }, year);
      });
    }
    /**
     * Renders year picker
     * @return {ReactElement} select
     */

  }, {
    key: "renderYearPicker",
    value: function renderYearPicker() {
      var viewedDate = this.state.viewedDate;
      return React.createElement("div", {
        className: "slds-shrink-none"
      }, React.createElement("label", {
        className: "slds-assistive-text",
        htmlFor: "select-01"
      }, "Pick a Year"), React.createElement("div", {
        className: "slds-select_container"
      }, React.createElement("select", {
        value: viewedDate.year(),
        className: "slds-select",
        onChange: this.onYearChange
      }, this.renderYearOptions())));
    }
    /**
     * Renders the monthly view including weeks and days
     * @return {ReactElement} tbody
     */

  }, {
    key: "renderMonth",
    value: function renderMonth() {
      var _this2 = this;

      var today = this.getTranslations('today');

      var onClick = function onClick() {
        return _this2.onDatepickerChange();
      };

      return React.createElement("tbody", null, this.getMonthDays().map(function (week, weekIndex) {
        return _this2.renderWeek(week, weekIndex);
      }), React.createElement("tr", null, React.createElement("td", {
        colSpan: "7",
        role: "gridcell"
      }, React.createElement("a", {
        onClick: onClick,
        className: "slds-show_inline-block slds-p-bottom_x-small"
      }, today))));
    }
    /**
     * Renders a week
     * @return {ReactElement} tr
     */

  }, {
    key: "renderWeek",
    value: function renderWeek(week, weekIndex) {
      var _this3 = this;

      return React.createElement("tr", {
        key: weekIndex
      }, week.map(function (_ref, dayIndex) {
        var _ref2 = _slicedToArray(_ref, 2),
            day = _ref2[0],
            inRange = _ref2[1];

        return _this3.renderDay(day, inRange, dayIndex);
      }));
    }
    /**
     * Renders a day
     * @return {ReactElement} td
     */

  }, {
    key: "renderDay",
    value: function renderDay(day, inRange, dayIndex) {
      var _this4 = this;

      var inputValue = this.state.inputValue;

      var onClick = function onClick() {
        return inRange && _this4.onDatepickerChange(day);
      };

      var isToday = day.isSame(moment(), 'day');
      var isSelected = day.isSame(moment(inputValue, defaultDateFormat), 'day');
      var classes = {
        'slds-is-today': day.isSame(moment(), 'day'),
        'slds-disabled-text': !inRange,
        'slds-is-selected': isSelected
      };
      return React.createElement("td", {
        "aria-disabled": !inRange ? 'true' : null,
        "aria-selected": isSelected,
        className: cx(classes),
        key: dayIndex,
        role: "gridcell",
        tabIndex: inRange ? '0' : null
      }, React.createElement("span", {
        className: "slds-day",
        onClick: onClick
      }, isToday && React.createElement("span", {
        className: "slds-assistive-text"
      }, "Today: "), day.date()));
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var _this$props5 = this.props,
          className = _this$props5.className,
          disabled = _this$props5.disabled,
          closeOnClickOutside = _this$props5.closeOnClickOutside,
          required = _this$props5.required;
      var _this$state = this.state,
          inputValue = _this$state.inputValue,
          isValid = _this$state.isValid,
          open = _this$state.open,
          viewedDate = _this$state.viewedDate;
      var viewedMonthName = moment(viewedDate).format('MMMM');
      var inputFieldLabel = this.getTranslations('inputFieldLabel');
      var inputFieldError = this.getTranslations('inputFieldError');
      var error = isValid ? undefined : inputFieldError;
      var placeholder = moment().localeData().longDateFormat(placeholderDateFormat);
      var condition = closeOnClickOutside && open;
      return React.createElement(ClickOutside, {
        onClickOutside: this.onClickOutside,
        condition: condition
      }, React.createElement("div", {
        className: className,
        style: {
          position: 'relative'
        }
      }, React.createElement(Input, {
        disabled: disabled,
        id: "date-input",
        label: inputFieldLabel,
        placeholder: placeholder,
        iconRight: "monthlyview",
        error: error,
        value: inputValue || '',
        onFocus: function onFocus(e) {
          return _this5.onInputFieldClick(e.target.value);
        },
        onChange: function onChange(e) {
          return _this5.onInputFieldChange(e.target.value);
        },
        required: required
      }), open && React.createElement("div", {
        "aria-label": "Date picker: ".concat(viewedMonthName),
        className: "slds-datepicker slds-dropdown slds-dropdown_left",
        role: "dialog"
      }, React.createElement("div", {
        className: "slds-datepicker__filter slds-grid"
      }, React.createElement("div", {
        className: "slds-datepicker__filter_month slds-grid slds-grid_align-spread slds-grow"
      }, React.createElement("div", {
        className: "slds-align-middle"
      }, React.createElement(IconButton, {
        onClick: function onClick() {
          return _this5.onMonthChange(-1);
        },
        sprite: "utility",
        icon: "left",
        container: true
      })), React.createElement("h2", {
        id: "month",
        className: "slds-align-middle"
      }, viewedDate.format('MMMM')), React.createElement("div", {
        className: "slds-align-middle"
      }, React.createElement(IconButton, {
        onClick: function onClick() {
          return _this5.onMonthChange(1);
        },
        sprite: "utility",
        icon: "right",
        container: true
      }))), this.renderYearPicker()), React.createElement("table", {
        className: "slds-datepicker__month",
        role: "grid"
      }, DatepickerRaw.renderWeekHeader(), this.renderMonth()))));
    }
  }]);

  return DatepickerRaw;
}(Component);

_defineProperty(DatepickerRaw, "validate", function (date) {
  return moment(date, iso8601DateFormat, true).isValid();
});

_defineProperty(DatepickerRaw, "isControlled", function (date) {
  return typeof date !== 'undefined';
});

DatepickerRaw.defaultProps = {
  className: null,
  closeOnClickOutside: false,
  date: undefined,
  disabled: false,
  initialDate: null,
  locale: 'en',
  open: false,
  required: false,
  timezone: 'America/Los_Angeles',
  translations: defaultTranslations,
  yearSpan: 2
};
DatepickerRaw.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Additional class name
   */
  className: PropTypes.string,

  /**
   * Date in ISO 8601 format (controlled component)
   */
  date: PropTypes.string,

  /**
   * Disabled state
   */
  disabled: PropTypes.bool,

  /**
   * Optional initial date in ISO 8601 format
   */
  initialDate: PropTypes.string,

  /**
   * Optional locale
   */
  locale: PropTypes.string,

  /**
   * Callback function once a date has been selected or the input has been changed
   * Returns the input value and whether it is valid or not
   */
  onChange: PropTypes.func.isRequired,

  /**
   * Whether the datepicker closes automatically on an outside click
   */
  closeOnClickOutside: PropTypes.bool,

  /**
   * Whether the datepicker is open or closed
   */
  open: PropTypes.bool,

  /**
   * Whether input is required
   */
  required: PropTypes.bool,

  /**
   * Optional timezone
   */
  timezone: PropTypes.string,

  /**
   * Optional translations, default is english
   */
  translations: PropTypes.shape({
    inputFieldError: PropTypes.string,
    inputFieldLabel: PropTypes.string,
    today: PropTypes.string
  }),

  /**
   * How many years to show before and after the current year
   */
  yearSpan: PropTypes.number
} : {};

var Datepicker = function Datepicker(props) {
  return React.createElement(DatepickerRaw, _extends({
    closeOnClickOutside: true
  }, props));
};

export default Datepicker;