import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Icon } from '../Icon';
import { MediaObject } from '../MediaObject';

var FileCaption = function FileCaption(_ref) {
  var fileType = _ref.fileType,
      hasActions = _ref.hasActions,
      title = _ref.title;
  var fileIcon = React.createElement(Icon, {
    icon: fileType,
    size: "x-small",
    sprite: "doctype",
    title: fileType
  });
  var captionClasses = ['slds-file__title', 'slds-file__title_card', {
    'slds-file-has-actions': hasActions
  }];
  return React.createElement("figcaption", {
    className: cx(captionClasses)
  }, React.createElement(MediaObject, {
    center: true,
    figureLeft: fileIcon,
    size: "small"
  }, React.createElement("span", {
    className: "slds-file__text slds-truncate",
    title: title
  }, title)));
};

FileCaption.propTypes = process.env.NODE_ENV !== "production" ? {
  fileType: PropTypes.string.isRequired,
  hasActions: PropTypes.bool.isRequired,
  title: PropTypes.string.isRequired
} : {};
export default FileCaption;