import React from 'react';
import PropTypes from 'prop-types';
import { Icon } from '../Icon';

var FileExternalIcon = function FileExternalIcon(_ref) {
  var externalIcon = _ref.externalIcon;
  var icon = externalIcon.icon,
      sprite = externalIcon.sprite,
      title = externalIcon.title;
  return React.createElement("div", {
    className: "slds-file__external-icon"
  }, React.createElement(Icon, {
    className: "slds-file__icon",
    svgClassName: "slds-icon-text-default",
    icon: icon,
    sprite: sprite,
    title: title
  }));
};

FileExternalIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  externalIcon: PropTypes.shape({
    icon: PropTypes.string,
    sprite: PropTypes.string,
    title: PropTypes.string
  }).isRequired
} : {};
export default FileExternalIcon;