import "core-js/modules/es.array.concat";
import React from 'react';
import PropTypes from 'prop-types';
import { Icon } from '../Icon';
import { Spinner } from '../Spinner';

var FileMedia = function FileMedia(_ref) {
  var fileType = _ref.fileType,
      image = _ref.image,
      isLoading = _ref.isLoading,
      title = _ref.title;
  if (isLoading) return React.createElement(Spinner, {
    size: "medium"
  });
  if (image && image.src) return React.createElement("img", {
    src: image.src,
    alt: image.alt || title
  });
  return React.createElement(Icon, {
    className: "slds-file__icon",
    sprite: "doctype",
    icon: fileType,
    title: "".concat(title, " : ").concat(fileType)
  });
};

FileMedia.defaultProps = {
  image: null
};
FileMedia.propTypes = process.env.NODE_ENV !== "production" ? {
  fileType: PropTypes.string.isRequired,
  image: PropTypes.shape({
    alt: PropTypes.string,
    src: PropTypes.string
  }),
  isLoading: PropTypes.bool.isRequired,
  title: PropTypes.string.isRequired
} : {};
export default FileMedia;