import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var FormElement = function FormElement(props) {
  var children = props.children,
      className = props.className,
      error = props.error,
      fieldset = props.fieldset,
      isStatic = props.isStatic,
      required = props.required,
      rest = _objectWithoutProperties(props, ["children", "className", "error", "fieldset", "isStatic", "required"]);

  var sldsClasses = ['slds-form-element', {
    'slds-has-error': !!error
  }, {
    'slds-is-required': required
  }, {
    'slds-form-element_readonly': isStatic
  }, className];
  var Tag = fieldset ? 'fieldset' : 'div';
  return React.createElement(Tag, _extends({}, rest, {
    className: cx(sldsClasses)
  }), children);
};

FormElement.defaultProps = {
  className: null,
  error: null,
  fieldset: false,
  isStatic: false,
  required: false
};
FormElement.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * form content
   */
  children: PropTypes.node.isRequired,

  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * can render errors for the given form element
   */
  error: PropTypes.string,

  /**
   * renders as a fieldset instead
   */
  fieldset: PropTypes.bool,

  /**
   * Renders in a static, "view" mode
   */
  isStatic: PropTypes.bool,

  /**
   * adds required-attribute to the form element
   */
  required: PropTypes.bool
} : {};
export default FormElement;