import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { getUniqueHash } from '../../utils';

var FormElementError = function FormElementError(props) {
  var className = props.className,
      error = props.error,
      id = props.id,
      rest = _objectWithoutProperties(props, ["className", "error", "id"]);

  var renderError = function renderError() {
    if (error) {
      var sldsClasses = ['slds-form-element__help', className];
      return React.createElement("div", _extends({}, rest, {
        id: getUniqueHash(error, id),
        className: cx(sldsClasses)
      }), error);
    }

    return null;
  };

  return renderError();
};

FormElementError.defaultProps = {
  error: null
};
FormElementError.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * element triggered on the containing form element
   */
  error: PropTypes.string,

  /**
   * id of the parent component carrying the error
   */
  id: PropTypes.string.isRequired
} : {};
export default FormElementError;