import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { applyDecorators, decoratorProp } from '../../utils';

var Container = function Container(props) {
  var El = props.as,
      children = props.children,
      className = props.className,
      flavor = props.flavor,
      size = props.size,
      rest = _objectWithoutProperties(props, ["as", "children", "className", "flavor", "size"]);

  var sldsClasses = [className, applyDecorators(flavor, 'container'), _defineProperty({}, "slds-container_".concat(size), !!size)];
  return React.createElement(El, _extends({}, rest, {
    className: cx(sldsClasses)
  }), children);
};

Container.defaultProps = {
  as: 'div',
  children: null,
  className: null,
  flavor: [],
  size: null
};
Container.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Allows using an arbitrary DOM element as container
   */
  as: PropTypes.string,

  /**
   * container content
   */
  children: PropTypes.node,

  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * flavor: array of flavors, you can also provide a single flavor as string.
   * Flavors: fluid, left, center, right
   */
  flavor: decoratorProp(['fluid', 'left', 'center', 'right']),

  /*
   * sizes: small, medium, large, x-large
   */
  size: PropTypes.oneOf(['small', 'medium', 'large', 'x-large'])
} : {};
export default Container;