import "core-js/modules/es.symbol";
import "core-js/modules/es.symbol.description";
import "core-js/modules/es.symbol.iterator";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.date.to-string";
import "core-js/modules/es.object.get-prototype-of";
import "core-js/modules/es.object.set-prototype-of";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.string.iterator";
import "core-js/modules/web.dom-collections.iterator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component, Fragment } from 'react';
import PropTypes from 'prop-types';
import { ResizeListener } from './ResizeListener';
export var OverflowContainer =
/*#__PURE__*/
function (_Component) {
  _inherits(OverflowContainer, _Component);

  function OverflowContainer() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, OverflowContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(OverflowContainer)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      overflowCount: 0
    });

    _defineProperty(_assertThisInitialized(_this), "calculateOverflow", function () {
      var _this$props = _this.props,
          containerRef = _this$props.containerRef,
          skipCalculation = _this$props.skipCalculation;
      if (skipCalculation || !containerRef || !containerRef.current) return;
      var currentOverflowCount = _this.state.overflowCount;
      var children = containerRef.current.children;
      if (children.length === 0) return; // Optimization: All pills have a static height due to truncation

      var pillHeight = children[0].clientHeight;
      var overflowCount = 0;

      for (var i = 0; i < children.length; i += 1) {
        var child = children[i];
        if (child.offsetTop >= pillHeight) overflowCount += 1;
      }

      if (currentOverflowCount !== overflowCount) {
        _this.setState({
          overflowCount: overflowCount
        });
      }
    });

    return _this;
  }

  _createClass(OverflowContainer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.calculateOverflow();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props2 = this.props,
          forcedUpdateTimestamp = _this$props2.forcedUpdateTimestamp,
          skipCalculation = _this$props2.skipCalculation;

      if (prevProps.skipCalculation && !skipCalculation || forcedUpdateTimestamp && forcedUpdateTimestamp > prevProps.forcedUpdateTimestamp) {
        this.calculateOverflow();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;
      var overflowCount = this.state.overflowCount;
      return React.createElement(Fragment, null, React.createElement(ResizeListener, {
        callback: this.calculateOverflow
      }), children({
        overflowCount: overflowCount
      }));
    }
  }]);

  return OverflowContainer;
}(Component);

_defineProperty(OverflowContainer, "defaultProps", {
  containerRef: {},
  forcedUpdateTimestamp: Date.now(),
  skipCalculation: false
});

OverflowContainer.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.func.isRequired,
  containerRef: PropTypes.object,
  forcedUpdateTimestamp: PropTypes.number,
  skipCalculation: PropTypes.bool
} : {};