import "core-js/modules/es.object.assign";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';

function rafThrottle(cb) {
  var currentExecution;

  var later = function later(context, args) {
    return function () {
      currentExecution = null;
      cb.apply(context, args);
    };
  };

  function throttled() {
    if (currentExecution == null) {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      currentExecution = requestAnimationFrame(later(this, args));
    }
  }

  return throttled;
}

export var withThrottle = function withThrottle(Cmp) {
  return function (props) {
    return React.createElement(Cmp, _extends({}, props, {
      throttleFn: rafThrottle
    }));
  };
};