import "core-js/modules/es.symbol";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var IconSVG = function IconSVG(props, _ref) {
  var assetBasePath = _ref.assetBasePath;

  var className = props.className,
      icon = props.icon,
      size = props.size,
      pathPrefix = props.pathPrefix,
      sprite = props.sprite,
      isButton = props.isButton,
      rest = _objectWithoutProperties(props, ["className", "icon", "size", "pathPrefix", "sprite", "isButton"]);

  var sldsClasses = [{
    'slds-icon': !isButton
  }, _defineProperty({}, "slds-icon_".concat(size), !!size), className];
  return React.createElement("svg", _extends({}, rest, {
    "aria-hidden": "true",
    className: cx(sldsClasses)
  }), React.createElement("use", {
    xlinkHref: "".concat(assetBasePath).concat(pathPrefix).concat(sprite, "-sprite/svg/symbols.svg#").concat(icon)
  }));
};

IconSVG.contextTypes = {
  assetBasePath: PropTypes.string
};
IconSVG.defaultProps = {
  className: null,
  pathPrefix: 'icons/',
  size: null,
  isButton: false
};
IconSVG.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * icon name
   */
  icon: PropTypes.string.isRequired,

  /**
   * Path between assetBasePath and the corresponding sprite.
   * This changed for <apex:slds /> between some SF apiVersions and is set to support 42.0
   */
  pathPrefix: PropTypes.string,

  /**
   * icon size
   */
  size: PropTypes.oneOf(['xx-small', 'x-small', 'small', 'medium', 'large']),

  /**
   * icon sprite name
   */
  sprite: PropTypes.string.isRequired,

  /**
   * removes slds_icon class (done internally by ButtonIcon)
   */
  isButton: PropTypes.bool
} : {};
export default IconSVG;