import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.array.map";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
var SCORES = ['negative', 'positive'];

var renderScore = function renderScore(score) {
  return React.createElement("svg", {
    key: score,
    viewBox: "0 0 5 5",
    className: "slds-icon-score__".concat(score),
    "aria-hidden": "true"
  }, React.createElement("circle", {
    cx: "50%",
    cy: "50%",
    r: "1.875"
  }));
};

var ScoreIcon = function ScoreIcon(props) {
  var assistiveText = props.assistiveText,
      className = props.className,
      score = props.score,
      title = props.title,
      rest = _objectWithoutProperties(props, ["assistiveText", "className", "score", "title"]);

  var assistive = assistiveText || title;
  return React.createElement("div", _extends({
    className: cx('slds-icon_container', className)
  }, rest), React.createElement("span", {
    className: "slds-icon-score",
    "data-slds-state": score,
    title: title
  }, SCORES.map(renderScore), assistive && React.createElement("span", {
    className: "slds-assistive-text"
  }, assistive)));
};

ScoreIcon.defaultProps = {
  assistiveText: null,
  className: null,
  title: null
};
ScoreIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * AssistiveText of icon. Defaults to `title` if not present
   */
  assistiveText: PropTypes.string,

  /**
   * Additional classes that will be applied to `span#slds-icon-score`
   */
  className: PropTypes.string,

  /**
   * Indicates the icon that will be rendered: `positive` or `negative`
   */
  score: PropTypes.oneOf(SCORES).isRequired,

  /**
   * Sets a `title` tooltip. Also sets `assistiveText` if prop not present
   */
  title: PropTypes.string
} : {};
export default ScoreIcon;