import "core-js/modules/es.symbol";
import "core-js/modules/es.symbol.description";
import "core-js/modules/es.symbol.iterator";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.filter";
import "core-js/modules/es.array.for-each";
import "core-js/modules/es.array.from";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.array.map";
import "core-js/modules/es.array.some";
import "core-js/modules/es.date.to-string";
import "core-js/modules/es.function.name";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.get-own-property-descriptor";
import "core-js/modules/es.object.get-own-property-descriptors";
import "core-js/modules/es.object.get-prototype-of";
import "core-js/modules/es.object.keys";
import "core-js/modules/es.object.set-prototype-of";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.promise";
import "core-js/modules/es.regexp.to-string";
import "core-js/modules/es.string.iterator";
import "core-js/modules/es.string.starts-with";
import "core-js/modules/web.dom-collections.for-each";
import "core-js/modules/web.dom-collections.iterator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import debounce from 'lodash-es/debounce';
import omit from 'lodash-es/omit';
import { FormElement, FormElementControl, FormElementError, FormElementLabel, InputRaw } from '../Form';
import { Cell, Row, Table } from '../Table';
import { Pill, PillContainer } from '../Pill';
import { Icon } from '../Icon';
import { ClickOutside } from '../ClickOutside'; // https://github.com/oliviertassinari/babel-plugin-transform-react-remove-prop-types#is-it-safe

var propTypes = {
  /**
   * if set to true, allows the creation of new elements that were not found
   * during lookups. For example new email addresses.
   * The new entry will not have an object type and the ID will be the current
   * timestamp.
   */
  allowCreate: PropTypes.bool,

  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * renders a different layour without borders (bare) for email docked
   * composer
   */
  emailLayout: PropTypes.bool,

  /**
   * renders an error for the lookup. shows an error messsage if error is a string.
   */
  error: PropTypes.string,

  /**
   * whether the lookup error message is hidden
   */
  hideErrorMessage: PropTypes.bool,

  /**
   * whether the lookup label is hidden
   */
  hideLabel: PropTypes.bool,

  /**
  * id of the input field in the lookup component
  */
  id: PropTypes.string.isRequired,

  /**
   * initial item selection. use with uncontrolled lookup
   */
  initialSelection: PropTypes.array,

  /**
   * label for the input field in the lookup component
   */
  inputLabel: PropTypes.oneOfType([PropTypes.string, PropTypes.node]).isRequired,

  /**
   * label for the dropdown in the lookup component
   */
  listLabel: PropTypes.string.isRequired,

  /**
   * loads items into the lookup component
   */
  load: PropTypes.func.isRequired,

  /**
   * set true to call load() onInputChange (defaults to true)
   */
  loadOnChange: PropTypes.bool,

  /**
   * set true to call load() onInputFocus (defaults to false)
   */
  loadOnFocus: PropTypes.bool,

  /**
   * set true to call load() onComponentDidMount (defaults to false)
   */
  loadOnMount: PropTypes.bool,

  /**
   * renders the lookup in multiple mode
   */
  multi: PropTypes.bool,

  /**
   * type of object that is queried via the lookup. if it changes, loaded items will be reset
   */
  objectType: PropTypes.string,

  /**
   * if set, closes lookup on an outside click
   */
  closeOnClickOutside: PropTypes.bool,

  /**
   * onChange handler for the lookup. has selected items as first argument
   */
  onChange: PropTypes.func.isRequired,

  /**
   * onFocus handler for the input field in the lookup
   */
  onFocus: PropTypes.func,

  /**
   * placeholder for the input field in lookup
   */
  placeholder: PropTypes.string,

  /**
   * Callback for rendering additional meta information for a list item.
   */
  renderMeta: PropTypes.func,

  /**
   * Callback for rendering a single selection pill.
   */
  renderSelection: PropTypes.func,

  /**
   * Marks the field as required
   */
  required: PropTypes.bool,

  /**
   * current item selection. use with controlled lookup
   */
  selection: PropTypes.array,

  /**
   * if set, renders the Advanced Modal table layout
   */
  table: PropTypes.bool,
  tableFields: PropTypes.arrayOf(PropTypes.shape({
    name: PropTypes.string.isRequired,
    label: PropTypes.string.isRequired
  })),

  /**
   * Label behind the number of Results in the table header
   */
  tableResultsHeading: PropTypes.string
};
export var LookupRaw =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(LookupRaw, _PureComponent);

  _createClass(LookupRaw, null, [{
    key: "filterDisplayItems",
    value: function filterDisplayItems(src, target) {
      var prop = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'id';
      return src.filter(function (o1) {
        return !target.some(function (o2) {
          return o1[prop] === o2[prop];
        });
      });
    }
  }, {
    key: "getSprite",
    value: function getSprite() {
      var objectType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      if (objectType.startsWith('custom')) {
        return 'custom';
      }

      return 'standard';
    }
  }]);

  function LookupRaw(props, context) {
    var _this;

    _classCallCheck(this, LookupRaw);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LookupRaw).call(this, props, context)); // eslint-disable-next-line

    _defineProperty(_assertThisInitialized(_this), "onClickOutside", function () {
      _this.closeList(false);
    });

    _defineProperty(_assertThisInitialized(_this), "handleLoad", function (searchTerm) {
      var prevSearchTerm = _this.state.searchTerm;
      var load = _this.props.load;
      var param = typeof term === 'string' ? searchTerm : prevSearchTerm;

      var onSuccess = function onSuccess(data) {
        if (Array.isArray(data)) {
          _this.setState({
            loaded: data
          });
        }

        return data;
      };

      return Promise.resolve(load(param)).then(onSuccess);
    });

    _defineProperty(_assertThisInitialized(_this), "handleInputChange", function (event) {
      var loadOnChange = _this.props.loadOnChange;
      var value = event.target.value;

      _this.setState({
        searchTerm: value
      });

      if (loadOnChange) {
        _this.handleLoad(value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleInputFocus", function (event) {
      var _this$props = _this.props,
          loadOnFocus = _this$props.loadOnFocus,
          onFocus = _this$props.onFocus;

      _this.openList();

      if (onFocus) {
        onFocus(event);
      }

      if (loadOnFocus) {
        _this.handleLoad();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleCreateElement", function (event) {
      var charCode = event.charCode,
          value = event.target.value;
      var _this$props2 = _this.props,
          allowCreate = _this$props2.allowCreate,
          emailLayout = _this$props2.emailLayout,
          multi = _this$props2.multi;
      var _this$state = _this.state,
          loaded = _this$state.loaded,
          selected = _this$state.selected;
      var isEnterPress = charCode === 13 || typeof charCode === 'undefined';
      var isAllowed = allowCreate && loaded.length === 0;
      var isMultiOrEmpty = multi || selected.length === 0;
      var isValid = emailLayout ? /^.+@.+\..+$/.test(value) : value !== '';

      if (isEnterPress && isValid && isAllowed && isMultiOrEmpty) {
        _this.createElement(value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "openList", function () {
      var multi = _this.props.multi;
      var _this$state2 = _this.state,
          open = _this$state2.open,
          selected = _this$state2.selected;

      if (!open) {
        if (!multi && selected.length <= 1) {
          _this.setState({
            open: true
          });
        }

        if (multi) {
          _this.setState({
            open: true
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "closeList", function () {
      var clearSearch = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      _this.setState(_objectSpread({
        open: false
      }, clearSearch ? {
        searchTerm: ''
      } : {}));
    });

    _defineProperty(_assertThisInitialized(_this), "defaultRenderSelection", function (item, _ref) {
      var onClose = _ref.onClose;
      var id = item.id,
          label = item.label,
          objectType = item.objectType;
      var multi = _this.props.multi;
      return React.createElement(Pill, {
        key: id,
        className: !multi ? 'slds-size_1-of-1' : null,
        icon: objectType && React.createElement(Icon, {
          sprite: LookupRaw.getSprite(objectType),
          icon: objectType
        }),
        id: id,
        title: label,
        label: label,
        onClose: onClose
      });
    });

    _defineProperty(_assertThisInitialized(_this), "createElement", function (value) {
      var _this$props3 = _this.props,
          onChange = _this$props3.onChange,
          selection = _this$props3.selection;
      var selected = _this.state.selected;
      var newItem = {
        id: Date.now(),
        label: value
      };
      var nextSelection = [].concat(_toConsumableArray(selected), [newItem]);

      if (!selection) {
        _this.setState({
          selected: nextSelection
        });
      }

      onChange(nextSelection);

      _this.closeList();
    });

    _defineProperty(_assertThisInitialized(_this), "highlightSelection", function (id) {
      _this.setState({
        highlighted: id
      });
    });

    console.info('[react-lds] Lookup:', 'This component is deprecated and will be removed in a future version', 'Please migrate to `EntityCombobox`');
    var initialSelection = props.initialSelection,
        _selection = props.selection;

    if (initialSelection && _selection) {
      // eslint-disable-next-line
      console.warn('[react-lds] Lookup:', 'You are supplying both `selection` & `initialSelection`, ignoring `initialSelection`.', 'The component will work as a controlled component');
    }

    var initialSelected = [];

    if (_selection && _selection.length > 0) {
      initialSelected = _selection;
    } else if (!_selection && initialSelection && initialSelection.length > 0) {
      initialSelected = initialSelection;
    }

    _this.state = {
      searchTerm: '',
      highlighted: null,
      open: false,
      loaded: [],
      selected: initialSelected
    };
    _this.handleLoad = debounce(_this.handleLoad, 500);
    return _this;
  }

  _createClass(LookupRaw, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var loadOnMount = this.props.loadOnMount;

      if (loadOnMount) {
        this.handleLoad();
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var objectType = this.props.objectType;

      if (objectType !== nextProps.objectType) {
        this.setState({
          loaded: [],
          selected: []
        });
      }

      if (nextProps.selection) {
        this.setState({
          selected: nextProps.selection
        });
      }
    }
  }, {
    key: "addSelection",
    value: function addSelection(item) {
      var _this$props4 = this.props,
          multi = _this$props4.multi,
          onChange = _this$props4.onChange,
          selection = _this$props4.selection;
      var selected = this.state.selected;
      var isNewItem = selected.indexOf(item) === -1;
      var nextSelection = multi ? [].concat(_toConsumableArray(selected), [item]) : [item];

      if (isNewItem && !selection) {
        this.setState({
          selected: nextSelection
        });
      }

      onChange(nextSelection);
      this.closeList();
    }
  }, {
    key: "removeSelection",
    value: function removeSelection(item) {
      var _this$props5 = this.props,
          onChange = _this$props5.onChange,
          selection = _this$props5.selection;
      var selected = this.state.selected;
      var nextSelection = selected.filter(function (select) {
        return select.id !== item.id;
      });

      if (!selection) {
        this.setState({
          selected: nextSelection
        });
      }

      onChange(nextSelection);
    }
  }, {
    key: "renderInput",
    value: function renderInput() {
      var _this$props6 = this.props,
          emailLayout = _this$props6.emailLayout,
          id = _this$props6.id,
          placeholder = _this$props6.placeholder,
          required = _this$props6.required;
      var _this$state3 = this.state,
          highlighted = _this$state3.highlighted,
          open = _this$state3.open,
          searchTerm = _this$state3.searchTerm,
          selected = _this$state3.selected;

      if (!open && selected.length > 0) {
        return null;
      }

      return React.createElement(FormElementControl, {
        hasIconRight: !emailLayout
      }, React.createElement(InputRaw, {
        "aria-activedescendant": highlighted,
        "aria-expanded": open,
        bare: emailLayout,
        className: emailLayout ? 'slds-input_height' : null,
        iconRight: emailLayout ? null : 'search',
        id: id,
        onBlur: this.handleCreateElement,
        onChange: this.handleInputChange,
        onFocus: this.handleInputFocus,
        onKeyPress: this.handleCreateElement,
        placeholder: emailLayout ? null : placeholder,
        required: required,
        role: "combobox",
        type: "text",
        value: searchTerm
      }));
    }
  }, {
    key: "renderError",
    value: function renderError() {
      var _this$props7 = this.props,
          error = _this$props7.error,
          hideErrorMessage = _this$props7.hideErrorMessage,
          id = _this$props7.id;
      return !hideErrorMessage && React.createElement(FormElementError, {
        error: error,
        id: id
      });
    }
  }, {
    key: "renderSelections",
    value: function renderSelections() {
      var _this2 = this;

      var _this$props8 = this.props,
          emailLayout = _this$props8.emailLayout,
          customRenderSelection = _this$props8.renderSelection;
      var selected = this.state.selected;

      if (selected.length < 1) {
        return null;
      }

      var renderSelectionFn = customRenderSelection || this.defaultRenderSelection;

      var renderSelection = function renderSelection(item, index) {
        var options = {
          index: index,
          onClose: function onClose() {
            return _this2.removeSelection(item);
          }
        };
        return renderSelectionFn(item, options, _this2.props);
      };

      return React.createElement(PillContainer, {
        bare: emailLayout,
        onClick: this.openList
      }, selected.map(renderSelection));
    }
  }, {
    key: "renderLookupList",
    value: function renderLookupList() {
      var _this3 = this;

      var _this$props9 = this.props,
          listLabel = _this$props9.listLabel,
          renderMeta = _this$props9.renderMeta,
          table = _this$props9.table;
      var _this$state4 = this.state,
          loaded = _this$state4.loaded,
          open = _this$state4.open,
          selected = _this$state4.selected;
      var displayItems = LookupRaw.filterDisplayItems(loaded, selected);

      if (table || !open || displayItems.length < 1) {
        return null;
      }

      var renderLookupItem = function renderLookupItem(item, i) {
        var id = _this3.props.id;
        var objectType = item.objectType,
            label = item.label,
            itemId = item.id,
            meta = item.meta;
        var lookupItemClasses = ['slds-lookup__item-action', 'slds-media', 'slds-media_center'];
        return React.createElement("li", {
          key: i,
          role: "presentation"
        }, React.createElement("span", {
          className: cx(lookupItemClasses),
          id: "".concat(id, "-option-").concat(i),
          onClick: function onClick() {
            return _this3.addSelection(item);
          },
          onMouseOver: function onMouseOver() {
            return _this3.highlightSelection(itemId);
          },
          role: "option"
        }, React.createElement(Icon, {
          className: "slds-m-right_x-small",
          sprite: LookupRaw.getSprite(objectType),
          icon: objectType,
          size: "small"
        }), React.createElement("div", {
          className: "slds-media__body"
        }, React.createElement("div", {
          className: "slds-lookup__result-text"
        }, label), renderMeta && renderMeta(item), !renderMeta && meta && React.createElement("span", {
          className: "slds-lookup__result-meta slds-text-body_small"
        }, meta))));
      };

      return React.createElement("div", {
        className: "slds-lookup__menu",
        role: "listbox"
      }, React.createElement("div", {
        className: "slds-lookup__item_label slds-text-body_small"
      }, listLabel), React.createElement("ul", {
        className: "slds-lookup__list",
        role: "presentation"
      }, displayItems.map(renderLookupItem)));
    }
  }, {
    key: "renderLookupTable",
    value: function renderLookupTable() {
      var _this4 = this;

      var _this$props10 = this.props,
          table = _this$props10.table,
          tableFields = _this$props10.tableFields,
          tableResultsHeading = _this$props10.tableResultsHeading;
      var _this$state5 = this.state,
          loaded = _this$state5.loaded,
          selected = _this$state5.selected;
      var displayItems = LookupRaw.filterDisplayItems(loaded, selected);

      if (!table || displayItems.length < 1) {
        return null;
      }

      var renderBodyCell = function renderBodyCell(content, index, objectType) {
        if (index === 0) {
          return React.createElement("a", null, objectType && React.createElement(Icon, {
            size: "small",
            className: "slds-m-right_x-small",
            sprite: LookupRaw.getSprite(objectType),
            icon: objectType
          }), content);
        }

        return content;
      };

      var header = React.createElement("thead", null, React.createElement(Row, null, React.createElement(Cell, {
        scope: "col",
        colSpan: tableFields.length
      }, "".concat(displayItems.length, " ").concat(tableResultsHeading))), React.createElement(Row, null, tableFields.map(function (_ref2) {
        var name = _ref2.name,
            label = _ref2.label;
        return React.createElement(Cell, {
          scope: "col",
          key: name
        }, label);
      })));
      var body = React.createElement("tbody", null, displayItems.map(function (item) {
        return React.createElement(Row, {
          key: item.id
        }, tableFields.map(function (_ref3, index) {
          var name = _ref3.name;
          return React.createElement(Cell, {
            "data-label": name,
            scope: index === 0 ? 'row' : null,
            onClick: function onClick() {
              return _this4.addSelection(item);
            },
            key: "".concat(item.id, "-").concat(name)
          }, renderBodyCell(item[name], index, item.objectType));
        }));
      }));
      return React.createElement(Table, {
        flavor: "bordered",
        className: "slds-m-top_small"
      }, header, body);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props11 = this.props,
          className = _this$props11.className,
          closeOnClickOutside = _this$props11.closeOnClickOutside,
          emailLayout = _this$props11.emailLayout,
          error = _this$props11.error,
          hideLabel = _this$props11.hideLabel,
          id = _this$props11.id,
          inputLabel = _this$props11.inputLabel,
          multi = _this$props11.multi,
          required = _this$props11.required;
      var open = this.state.open;
      var rest = omit(this.props, Object.keys(propTypes));
      var sldsClasses = ['slds-lookup', {
        'slds-is-open': open
      }, className];
      var wrapperClasses = ['slds-grid', 'slds-grow', 'slds-p-horizontal_small'];
      var scope = multi ? null : 'single';
      var condition = closeOnClickOutside && open;
      return React.createElement("div", {
        className: emailLayout ? cx(wrapperClasses) : null
      }, emailLayout && React.createElement("label", {
        className: "slds-email-composer__label slds-align-middle",
        htmlFor: id
      }, required && React.createElement("abbr", {
        className: "slds-required",
        title: "required"
      }, "*"), inputLabel), React.createElement(FormElement, _extends({}, rest, {
        className: cx(sldsClasses),
        "data-select": scope,
        "data-scope": scope,
        error: error
      }), !emailLayout && React.createElement(FormElementLabel, {
        hideLabel: hideLabel,
        id: id,
        label: inputLabel,
        required: required
      }), React.createElement(ClickOutside, {
        onClickOutside: this.onClickOutside,
        condition: condition
      }, this.renderInput(), this.renderSelections(), this.renderError(), this.renderLookupList())), this.renderLookupTable());
    }
  }]);

  return LookupRaw;
}(PureComponent);

_defineProperty(LookupRaw, "defaultProps", {
  allowCreate: false,
  className: null,
  closeOnClickOutside: false,
  emailLayout: false,
  error: null,
  hideErrorMessage: false,
  hideLabel: false,
  initialSelection: null,
  loadOnChange: true,
  loadOnFocus: true,
  loadOnMount: false,
  multi: false,
  objectType: 'default',
  onFocus: null,
  placeholder: 'Search',
  renderMeta: null,
  renderSelection: null,
  required: false,
  selection: null,
  table: false,
  tableFields: [],
  tableResultsHeading: 'Results'
});

LookupRaw.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};

var Lookup = function Lookup(props) {
  return React.createElement(LookupRaw, _extends({
    closeOnClickOutside: true
  }, props));
};

export default Lookup;