import "core-js/modules/es.symbol";
import "core-js/modules/es.symbol.description";
import "core-js/modules/es.symbol.iterator";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.get-prototype-of";
import "core-js/modules/es.object.set-prototype-of";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.string.iterator";
import "core-js/modules/web.dom-collections.iterator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import omit from 'lodash-es/omit';
import ControlledMenu from './ControlledMenu';
import { ClickOutside } from '../ClickOutside'; // https://github.com/oliviertassinari/babel-plugin-transform-react-remove-prop-types#is-it-safe

var propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * The button that triggers the dropdown menu
   */
  button: PropTypes.element.isRequired,

  /**
  * indicates if the menu closes automatically on an outside click
  */
  closeOnClickOutside: PropTypes.bool,

  /**
   * menu should start open
   */
  defaultOpen: PropTypes.bool,

  /**
   * Called when menu is opened/closed
   */
  onToggle: PropTypes.func
} : {};
export var MenuRaw =
/*#__PURE__*/
function (_Component) {
  _inherits(MenuRaw, _Component);

  function MenuRaw(props) {
    var _this;

    _classCallCheck(this, MenuRaw);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(MenuRaw).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "onClickOutside", function () {
      return _this.setState({
        open: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getButton", function () {
      var button = _this.props.button;
      return React.cloneElement(button, {
        onClick: _this.toggle
      });
    });

    _defineProperty(_assertThisInitialized(_this), "toggle", function () {
      var onToggle = _this.props.onToggle;
      onToggle(!_this.state.open);

      _this.setState(function (prevState) {
        return {
          open: !prevState.open
        };
      });
    });

    var defaultOpen = _this.props.defaultOpen;
    _this.state = {
      open: defaultOpen
    };
    return _this;
  }

  _createClass(MenuRaw, [{
    key: "render",
    value: function render() {
      var closeOnClickOutside = this.props.closeOnClickOutside;
      var open = this.state.open;
      var rest = omit(this.props, ['button', 'defaultOpen', 'closeOnClickOutside']);
      var condition = closeOnClickOutside && open;
      return React.createElement(ClickOutside, {
        onClickOutside: this.onClickOutside,
        condition: condition
      }, React.createElement(ControlledMenu, _extends({}, rest, {
        button: this.getButton(),
        isOpen: open
      })));
    }
  }]);

  return MenuRaw;
}(Component);

_defineProperty(MenuRaw, "defaultProps", {
  closeOnClickOutside: false,
  defaultOpen: false,
  onToggle: Function.prototype
});

MenuRaw.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};

var Menu = function Menu(props) {
  return React.createElement(MenuRaw, _extends({
    closeOnClickOutside: true
  }, props));
};

export default Menu;