import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var MenuSubHeader = function MenuSubHeader(props) {
  var children = props.children,
      className = props.className,
      divider = props.divider,
      rest = _objectWithoutProperties(props, ["children", "className", "divider"]);

  var sldsClasses = ['slds-dropdown__header', 'slds-truncate', {
    'slds-has-divider_top-space': divider
  }, className];
  return React.createElement("li", _extends({
    className: cx(sldsClasses),
    title: children,
    role: "separator"
  }, rest), React.createElement("span", null, children));
};

MenuSubHeader.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * The content of a menu item sub header, should be string or an element
   */
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.element]).isRequired,

  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * set to true if a divider should appear above this list item
   */
  divider: PropTypes.bool
  /**
   * left icon that is only shown when selected is true
   */

} : {};
MenuSubHeader.defaultProps = {
  className: null,
  divider: false
};
export default MenuSubHeader;