import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var ModalContent = function ModalContent(_ref) {
  var children = _ref.children,
      className = _ref.className,
      collapsePadding = _ref.collapsePadding,
      id = _ref.id,
      _ = _ref.onClose,
      rest = _objectWithoutProperties(_ref, ["children", "className", "collapsePadding", "id", "onClose"]);

  return React.createElement("div", _extends({}, rest, {
    className: cx('slds-modal__content', {
      'slds-p-around_medium': !collapsePadding
    }, className),
    id: id
  }), children);
};

ModalContent.defaultProps = {
  className: null,
  collapsePadding: false,
  id: null
};
ModalContent.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Modal content
   */
  children: PropTypes.node.isRequired,

  /**
   * className that will be merged
   */
  className: PropTypes.string,

  /**
   * Whether the standard padding should be collapsed
   */
  collapsePadding: PropTypes.bool,

  /**
   * (PRIVATE) passed down from Modal
   */
  id: PropTypes.string
} : {};
export default ModalContent;