import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Button } from '../Button';

var ModalFooter = function ModalFooter(_ref) {
  var children = _ref.children,
      className = _ref.className,
      closeButtonLabel = _ref.closeButtonLabel,
      directional = _ref.directional,
      hideCloseButton = _ref.hideCloseButton,
      onClose = _ref.onClose,
      _ = _ref.id,
      rest = _objectWithoutProperties(_ref, ["children", "className", "closeButtonLabel", "directional", "hideCloseButton", "onClose", "id"]);

  return React.createElement("footer", _extends({}, rest, {
    className: cx('slds-modal__footer', {
      'slds-modal__footer_directional': directional
    }, className)
  }), !hideCloseButton && !!onClose && React.createElement(Button, {
    onClick: onClose
  }, closeButtonLabel), children);
};

ModalFooter.defaultProps = {
  children: null,
  className: null,
  directional: false,
  hideCloseButton: false,
  closeButtonLabel: 'Cancel',
  onClose: null
};
ModalFooter.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Additional content in ModalFooter. Usually used to add a confirm button
   */
  children: PropTypes.node,

  /**
   * className that will be merged
   */
  className: PropTypes.string,

  /**
   * Renders a directional footer
   */
  directional: PropTypes.bool,

  /**
   * Hides the closeButton when `onClose` is set
   */
  hideCloseButton: PropTypes.bool,

  /**
   * Label for the closeButton that will be rendered
   */
  closeButtonLabel: PropTypes.string,

  /**
   * (PRIVATE) Passed down from Modal. Renders a close button with `closeButtonLabel`
   */
  onClose: PropTypes.func
} : {};
export default ModalFooter;