import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
export var List = function List(_ref) {
  var children = _ref.children,
      className = _ref.className,
      mode = _ref.mode,
      rest = _objectWithoutProperties(_ref, ["children", "className", "mode"]);

  return React.createElement("dl", _extends({}, rest, {
    className: cx(["slds-list_".concat(mode), {
      'slds-wrap': mode === 'horizontal'
    }, className])
  }), children);
};
List.defaultProps = {
  className: null,
  mode: 'horizontal'
};
List.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * one or more sets of `Value` or `Name` components
   */
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  mode: PropTypes.oneOf(['horizontal', 'inline', 'stacked'])
} : {};

var NameOrValue = function NameOrValue(_ref2) {
  var El = _ref2.as,
      className = _ref2.className,
      children = _ref2.children,
      title = _ref2.title,
      rest = _objectWithoutProperties(_ref2, ["as", "className", "children", "title"]);

  return React.createElement(El, _extends({}, rest, {
    className: cx([className, 'slds-truncate']),
    title: title || (typeof children === 'string' ? children : '')
  }), children);
};

NameOrValue.defaultProps = {
  className: null,
  title: null
};
NameOrValue.propTypes = process.env.NODE_ENV !== "production" ? {
  as: PropTypes.oneOf(['dd', 'dt']).isRequired,
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  title: PropTypes.string
} : {};
export var Name = function Name(_ref3) {
  var className = _ref3.className,
      rest = _objectWithoutProperties(_ref3, ["className"]);

  return React.createElement(NameOrValue, _extends({}, rest, {
    as: "dt",
    className: cx(['slds-item_label', 'slds-text-color_weak', className])
  }));
};
Name.defaultProps = {
  className: null,
  title: null
};
Name.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,

  /**
   * additional class names, added to `dt`
   */
  className: PropTypes.string,

  /**
   * title `attribute`, overwrites `children` if `children` is a string
   */
  title: PropTypes.string
} : {};
export var Value = function Value(_ref4) {
  var className = _ref4.className,
      rest = _objectWithoutProperties(_ref4, ["className"]);

  return React.createElement(NameOrValue, _extends({}, rest, {
    as: "dd",
    className: cx(['slds-item_detail', className])
  }));
};
Value.defaultProps = {
  className: null,
  title: null
};
Value.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,

  /**
   * additional class names, added to `dd`
   */
  className: PropTypes.string,

  /**
   * title `attribute`, overwrites `children` if `children` is a string
   */
  title: PropTypes.string
} : {};