import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Icon } from '../Icon';
import { MediaObject } from '../MediaObject';

var PageHeaderBase = function PageHeaderBase(props) {
  var className = props.className,
      _props$icon = props.icon,
      icon = _props$icon.icon,
      sprite = _props$icon.sprite,
      info = props.info,
      title = props.title,
      rest = _objectWithoutProperties(props, ["className", "icon", "info", "title"]);

  var sldsClasses = ['slds-page-header', className];
  return React.createElement("div", _extends({}, rest, {
    className: cx(sldsClasses)
  }), React.createElement("div", {
    className: "slds-page-header__row"
  }, React.createElement("div", {
    className: "slds-page-header__col-title"
  }, React.createElement(MediaObject, {
    figureLeft: React.createElement(Icon, {
      sprite: sprite,
      icon: icon,
      svgClassName: "slds-page-header__icon"
    })
  }, React.createElement("div", {
    className: "slds-page-header__name"
  }, React.createElement("div", {
    className: "slds-page-header__name-title"
  }, React.createElement("h1", null, React.createElement("span", {
    className: "slds-page-header__title slds-truncate",
    title: title
  }, title)))), React.createElement("p", {
    className: "slds-page-header__name-meta"
  }, info)))));
};

PageHeaderBase.defaultProps = {
  className: null
};
PageHeaderBase.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * icon and sprite
   */
  icon: PropTypes.shape({
    sprite: PropTypes.string.isRequired,
    icon: PropTypes.string.isRequired
  }).isRequired,

  /**
   * info subtitle
   */
  info: PropTypes.string.isRequired,

  /**
   * title
   */
  title: PropTypes.string.isRequired
} : {};
export default PageHeaderBase;