import "core-js/modules/es.symbol";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.array.map";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import ObjectHome from './ObjectHome';

var RecordHome = function RecordHome(_ref) {
  var detailItems = _ref.detailItems,
      headerButtons = _ref.headerButtons,
      icon = _ref.icon,
      recordType = _ref.recordType,
      title = _ref.title,
      rest = _objectWithoutProperties(_ref, ["detailItems", "headerButtons", "icon", "recordType", "title"]);

  return React.createElement(ObjectHome, _extends({}, rest, {
    icon: icon,
    recordType: recordType,
    title: title,
    topButtons: headerButtons,
    bottomButtons: null,
    titleMenu: null
  }), React.createElement("div", {
    className: "slds-page-header__row slds-page-header__row_gutters"
  }, React.createElement("div", {
    className: "slds-page-header__col-details"
  }, detailItems.length > 0 && React.createElement("ul", {
    className: "slds-grid slds-page-header__detail-row"
  }, detailItems.map(function (_ref2, index) {
    var itemTitle = _ref2.title,
        itemContent = _ref2.content;
    return (// eslint-disable-next-line react/no-array-index-key
      React.createElement("li", {
        className: "slds-page-header__detail-block",
        key: "".concat(itemTitle, "-").concat(index)
      }, React.createElement("div", {
        className: "slds-text-title slds-truncate",
        title: itemTitle
      }, itemTitle), React.createElement("div", {
        className: "slds-truncate",
        title: itemContent
      }, itemContent))
    );
  })))));
};

RecordHome.defaultProps = {
  className: null,
  detailItems: [],
  headerButtons: null
};
RecordHome.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * entries for the detail row, can be just strings or more complex nodes like
   * links or text with icons etc...
   */
  detailItems: PropTypes.arrayOf(PropTypes.shape({
    title: PropTypes.node.isRequired,
    content: PropTypes.node.isRequired
  })),

  /**
   * buttons that are rendered on the right side of the header
   */
  headerButtons: PropTypes.node,

  /**
   * sprite and icon
   */
  icon: PropTypes.shape({
    sprite: PropTypes.string.isRequired,
    icon: PropTypes.string.isRequired
  }).isRequired,

  /**
   * record type header above the title
   */
  recordType: PropTypes.string.isRequired,

  /**
   * title
   */
  title: PropTypes.string.isRequired
} : {};
export default RecordHome;