import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var Path = function Path(props) {
  var button = props.button,
      children = props.children,
      className = props.className,
      rest = _objectWithoutProperties(props, ["button", "children", "className"]);

  var sldsClasses = ['slds-path-coach', className];
  return React.createElement("div", _extends({
    className: cx(sldsClasses)
  }, rest), React.createElement("div", {
    className: "slds-grid"
  }, React.createElement("div", {
    className: "slds-tabs_path",
    role: "application"
  }, React.createElement("ul", {
    className: "slds-tabs_path__nav",
    role: "listbox"
  }, children)), button));
};

Path.defaultProps = {
  className: null
};
Path.propTypes = process.env.NODE_ENV !== "production" ? {
  /*
   * button to change selected stage status
   */
  button: PropTypes.node.isRequired,

  /*
   * children should be PathStages
   */
  children: PropTypes.node.isRequired,

  /*
   * class name
   */
  className: PropTypes.string
} : {};
export default Path;