import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { IconSVG } from '../Icon';

var PathStage = function PathStage(props) {
  var assistiveText = props.assistiveText,
      className = props.className,
      complete = props.complete,
      current = props.current,
      label = props.label,
      onStageClick = props.onStageClick,
      selected = props.selected,
      rest = _objectWithoutProperties(props, ["assistiveText", "className", "complete", "current", "label", "onStageClick", "selected"]);

  var sldsClasses = ['slds-tabs_path__item', {
    'slds-is-complete': complete
  }, {
    'slds-is-current': current
  }, {
    'slds-is-incomplete': !complete && !current
  }, {
    'slds-is-active': selected && !current
  }, className];
  return React.createElement("li", _extends({
    className: cx(sldsClasses),
    role: "presentation"
  }, rest), React.createElement("a", {
    "aria-selected": selected,
    className: "slds-tabs_path__link",
    role: "option",
    tabIndex: selected ? 0 : -1,
    onClick: onStageClick
  }, React.createElement("span", {
    className: "slds-tabs_path__stage"
  }, complete && React.createElement(IconSVG, {
    sprite: "utility",
    icon: "check",
    size: "x-small"
  }), React.createElement("span", {
    className: "slds-assistive-text"
  }, assistiveText)), React.createElement("span", {
    className: "slds-tabs_path__title"
  }, label)));
};

PathStage.defaultProps = {
  assistiveText: null,
  className: null,
  complete: false,
  current: false,
  selected: false
};
PathStage.propTypes = process.env.NODE_ENV !== "production" ? {
  /*
   * aria assistive text
   */
  assistiveText: PropTypes.string,

  /*
   * class name
   */
  className: PropTypes.string,

  /*
   * stage is current stage
   */
  current: PropTypes.bool,

  /*
   * stage is complete
   */
  complete: PropTypes.bool,

  /*
   * string or node as label of the stage
   */
  label: PropTypes.node.isRequired,

  /*
   * function to be called on stage click
   */
  onStageClick: PropTypes.func.isRequired,

  /*
   * stage is selected
   */
  selected: PropTypes.bool
} : {};
export default PathStage;