import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.array.map";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
var Listbox = React.forwardRef(function (props, ref) {
  var children = props.children,
      className = props.className,
      label = props.label,
      rest = _objectWithoutProperties(props, ["children", "className", "label"]);

  var sldsClasses = ['slds-listbox', 'slds-listbox_horizontal', className];

  var renderChild = function renderChild(child, i) {
    if (!child) return null;
    var clonedChild = React.cloneElement(child, {
      'aria-selected': true,
      tabIndex: i === 0 ? 0 : null
    });
    return React.createElement("li", {
      key: i,
      role: "presentation"
    }, clonedChild);
  };
  /* eslint-disable jsx-a11y/role-supports-aria-props */


  return React.createElement("ul", _extends({}, rest, {
    "aria-label": label,
    "aria-orientation": "horizontal",
    className: cx(sldsClasses),
    ref: ref,
    role: "listbox"
  }), React.Children.map(children, renderChild));
});
Listbox.displayName = 'Listbox';
Listbox.defaultProps = {
  className: null,
  label: null
};
Listbox.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * child nodes
   */
  children: PropTypes.node.isRequired,

  /**
   * optional classname
   */
  className: PropTypes.string,

  /**
   * ARIA-label for listbox
   */
  label: PropTypes.string
} : {};
export default Listbox;