import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { IconButton } from '../Button';

var Pill = function Pill(props) {
  var bare = props.bare,
      className = props.className,
      icon = props.icon,
      label = props.label,
      onClose = props.onClose,
      portrait = props.portrait,
      preventCloseFocus = props.preventCloseFocus,
      title = props.title,
      url = props.url,
      rest = _objectWithoutProperties(props, ["bare", "className", "icon", "label", "onClose", "portrait", "preventCloseFocus", "title", "url"]);

  var isLinked = !!url;
  var LabelElement = isLinked ? 'a' : 'span';
  var sldsClasses = ['slds-pill', {
    'slds-pill_bare': bare
  }, className];
  var closeButton = onClose === null ? null : React.createElement(IconButton, {
    onClick: onClose,
    className: "slds-pill__remove",
    sprite: "utility",
    icon: "close",
    tabIndex: preventCloseFocus ? '-1' : null,
    title: "Remove"
  });
  return React.createElement("span", _extends({}, rest, {
    className: cx(sldsClasses)
  }), icon && React.createElement("span", {
    className: "slds-pill__icon_container"
  }, icon), portrait && React.createElement("span", {
    className: "slds-pill__icon_container"
  }, portrait), React.createElement(LabelElement, {
    href: isLinked ? url : null,
    className: "slds-pill__label",
    title: title
  }, label), closeButton);
};

Pill.defaultProps = {
  className: null,
  icon: null,
  onClose: null,
  portrait: null,
  preventCloseFocus: false,
  url: null,
  bare: false
};
Pill.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * optional Icon that receives '.pill__icon_container' class
   */
  icon: PropTypes.node,

  /**
   * content of the pill label
   */
  label: PropTypes.node.isRequired,

  /**
   * onClose handler for the pill, if left out, Pill doesn't have close button
   */
  onClose: PropTypes.func,

  /**
   * optional image that receives '.pill__icon' class
   */
  portrait: PropTypes.node,

  /**
   * If set to true, the close icon will not be focusable with the keyboard
   */
  preventCloseFocus: PropTypes.bool,

  /**
   * title of the pill label
   */
  title: PropTypes.string.isRequired,

  /**
   * optional url for the link label
   */
  url: PropTypes.string,

  /**
   * bare flavor
   */
  bare: PropTypes.bool
} : {};
export default Pill;