import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var PillContainer = function PillContainer(props) {
  var bare = props.bare,
      children = props.children,
      className = props.className,
      rest = _objectWithoutProperties(props, ["bare", "children", "className"]);

  var sldsClasses = ['slds-pill_container', {
    'slds-pill_container_bare': !!bare
  }, className];
  return React.createElement("div", _extends({}, rest, {
    className: cx(sldsClasses)
  }), children);
};

PillContainer.defaultProps = {
  bare: false,
  className: null
};
PillContainer.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * bare flavor
   */
  bare: PropTypes.bool,

  /**
   * the pill(s) passed into the component
   */
  children: PropTypes.node.isRequired,

  /**
   * class name
   */
  className: PropTypes.string
} : {};
export default PillContainer;