import "core-js/modules/es.symbol";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import { Grid } from '../Grid';
import { getClampedProgress } from './utils';
import ProgressBar from './ProgressBar';

var DescriptiveProgressBar = function DescriptiveProgressBar(_ref) {
  var completeLabel = _ref.completeLabel,
      id = _ref.id,
      label = _ref.label,
      max = _ref.max,
      min = _ref.min,
      progress = _ref.progress,
      rest = _objectWithoutProperties(_ref, ["completeLabel", "id", "label", "max", "min", "progress"]);

  return React.createElement("div", null, React.createElement(Grid, {
    className: "slds-p-bottom_x-small",
    align: "spread",
    id: id
  }, React.createElement("span", null, label), React.createElement("span", {
    "aria-hidden": "true"
  }, React.createElement("strong", null, "".concat(getClampedProgress(progress, min, max), "% ").concat(completeLabel)))), React.createElement(ProgressBar, _extends({
    "aria-labelledby": id,
    completeLabel: completeLabel,
    min: min,
    max: max,
    progress: progress
  }, rest)));
};

DescriptiveProgressBar.defaultProps = {
  completeLabel: 'Complete',
  max: 100,
  min: 0,
  progress: 0
};
DescriptiveProgressBar.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Labels the 'Complete' percentage, e.g. "25% Complete" */
  completeLabel: PropTypes.string,

  /** Ties label to ProgressBar for assistive technology */
  id: PropTypes.string.isRequired,

  /** Main label */
  label: PropTypes.node.isRequired,

  /** See ProgressBar */
  max: PropTypes.number,

  /** See ProgressBar */
  min: PropTypes.number,

  /** See ProgressBar */
  progress: PropTypes.number
} : {};
export default DescriptiveProgressBar;