import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Icon } from '../Icon';

var VerticalProgressIndicatorItem = function VerticalProgressIndicatorItem(_ref) {
  var assistiveText = _ref.assistiveText,
      className = _ref.className,
      isActive = _ref.isActive,
      isError = _ref.isError,
      isCompleted = _ref.isCompleted,
      children = _ref.children,
      isSuccess = _ref.isSuccess,
      rest = _objectWithoutProperties(_ref, ["assistiveText", "className", "isActive", "isError", "isCompleted", "children", "isSuccess"]);

  var classNames = cx('slds-progress__item', {
    'slds-is-active': isActive,
    'slds-is-completed': isCompleted || isSuccess,
    'slds-has-error': isError
  }, className);
  var icon = isError ? 'error' : 'success';
  return React.createElement("li", _extends({}, rest, {
    className: classNames
  }), !isCompleted && !isError && !isSuccess ? React.createElement("div", {
    className: "slds-progress__marker"
  }) : React.createElement(Icon, {
    size: "xx-small",
    sprite: "utility",
    icon: icon,
    className: cx('slds-progress__marker slds-progress__marker_icon', {
      'slds-progress__marker_icon-success': isSuccess
    }),
    title: assistiveText
  }), React.createElement("div", {
    className: "slds-progress__item_content slds-grid slds-grid_align-spread"
  }, children || assistiveText));
};

VerticalProgressIndicatorItem.defaultProps = {
  assistiveText: null,
  className: null,
  children: null,
  isActive: false,
  isCompleted: false,
  isError: false,
  isSuccess: false
};
VerticalProgressIndicatorItem.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Assisitive text for this step
   */
  assistiveText: PropTypes.string,

  /**
   * Step content
   */
  children: PropTypes.node,

  /**
   * Additional className
   */
  className: PropTypes.string,

  /**
   * Whether this step is active
   */
  isActive: PropTypes.bool,

  /**
   * Whether this step is complete
   */
  isCompleted: PropTypes.bool,

  /**
   * Whether this step is succeeded
   */
  isSuccess: PropTypes.bool,

  /**
   * Whether this step has an error
   */
  isError: PropTypes.bool
} : {};
export default VerticalProgressIndicatorItem;