import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Icon } from '../Icon';
import { MediaObject } from '../MediaObject'; // eslint-disable-next-line react/prop-types

var defaultIconRenderer = function defaultIconRenderer(_ref) {
  var theme = _ref.theme,
      size = _ref.size;
  return React.createElement(Icon, {
    icon: "info",
    sprite: "utility",
    size: size,
    svgClassName: theme === 'dark' ? null : 'slds-icon-text-default',
    title: "information"
  });
};

var ScopedNotification = function ScopedNotification(props) {
  var children = props.children,
      className = props.className,
      renderIcon = props.renderIcon,
      theme = props.theme,
      rest = _objectWithoutProperties(props, ["children", "className", "renderIcon", "theme"]);

  var sldsClasses = ['slds-scoped-notification', _defineProperty({}, "slds-scoped-notification_".concat(theme), theme && theme !== 'base'), className];
  return React.createElement(MediaObject, _extends({}, rest, {
    center: true,
    className: cx(sldsClasses),
    figureLeft: renderIcon({
      theme: theme,
      size: 'small'
    }),
    role: "status"
  }), children);
};

ScopedNotification.defaultProps = {
  className: null,
  renderIcon: defaultIconRenderer,
  theme: null
};
ScopedNotification.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Notification content
   */
  children: PropTypes.node.isRequired,

  /**
   * Optional className, applied to `slds-scoped-notification`
   */
  className: PropTypes.string,

  /**
   * Optional func. to render the notification icon. It returns an `<Icon />` by default. Params: `{ theme, size }`
   */
  renderIcon: PropTypes.func,

  /**
   * Notifcation theme. Passing `"base"` and `null` both maps to the default theme
   */
  theme: PropTypes.oneOf(['base', 'light', 'dark'])
} : {};
export default ScopedNotification;