import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Button } from '../Button';
import { ProgressRing } from '../Progress';
import { MediaObject } from '../MediaObject';
import { SummaryDetail } from '../SummaryDetail';

var SetupAssistantItem = function SetupAssistantItem(_ref) {
  var children = _ref.children,
      className = _ref.className,
      isOpen = _ref.isOpen,
      title = _ref.title,
      stepProgress = _ref.stepProgress,
      step = _ref.step,
      renderProgress = _ref.renderProgress,
      renderAddon = _ref.renderAddon,
      renderOpenContent = _ref.renderOpenContent,
      onOpen = _ref.onOpen,
      rest = _objectWithoutProperties(_ref, ["children", "className", "isOpen", "title", "stepProgress", "step", "renderProgress", "renderAddon", "renderOpenContent", "onOpen"]);

  var renderTitle = function renderTitle(_title) {
    return React.createElement("div", {
      className: "slds-setup-assistant__step-summary"
    }, React.createElement(MediaObject, {
      figureLeft: renderProgress({
        stepProgress: stepProgress,
        step: step
      }),
      bodyClassName: "slds-m-top_x-small",
      center: false
    }, React.createElement(MediaObject, {
      figureRight: renderAddon(),
      bodyClassName: "slds-setup-assistant__step-summary-content",
      center: false
    }, React.createElement("h3", {
      className: "slds-setup-assistant__step-summary-title slds-text-heading_small"
    }, onOpen ? React.createElement(Button, {
      flavor: null,
      className: "slds-button_reset",
      onClick: onOpen
    }, _title) : _title), React.createElement("p", null, children))));
  };

  return React.createElement("li", _extends({
    className: cx('slds-setup-assistant__item', className)
  }, rest), React.createElement("article", {
    className: "slds-setup-assistant__step"
  }, onOpen ? React.createElement(SummaryDetail, {
    containerClassName: "slds-container_fluid",
    iconButtonClassName: "slds-m-top_x-small",
    isOpen: isOpen,
    onOpen: onOpen,
    renderTitle: renderTitle,
    title: title
  }, renderOpenContent && function () {
    return React.createElement("div", {
      className: "slds-setup-assistant__step-detail"
    }, renderOpenContent({
      isOpen: isOpen
    }));
  }) : renderTitle(title)));
};

SetupAssistantItem.defaultProps = {
  children: null,
  className: null,
  stepProgress: null,
  step: null,
  isOpen: false,
  onOpen: null,
  renderAddon: function renderAddon() {
    return null;
  },
  renderOpenContent: function renderOpenContent() {
    return null;
  },
  // eslint-disable-next-line react/prop-types
  renderProgress: function renderProgress(_ref2) {
    var stepProgress = _ref2.stepProgress,
        step = _ref2.step;
    return (step || stepProgress) && React.createElement(ProgressRing, {
      progress: stepProgress,
      status: "active-step",
      size: "large"
    }, step);
  }
};
SetupAssistantItem.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Item content
   */
  children: PropTypes.node,

  /**
   * Additional className
   */
  className: PropTypes.string,

  /**
   * Defines the expanded state
   */
  isOpen: PropTypes.bool,

  /**
   * Triggered on expand icon and title click
   */
  onOpen: PropTypes.func,

  /**
   * Function that renders the expanded content. Called when isOpen is true
   */
  renderAddon: PropTypes.func,

  /**
   * Renders the expanded content
   */
  renderOpenContent: PropTypes.func,

  /**
   * Renders the progress ring
   */
  renderProgress: PropTypes.func,

  /**
   * Passed to renderProgress
   */
  step: PropTypes.element,

  /**
   * Passed to renderProgress
   */
  stepProgress: PropTypes.number,

  /**
   * Step title
   */
  title: PropTypes.string.isRequired
} : {};
export default SetupAssistantItem;