import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import SpinnerContainer from './SpinnerContainer';

var Spinner = function Spinner(props) {
  var assistiveLabel = props.assistiveLabel,
      className = props.className,
      container = props.container,
      delayed = props.delayed,
      flavor = props.flavor,
      inline = props.inline,
      size = props.size,
      rest = _objectWithoutProperties(props, ["assistiveLabel", "className", "container", "delayed", "flavor", "inline", "size"]);

  var baseClass = 'slds-spinner';
  var sldsClasses = [baseClass, _defineProperty({}, "".concat(baseClass, "_").concat(size), !!size), _defineProperty({}, "".concat(baseClass, "_").concat(flavor), !!flavor), _defineProperty({}, "".concat(baseClass, "_delayed"), !!delayed), _defineProperty({}, "".concat(baseClass, "_inline"), !!inline), className];
  var spinner = React.createElement("div", _extends({}, rest, {
    role: "status",
    className: cx(sldsClasses)
  }), React.createElement("span", {
    className: "slds-assistive-text"
  }, assistiveLabel), React.createElement("div", {
    className: "slds-spinner__dot-a"
  }), React.createElement("div", {
    className: "slds-spinner__dot-b"
  }));
  if (container) return React.createElement(SpinnerContainer, null, spinner);
  return spinner;
};

Spinner.defaultProps = {
  assistiveLabel: 'Loading',
  className: null,
  container: false,
  delayed: false,
  flavor: null,
  inline: false,
  size: 'medium'
};
Spinner.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Label that will be shown on hover
   */
  assistiveLabel: PropTypes.string,

  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * convenience prop to wrap Spinner in SpinnerContainer
   */
  container: PropTypes.bool,

  /**
   * Adds a 300ms start delay
   */
  delayed: PropTypes.bool,

  /**
   * Flavor. Can be either 'brand' or 'inverse'
   */
  flavor: PropTypes.oneOf(['brand', 'inverse']),

  /**
   * inline variation
   */
  inline: PropTypes.bool,

  /**
   * spinner sizes: xx-small, x-small, small, medium, large
   */
  size: PropTypes.oneOf(['xx-small', 'x-small', 'small', 'medium', 'large'])
} : {};
export default Spinner;