import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";
import "core-js/modules/es.string.fixed";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var SpinnerContainer = function SpinnerContainer(props) {
  var className = props.className,
      fixed = props.fixed,
      children = props.children,
      rest = _objectWithoutProperties(props, ["className", "fixed", "children"]);

  var sldsClasses = ['slds-spinner_container', {
    'slds-is-fixed': fixed
  }, className];
  return React.createElement("div", _extends({}, rest, {
    className: cx(sldsClasses)
  }), children);
};

SpinnerContainer.defaultProps = {
  className: null,
  children: null,
  fixed: false
};
SpinnerContainer.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * fixed positioning by adding the .slds-is-fixed class to the container,
   * needed if dynamically loading portions of component after spinner is showing
   */
  fixed: PropTypes.bool,

  /**
   * children should be one instance of Spinner
   */
  children: PropTypes.node
} : {};
export default SpinnerContainer;