import "core-js/modules/es.symbol";
import "core-js/modules/es.symbol.description";
import "core-js/modules/es.symbol.iterator";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.object.get-prototype-of";
import "core-js/modules/es.object.set-prototype-of";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.string.iterator";
import "core-js/modules/web.dom-collections.iterator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { ToggleButton, TOGGLE_BUTTON_WIDTH } from './ToggleButton';
var FULL_HEIGHT = {
  height: '100%'
};
var DETAIL_VIEW_STYLE = {
  marginLeft: TOGGLE_BUTTON_WIDTH
};
export var ControlledSplitView =
/*#__PURE__*/
function (_Component) {
  _inherits(ControlledSplitView, _Component);

  function ControlledSplitView() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ControlledSplitView);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ControlledSplitView)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "getMasterViewId", function () {
      var id = _this.props.id;
      return "master_view_".concat(id);
    });

    _defineProperty(_assertThisInitialized(_this), "toggle", function () {
      var _this$props = _this.props,
          isOpen = _this$props.isOpen,
          onOpen = _this$props.onOpen,
          onClose = _this$props.onClose;

      if (isOpen) {
        onClose();
      } else {
        onOpen();
      }
    });

    return _this;
  }

  _createClass(ControlledSplitView, [{
    key: "renderMasterView",
    value: function renderMasterView() {
      var _this$props2 = this.props,
          isOpen = _this$props2.isOpen,
          master = _this$props2.master;
      return isOpen && React.createElement("article", {
        id: this.getMasterViewId(),
        className: "slds-split-view slds-grid slds-grid_vertical slds-grow slds-scrollable_none"
      }, master);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          assistiveTextOpen = _this$props3.assistiveTextOpen,
          assistiveTextClose = _this$props3.assistiveTextClose,
          className = _this$props3.className,
          detail = _this$props3.detail,
          id = _this$props3.id,
          isOpen = _this$props3.isOpen,
          masterMaxWidth = _this$props3.masterMaxWidth,
          masterMinWidth = _this$props3.masterMinWidth;
      var masterStyle = isOpen ? {
        maxWidth: masterMaxWidth,
        minWidth: masterMinWidth
      } : null;
      return React.createElement("div", {
        id: id,
        className: cx('slds-grid', className),
        style: FULL_HEIGHT
      }, React.createElement("div", {
        style: masterStyle,
        className: cx('slds-split-view_container', {
          'slds-is-open': isOpen
        }, {
          'slds-is-closed': !isOpen
        })
      }, React.createElement(ToggleButton, {
        ariaControls: this.getMasterViewId(),
        assistiveTextOpen: assistiveTextOpen,
        assistiveTextClose: assistiveTextClose,
        isOpen: isOpen,
        onClick: this.toggle
      }), this.renderMasterView()), React.createElement("div", {
        style: DETAIL_VIEW_STYLE,
        className: "slds-grow slds-scrollable_y"
      }, detail));
    }
  }]);

  return ControlledSplitView;
}(Component);

_defineProperty(ControlledSplitView, "defaultProps", {
  assistiveTextOpen: '',
  assistiveTextClose: '',
  className: null,
  masterMaxWidth: '20rem',
  masterMinWidth: '20rem'
});

ControlledSplitView.propTypes = process.env.NODE_ENV !== "production" ? {
  assistiveTextOpen: PropTypes.string,
  assistiveTextClose: PropTypes.string,
  className: PropTypes.string,
  detail: PropTypes.node.isRequired,
  id: PropTypes.string.isRequired,
  master: PropTypes.node.isRequired,
  masterMaxWidth: PropTypes.string,
  masterMinWidth: PropTypes.string,
  onOpen: PropTypes.func.isRequired,
  onClose: PropTypes.func.isRequired,
  isOpen: PropTypes.bool.isRequired
} : {};