import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { IconSVG } from '../Icon';
export var TOGGLE_BUTTON_WIDTH = '0.75rem';
var NO_SHADOW = {
  boxShadow: 'none'
};
export var ToggleButton = function ToggleButton(_ref) {
  var ariaControls = _ref.ariaControls,
      assistiveTextOpen = _ref.assistiveTextOpen,
      assistiveTextClose = _ref.assistiveTextClose,
      isOpen = _ref.isOpen,
      onClick = _ref.onClick;
  var assistiveText = isOpen ? assistiveTextOpen : assistiveTextClose;
  var buttonClassName = cx('slds-button slds-button_icon slds-split-view__toggle-button', {
    'slds-is-open': isOpen
  });
  return React.createElement("button", {
    "aria-controls": ariaControls,
    "aria-expanded": isOpen,
    className: buttonClassName,
    onClick: onClick,
    style: NO_SHADOW,
    title: assistiveText,
    type: "button"
  }, React.createElement(IconSVG, {
    className: "slds-button__icon slds-button__icon_x-small"
    /* SLDS applies rotate tranform to this icon,
       so we don't need to change icon itself
     */
    ,
    icon: "left",
    isButton: true,
    sprite: "utility"
  }), React.createElement("span", {
    className: "slds-assistive-text"
  }, assistiveText));
};
ToggleButton.propTypes = process.env.NODE_ENV !== "production" ? {
  ariaControls: PropTypes.string.isRequired,
  assistiveTextOpen: PropTypes.string.isRequired,
  assistiveTextClose: PropTypes.string.isRequired,
  isOpen: PropTypes.bool.isRequired,
  onClick: PropTypes.func.isRequired
} : {};