import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { applyDecorators, decoratorProp } from '../../utils';

var Table = function Table(props) {
  var children = props.children,
      className = props.className,
      flavor = props.flavor,
      stickyHeader = props.stickyHeader,
      variation = props.variation,
      rest = _objectWithoutProperties(props, ["children", "className", "flavor", "stickyHeader", "variation"]);

  var sldsClasses = ['slds-table', 'slds-table_cell-buffer', className, applyDecorators(flavor, 'table'), applyDecorators(variation)];
  return React.createElement("table", _extends({}, rest, {
    className: cx(sldsClasses)
  }), children);
}; // https://github.com/oliviertassinari/babel-plugin-transform-react-remove-prop-types#is-it-safe


export var propTypes = {
  /**
   * table content
   */
  children: PropTypes.node,

  /**
   * class name
   */
  className: PropTypes.string,

  /**
   * flavor: array of flavors, you can also provide a single flavor string.
   * Flavors: bordered, col-bordered, striped, fixed-layout
   */
  flavor: decoratorProp(['bordered', 'col-bordered', 'striped', 'fixed-layout', 'header-hidden']),

  /**
   * Make table header stick to the top
   */
  stickyHeader: PropTypes.bool,

  /**
   * variation: array of variations, you can also provide a single variation string.
   * Variations: no-row-hover, max-medium-table_stacked,
   max-medium-table_stacked-horizontal
   */
  variation: decoratorProp(['no-row-hover', 'max-medium-table_stacked', 'max-medium-table_stacked-horizontal'])
};
Table.defaultProps = {
  children: null,
  className: null,
  flavor: [],
  stickyHeader: false,
  variation: []
};
Table.propTypes = process.env.NODE_ENV !== "production" ? propTypes : {};
export default Table;