import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { getAriaLabel, getTabsClass } from './utils';

var Tab = function Tab(props) {
  var children = props.children,
      className = props.className,
      id = props.id,
      isActive = props.isActive,
      scoped = props.scoped,
      _ = props.renderTitle,
      __ = props.title,
      rest = _objectWithoutProperties(props, ["children", "className", "id", "isActive", "scoped", "renderTitle", "title"]);

  return React.createElement("div", _extends({}, rest, {
    "aria-labelledby": getAriaLabel(id),
    className: cx(getTabsClass('__content', scoped), isActive ? 'slds-show' : 'slds-hide'),
    id: id,
    role: "tabpanel"
  }), isActive === null ? null : children);
};

Tab.defaultProps = {
  className: null,
  isActive: false,
  renderTitle: null,
  scoped: false
};
Tab.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Tab content
   */
  children: PropTypes.node.isRequired,

  /**
   * Additional classes
   */
  className: PropTypes.string,

  /**
   * Unique id, used to reference navigation
   */
  id: PropTypes.string.isRequired,

  /**
   * Function to render `title`. Called with ({ id, isActive, isFocused, title})
   */
  renderTitle: PropTypes.func,

  /**
   * Title in Navigation
   */
  title: PropTypes.string.isRequired,

  /**
   * (PRIVATE) Set by parent Tabs
   */
  isActive: PropTypes.bool,

  /**
   * (PRIVATE) Set by parent Tabs
   */
  scoped: PropTypes.bool
} : {};
export default Tab;