import "core-js/modules/es.symbol";
import "core-js/modules/es.symbol.description";
import "core-js/modules/es.symbol.iterator";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.array.join";
import "core-js/modules/es.array.map";
import "core-js/modules/es.object.get-prototype-of";
import "core-js/modules/es.object.set-prototype-of";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.regexp.exec";
import "core-js/modules/es.string.ends-with";
import "core-js/modules/es.string.iterator";
import "core-js/modules/es.string.split";
import "core-js/modules/web.dom-collections.iterator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { PureComponent } from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Manager, Reference, Popper } from 'react-popper';
var ELEMENT_STYLE = {
  display: 'inline-block'
};
export var POSITIONS = ['top', 'top-start', 'top-end', 'left', 'right', 'bottom', 'bottom-start', 'bottom-end'];

var getNubbin = function getNubbin(position) {
  var nubbinMap = {
    bottom: 'top',
    left: 'right',
    right: 'left',
    top: 'bottom',
    end: 'right',
    start: 'left'
  };
  return position.split('-').map(function (x) {
    return nubbinMap[x];
  }).join('-');
};

var getPopperProps = function getPopperProps(position, customOffset) {
  var offset;

  if (!customOffset) {
    if (position === 'left' || position === 'right') {
      offset = '0, 16';
    } else if (position.endsWith('start')) {
      offset = '-16, 16';
    } else if (position.endsWith('end')) {
      offset = '16, 16';
    } else {
      offset = '0, 16';
    }
  } else {
    offset = customOffset;
  }

  return {
    placement: position,
    positionFixed: true,
    modifiers: {
      offset: {
        enabled: true,
        offset: offset
      },
      flip: {
        enabled: true,
        boundariesElement: 'window',
        padding: 0
      },
      preventOverflow: {
        enabled: true,
        boundariesElement: 'window',
        padding: 0
      }
    }
  };
};

var ControlledTooltip =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(ControlledTooltip, _PureComponent);

  function ControlledTooltip() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ControlledTooltip);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ControlledTooltip)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "renderPopper", function () {
      var _this$props = _this.props,
          className = _this$props.className,
          id = _this$props.id,
          isOpen = _this$props.isOpen,
          offset = _this$props.offset,
          position = _this$props.position,
          renderTitle = _this$props.renderTitle,
          title = _this$props.title;
      var popoverClasses = cx(['slds-popover', 'slds-popover_tooltip', "slds-nubbin_".concat(getNubbin(position)), className]);
      return React.createElement(Popper, getPopperProps(position, offset), function (_ref) {
        var placement = _ref.placement,
            ref = _ref.ref,
            style = _ref.style;
        if (!isOpen) return null;
        return React.createElement("div", {
          className: popoverClasses,
          id: id,
          ref: ref,
          role: "tooltip",
          style: style,
          "data-placement": placement
        }, React.createElement("div", {
          className: "slds-popover__body"
        }, renderTitle ? renderTitle(title) : title));
      });
    });

    _defineProperty(_assertThisInitialized(_this), "render", function () {
      var _this$props2 = _this.props,
          children = _this$props2.children,
          id = _this$props2.id,
          onOpen = _this$props2.onOpen,
          onClose = _this$props2.onClose,
          portalSelector = _this$props2.portalSelector;
      var popper = portalSelector ? ReactDOM.createPortal(_this.renderPopper(), document.querySelector(portalSelector)) : _this.renderPopper();
      return React.createElement(Manager, null, React.createElement(Reference, null, function (_ref2) {
        var ref = _ref2.ref;
        return React.createElement("div", {
          "aria-describedby": id,
          onMouseEnter: onOpen,
          onFocus: onOpen,
          onMouseLeave: onClose,
          onBlur: onClose,
          ref: ref,
          style: ELEMENT_STYLE
        }, children);
      }), popper);
    });

    return _this;
  }

  return ControlledTooltip;
}(PureComponent);

ControlledTooltip.defaultProps = {
  className: null,
  isOpen: true,
  offset: null,
  onOpen: null,
  onClose: null,
  portalSelector: null,
  position: 'top-start',
  renderTitle: null
};
ControlledTooltip.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Will be wrapped with a div referencing the tooltip
   */
  children: PropTypes.node.isRequired,

  /**
   * Optional className applied to the slds-popover element
   */
  className: PropTypes.string,

  /**
   * Id linking the popover to the reference
   */
  id: PropTypes.string.isRequired,

  /**
   * Controls whether the popover is visible
   */
  isOpen: PropTypes.bool,

  /**
   * Allows you to set popper offsets manually
   * Usage: https://popper.js.org/popper-documentation.html#modifiers..offset
   */
  offset: PropTypes.string,

  /**
   * Function toggled when hovering or focussing the reference
   */
  onOpen: PropTypes.func,

  /**
   * Function toggled when blurring the reference (when open)
   */
  onClose: PropTypes.func,

  /**
   * If set, use element with this selector as Portal for Popper
   */
  portalSelector: PropTypes.string,

  /**
   * Position of the popover. The popover will move if it hits a window boundary
   */
  position: PropTypes.oneOf(POSITIONS),

  /**
   * Function that renders `title` if set. Is passed the `title` prop
   */
  renderTitle: PropTypes.func,

  /**
   * Static title property
   */
  title: PropTypes.oneOfType([PropTypes.element, PropTypes.string]).isRequired
} : {};
export default ControlledTooltip;