import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.array.map";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';

var VerticalNavigationSection = function VerticalNavigationSection(props) {
  var children = props.children,
      className = props.className,
      id = props.id,
      title = props.title,
      rest = _objectWithoutProperties(props, ["children", "className", "id", "title"]);

  var sldsClasses = ['slds-nav-vertical__section', className];

  var renderChild = function renderChild(child) {
    return React.cloneElement(child, {
      'aria-describedby': id
    });
  };

  return React.createElement("div", _extends({}, rest, {
    className: cx(sldsClasses)
  }), React.createElement("h2", {
    className: "slds-nav-vertical__title",
    id: id
  }, title), React.createElement("ul", null, React.Children.map(children, renderChild)));
};

VerticalNavigationSection.defaultProps = {
  className: null
};
VerticalNavigationSection.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * One or more VerticalNavigationItem
   */
  children: PropTypes.node.isRequired,

  /**
   * Classname to be applied to the parent
   */
  className: PropTypes.string,

  /**
   * Id of title, will relate children to parent
   */
  id: PropTypes.string.isRequired,

  /**
   * Section title
   */
  title: PropTypes.string.isRequired
} : {};
export default VerticalNavigationSection;