import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import cx from 'classnames';
import PropTypes from 'prop-types';
import { InputRaw } from '../Form';

var VisualPicker = function VisualPicker(props) {
  var caption = props.caption,
      children = props.children,
      className = props.className,
      disabled = props.disabled,
      id = props.id,
      inputProps = props.inputProps,
      size = props.size,
      type = props.type,
      rest = _objectWithoutProperties(props, ["caption", "children", "className", "disabled", "id", "inputProps", "size", "type"]);

  var sldsClasses = ['slds-visual-picker', "slds-visual-picker_".concat(size), className];
  return React.createElement("div", _extends({}, rest, {
    className: cx(sldsClasses)
  }), React.createElement(InputRaw, _extends({}, inputProps, {
    disabled: disabled,
    id: id,
    type: type,
    value: id,
    name: "options"
  })), React.createElement("label", {
    htmlFor: id
  }, children, caption));
};

VisualPicker.defaultProps = {
  caption: null,
  className: null,
  disabled: false,
  inputProps: {},
  size: 'medium',
  type: 'radio'
};
VisualPicker.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Caption element rendered underneath the tile. Should be `VisualPickerTileCaption`
   */
  caption: PropTypes.element,

  /**
   * Tile content. Should either be: `VisualPickerText` or `VisualPickerIcon`
   */
  children: PropTypes.node.isRequired,

  /**
   * Optional className applied to wrapper `div`
   */
  className: PropTypes.string,

  /**
   * Disabled state for input
   */
  disabled: PropTypes.bool,

  /**
   * Input id
   */
  id: PropTypes.string.isRequired,

  /**
   * Additional input props. `name`, `value`, `type` and `id` are overwritten
   */
  inputProps: PropTypes.object,

  /**
   * Tile size
   */
  size: PropTypes.oneOf(['medium', 'large']),

  /**
   * Input type. Should be the same for all tiles in one `VisualPickerContainer`
   */
  type: PropTypes.oneOf(['radio', 'checkbox'])
} : {};
export default VisualPicker;