import React from 'react';
import PropTypes from 'prop-types';

var VisualPickerTileCaption = function VisualPickerTileCaption(_ref) {
  var children = _ref.children,
      title = _ref.title;
  return React.createElement("span", {
    className: "slds-visual-picker__body"
  }, title && React.createElement("span", {
    className: "slds-text-heading_small"
  }, title), React.createElement("span", {
    className: "slds-text-title"
  }, children));
};

VisualPickerTileCaption.defaultProps = {
  title: null
};
VisualPickerTileCaption.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Text content of the caption
   */
  children: PropTypes.node.isRequired,

  /**
   * Optional title rendered as `heading_small`
   */
  title: PropTypes.string
} : {};
export default VisualPickerTileCaption;