import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Icon } from '../Icon';

var VisualPickerTileIcon = function VisualPickerTileIcon(_ref) {
  var className = _ref.className,
      icon = _ref.icon,
      sprite = _ref.sprite;
  var figureClasses = ['slds-visual-picker__figure', 'slds-visual-picker__icon', {
    'slds-visual-picker__text': false
  }, 'slds-align_absolute-center', className];
  return React.createElement("span", {
    className: cx(figureClasses)
  }, React.createElement("span", {
    className: "slds-is-selected"
  }, React.createElement(Icon, {
    icon: "check",
    size: "large",
    sprite: "action"
  })), React.createElement("span", {
    className: "slds-is-not-selected"
  }, React.createElement(Icon, {
    icon: icon,
    sprite: sprite,
    svgClassName: sprite === 'utility' ? 'slds-icon-text-default' : null,
    size: "large"
  })));
};

VisualPickerTileIcon.defaultProps = {
  className: null
};
VisualPickerTileIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Optional className, applied to `slds-visual-picker__figure`
   */
  className: PropTypes.string,

  /**
   * Icon name
   */
  icon: PropTypes.string.isRequired,

  /**
   * Sprite name
   */
  sprite: PropTypes.string.isRequired
} : {};
export default VisualPickerTileIcon;