import React, { Fragment } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { Icon } from '../Icon';

var VisualPickerTileText = function VisualPickerTileText(_ref) {
  var className = _ref.className,
      children = _ref.children,
      title = _ref.title;
  var figureClasses = ['slds-visual-picker__figure', 'slds-visual-picker__text', 'slds-align_absolute-center', className];
  return React.createElement(Fragment, null, React.createElement("span", {
    className: cx(figureClasses)
  }, React.createElement("span", null, React.createElement("span", {
    className: "slds-text-heading_large"
  }, title), children && React.createElement("span", {
    className: "slds-text-title"
  }, children))), React.createElement(Icon, {
    className: "slds-visual-picker__text-check",
    sprite: "utility",
    icon: "check",
    size: "x-small"
  }));
};

VisualPickerTileText.defaultProps = {
  className: null,
  children: null
};
VisualPickerTileText.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Optional className, applied to `slds-visual-picker__figure`
   */
  className: PropTypes.string,

  /**
   * Text content renderes as `text-title`
   */
  children: PropTypes.node,

  /**
   * Title renderes as `heading_large`
   */
  title: PropTypes.string.isRequired
} : {};
export default VisualPickerTileText;