import "core-js/modules/es.symbol";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.keys";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import { Modal, ModalContent } from '../Modal';
import WelcomeMatContent from './components/WelcomeMatContent';

var WelcomeMat = function WelcomeMat(_ref) {
  var id = _ref.id,
      isOpen = _ref.isOpen,
      onClose = _ref.onClose,
      rest = _objectWithoutProperties(_ref, ["id", "isOpen", "onClose"]);

  return React.createElement(Modal, {
    id: id,
    open: isOpen,
    onClose: onClose,
    size: "small"
  }, React.createElement(ModalContent, {
    collapsePadding: true
  }, React.createElement(WelcomeMatContent, _extends({}, rest, {
    id: id,
    onClose: onClose
  }))));
};

WelcomeMat.defaultProps = {
  isOpen: false
};
WelcomeMat.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Identifier for `Modal`, ties to `WelcomeMat` title
   */
  id: PropTypes.string.isRequired,

  /**
   * Controls `isOpen` state of the underlying `Modal`
   */
  isOpen: PropTypes.bool,

  /**
   * Passed to `Modal` & `WelcomeMatContent`
   */
  onClose: PropTypes.func.isRequired
} : {};
export default WelcomeMat;