import "core-js/modules/es.symbol";
import "core-js/modules/es.symbol.description";
import "core-js/modules/es.symbol.iterator";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.find";
import "core-js/modules/es.array.index-of";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.array.map";
import "core-js/modules/es.object.assign";
import "core-js/modules/es.object.get-prototype-of";
import "core-js/modules/es.object.keys";
import "core-js/modules/es.object.set-prototype-of";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.string.iterator";
import "core-js/modules/web.dom-collections.iterator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { stepType } from '../constants';
import { Column, Grid } from '../../Grid';
import { WelcomeMatStep } from './WelcomeMatStep';

var WelcomeMatContent =
/*#__PURE__*/
function (_Component) {
  _inherits(WelcomeMatContent, _Component);

  function WelcomeMatContent() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, WelcomeMatContent);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(WelcomeMatContent)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "onComplete", function (evt) {
      var targetId = evt.currentTarget.dataset.targetId;
      var _this$props = _this.props,
          onCompleteStep = _this$props.onCompleteStep,
          steps = _this$props.steps; // `stepId` can be a `number` while targetId will be a `string`, need to cast

      var step = steps.find(function (_ref) {
        var stepId = _ref.id;
        return "".concat(stepId) === "".concat(targetId);
      });
      return onCompleteStep({
        id: step.id,
        step: step
      });
    });

    return _this;
  }

  _createClass(WelcomeMatContent, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          customStyle = _this$props2.customStyle,
          description = _this$props2.description,
          id = _this$props2.id,
          isInfoOnly = _this$props2.isInfoOnly,
          onClose = _this$props2.onClose,
          onCompleteStep = _this$props2.onCompleteStep,
          renderAction = _this$props2.renderAction,
          renderDismiss = _this$props2.renderDismiss,
          renderProgress = _this$props2.renderProgress,
          steps = _this$props2.steps,
          title = _this$props2.title,
          rest = _objectWithoutProperties(_this$props2, ["customStyle", "description", "id", "isInfoOnly", "onClose", "onCompleteStep", "renderAction", "renderDismiss", "renderProgress", "steps", "title"]);

      var isSplash = steps == null;
      var sldsClasses = ['slds-welcome-mat', {
        'slds-welcome-mat_splash': isSplash
      }];
      return React.createElement("div", _extends({}, rest, {
        className: cx(sldsClasses)
      }), React.createElement(Grid, {
        className: "slds-welcome-mat__content"
      }, React.createElement(Column, {
        className: "slds-welcome-mat__info",
        omitCol: true,
        sizeOf: isSplash ? '1-1' : '1-2',
        style: customStyle
      }, React.createElement("div", {
        className: "slds-welcome-mat__info-content"
      }, React.createElement("h2", {
        id: "".concat(id, "-label"),
        className: "slds-welcome-mat__info-title"
      }, title), React.createElement("div", {
        className: "slds-welcome-mat__info-description slds-text-longform"
      }, description), renderProgress && !isSplash && renderProgress({
        steps: steps
      }), (renderAction || renderDismiss) && React.createElement("div", {
        className: "slds-welcome-mat__info-actions"
      }, renderAction && renderAction({
        onClose: onClose,
        steps: steps
      }), renderDismiss && (renderAction ? React.createElement("div", {
        className: "slds-m-top_large"
      }, renderDismiss({
        id: id,
        onClose: onClose,
        steps: steps
      })) : renderDismiss({
        id: id,
        onClose: onClose,
        steps: steps
      }))))), !isSplash && React.createElement(Column, {
        as: "ul",
        className: cx(['slds-welcome-mat__tiles', {
          'slds-welcome-mat__tiles_info-only': isInfoOnly
        }]),
        omitCol: true,
        size: "1-of-2"
      }, steps.map(function (step) {
        return React.createElement(WelcomeMatStep, {
          key: "".concat(id, "-").concat(step.id),
          isInfoOnly: isInfoOnly,
          onComplete: _this2.onComplete,
          step: step
        });
      }))));
    }
  }]);

  return WelcomeMatContent;
}(Component);

_defineProperty(WelcomeMatContent, "defaultProps", {
  customStyle: null,
  isInfoOnly: false,
  onCompleteStep: null,
  renderAction: null,
  renderDismiss: null,
  renderProgress: null,
  steps: undefined
});

WelcomeMatContent.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Custom styles applied to `.welcome-mat__info`. Use this to apply custom backgrounds.
   * Default styles can be found at https://git.io/JvUdU
   */
  customStyle: PropTypes.object,

  /**
   * Description, rendered below `title`. Should return a `p`
   */
  description: PropTypes.node.isRequired,

  /**
   * Identifier for this `WelcomeMatContent` instance
   */
  id: PropTypes.string.isRequired,

  /**
   * When this flag is set, `isComplete` is ignored for steps
   */
  isInfoOnly: PropTypes.bool,

  /**
   * Passed to some actions that may close this `WelcomeMat`
   */
  onClose: PropTypes.func.isRequired,

  /**
   * Handler injected when rendering steps. Called with `({ id, step })`.
   * Note: This is also called for completed steps, a handler will need to check for `step.isCompleted`
   */
  onCompleteStep: PropTypes.func,

  /**
   * Renders call-to-action beneath description. Called with `({ onClose, steps })`
   */
  renderAction: PropTypes.func,

  /**
   * Should render a `Checkbox` or similar. Called with `({ onClose, steps })`
   */
  renderDismiss: PropTypes.func,

  /**
   * Should render a `WelcomeMatProgress` element. Called with `({ steps })`
   */
  renderProgress: PropTypes.func,

  /**
   * Steps as array. If not set or `undefined/null`, the "Splash" variant will be assumed
   */
  steps: PropTypes.arrayOf(stepType),

  /**
   * Title element
   */
  title: PropTypes.node.isRequired
} : {};
export default WelcomeMatContent;