import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.filter";
import React from 'react';
import PropTypes from 'prop-types';
import { ProgressBar } from '../../Progress';
import { stepType } from '../constants';

var WelcomeMatProgress = function WelcomeMatProgress(_ref) {
  var steps = _ref.steps;
  var len = steps.length;
  if (len === 0) return null;
  var completedSteps = steps.filter(function (_ref2) {
    var isCompleted = _ref2.isCompleted;
    return isCompleted;
  }).length;
  return React.createElement("div", {
    className: "slds-welcome-mat__info-progress"
  }, React.createElement("p", null, React.createElement("strong", null, "".concat(completedSteps, "/").concat(len, " completed"))), React.createElement(ProgressBar, {
    circular: true,
    min: 0,
    max: len,
    success: true,
    progress: completedSteps
  }));
};

WelcomeMatProgress.propTypes = process.env.NODE_ENV !== "production" ? {
  steps: PropTypes.arrayOf(stepType).isRequired
} : {};
export default WelcomeMatProgress;