import "core-js/modules/es.symbol";
import "core-js/modules/es.symbol.description";
import "core-js/modules/es.symbol.iterator";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.from";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.date.to-string";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.regexp.to-string";
import "core-js/modules/es.string.iterator";
import "core-js/modules/web.dom-collections.iterator";

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

/* eslint-disable no-script-url */
import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { stepType } from '../constants';
import { Icon } from '../../Icon';
import { MediaObject } from '../../MediaObject';

var renderFigure = function renderFigure(figure, classes) {
  return React.createElement("div", {
    className: cx.apply(void 0, _toConsumableArray(classes).concat(['slds-media__figure_fixed-width', 'slds-align_absolute-center']))
  }, figure);
};

export var WelcomeMatStep = function WelcomeMatStep(_ref) {
  var isInfoOnly = _ref.isInfoOnly,
      onComplete = _ref.onComplete,
      step = _ref.step;
  var description = step.description,
      icon = step.icon,
      id = step.id,
      isCompleted = step.isCompleted,
      sprite = step.sprite,
      title = step.title;
  var isComplete = !isInfoOnly && isCompleted;
  var sldsClasses = ['slds-welcome-mat__tile', {
    'slds-welcome-mat__tile_info-only': isInfoOnly
  }, {
    'slds-welcome-mat__tile_complete': isComplete
  }];
  var iconEl = React.createElement(Icon, {
    sprite: sprite,
    icon: icon,
    svgClassName: "slds-icon-text-default"
  });
  return React.createElement("li", {
    className: cx(sldsClasses)
  }, React.createElement(MediaObject, {
    as: isInfoOnly ? 'div' : 'a',
    className: isInfoOnly ? null : 'slds-box slds-box_link',
    href: isInfoOnly ? undefined : 'javascript:void(0)',
    center: false,
    "data-target-id": id,
    onClick: isInfoOnly ? null : onComplete,
    responsive: false,
    renderFigureLeft: renderFigure,
    figureLeft: React.createElement("div", {
      className: "slds-welcome-mat__tile-figure"
    }, isComplete ? React.createElement("div", {
      className: "slds-welcome-mat__tile-icon-container"
    }, iconEl, React.createElement(Icon, {
      className: "slds-icon_container_circle",
      icon: "check",
      sprite: "action",
      svgClassName: "slds-welcome-mat__icon-check"
    })) : iconEl)
  }, React.createElement("div", {
    className: "slds-welcome-mat__tile-body"
  }, React.createElement("h3", {
    className: "slds-welcome-mat__tile-title"
  }, title), React.createElement("p", {
    className: "slds-welcome-mat__tile-description"
  }, description))));
};
WelcomeMatStep.defaultProps = {
  onComplete: null
};
WelcomeMatStep.propTypes = process.env.NODE_ENV !== "production" ? {
  isInfoOnly: PropTypes.bool.isRequired,
  onComplete: PropTypes.func,
  step: stepType.isRequired
} : {};